
(function(){ // Import GET Vars
   document.$_GET = [];
   var urlHalves = String(document.location).split('?');
   if(urlHalves[1]){
      var urlVars = urlHalves[1].split('&');
      for(var i=0; i<=(urlVars.length); i++){
         if(urlVars[i]){
            var urlVarPair = urlVars[i].split('=');
            document.$_GET[urlVarPair[0]] = urlVarPair[1];
         }
      }
   }
})();


function CalendarControl() {

  var calendarId = 'CalendarControl';
	
	var	selectedMonth = 0;
	var	selectedDay = 0;
	var selectedYear = 0;
	var currentMonth = 0;
	var currentDay = 0;
	var currentYear = 0;	
	
	var selectedMode = parseInt(document.$_GET['sel_mode'] == null ? 1 : document.$_GET['sel_mode']);	
	var selectedIndex = document.$_GET['sel_index'] == null ? 0 : document.$_GET['sel_index'];
	
	if(document.$_GET['from'] != null)
	{
		var datum_from = new Date();
		datum_from.setTime(document.$_GET['from'] * 1000);
		selectedMonth = datum_from.getMonth() + 1;
		selectedDay = datum_from.getDate();
		selectedYear = datum_from.getFullYear();
	}

	if(document.$_GET['current'] != null)
	{
		var datum_from = new Date();
		datum_from.setTime(document.$_GET['current'] * 1000);
		currentMonth = datum_from.getMonth() + 1;
		currentDay = datum_from.getDate();
		currentYear = datum_from.getFullYear();
	}	
	
	var sel_day_count = 1;

	var sub_opt = document.$_GET['sub_opt'] == null ? "latency" : document.$_GET['sub_opt'];

  var months = ['January','February','March','April','May','June','July','August','September','October','November','December'];

  function getDaysInMonth(year, month) {
    return [31,((!(year % 4 ) && ( (year % 100 ) || !( year % 400 ) ))?29:28),31,30,31,30,31,31,30,31,30,31][month-1];
  }

  function getDayOfWeek(year, month, day) {
    var date = new Date(year,month-1,day - 1)
    return date.getDay();
  }

  this.setDate = setDate;
  function setDate(mode, year, month, day, index) {
 		selectedMode = mode;
		selectedYear = year;
		selectedMonth = month;
		selectedDay = day;
		selectedIndex = index;
    calendar = document.getElementById(calendarId);
    calendar.innerHTML = calendarDrawTable();
    return;
  }

  this.changeMonth = changeMonth;
  function changeMonth(change) {
    currentMonth += change;
    if(currentMonth > 12) {
      currentMonth = 1;
      currentYear++;
    } else if(currentMonth < 1) {
      currentMonth = 12;
      currentYear--;
    }

		//selectedMonth = currentMonth;
		//selectedYear = currentYear;		
		selectedMode = 0;
    calendar = document.getElementById(calendarId);
    calendar.innerHTML = calendarDrawTable();
  }

  this.changeYear = changeYear;
  function changeYear(change) {
    currentYear += change;
		//selectedYear = currentYear;
		selectedMode = 0;
    calendar = document.getElementById(calendarId);
    calendar.innerHTML = calendarDrawTable();
  }

  function getCurrentYear() {
    var year = new Date().getYear();
    if(year < 1900) year += 1900;
    return year;
  }

  function getCurrentMonth() {
    return new Date().getMonth() + 1;
  } 

  function getCurrentDay() {
    return new Date().getDate();
  }

	function getCurrentWeek(year, month, date, dayinweek) {
		var thursday = new Date(year, month, date + 4 - (dayinweek || 7));
		return Math.floor((thursday - new Date(thursday.getFullYear(), 0, 1)) / (7 * 24 * 60 * 60 * 1000)) + 1;
	}
	

  function calendarDrawTable() {

    var dayOfMonth = 1;
		var day = 1;
    var validDay = 0;
    var startDayOfWeek = getDayOfWeek(currentYear, currentMonth, dayOfMonth);
    var daysInMonth = getDaysInMonth(currentYear, currentMonth);
		var weekOfYear = getCurrentWeek(currentYear, currentMonth-1, day, startDayOfWeek);

		var days = new Array(42);
		var month = new Array(42);
		var year = new Array(42);
		var mode = new Array(42);
		
		if(startDayOfWeek > 0)
		{	
			for(var i = 1;i <= daysInMonth;i++)
			{
				days[i + startDayOfWeek - 1] = i;
				month[i + startDayOfWeek - 1] = currentMonth;
				year[i + startDayOfWeek - 1] = currentYear;				
				mode[i + startDayOfWeek - 1] = 1;
			}
			
			var lastmonthDays = getDaysInMonth((currentMonth > 1) ? currentYear : (currentYear - 1) , (currentMonth > 1) ? (currentMonth - 1) : 12);
			for(var i = 0;i < startDayOfWeek;i++)
			{
				days[startDayOfWeek - i - 1] = lastmonthDays;
				month[startDayOfWeek - i - 1] = (currentMonth > 1) ? (currentMonth - 1) : 12;
				year[startDayOfWeek - i - 1] = (currentMonth > 1) ? currentYear : (currentYear - 1);				
				mode[startDayOfWeek - i - 1] = 2;
				lastmonthDays--;
			}
			
			var nextmonthDays = 1;
			for(var i = daysInMonth + startDayOfWeek;i <= 42;i++)
			{
				days[i] = nextmonthDays;
				month[i] = (currentMonth < 12) ? (currentMonth + 1) : 1;
				year[i] = (currentMonth < 12) ? currentYear : (currentYear + 1);					
				mode[i] = 2;
				nextmonthDays++;
			}
		}
		else
		{
			for(var i = 0;i <= daysInMonth;i++)
			{
				days[i] = i + 1;
				month[i] = currentMonth;
				year[i] = currentYear;				
				mode[i] = 1;
			}	
			var nextmonthDays = 1;
			for(var i = daysInMonth + startDayOfWeek;i <= 42;i++)
			{
				days[i] = nextmonthDays;
				month[i] = (currentMonth < 12) ? (currentMonth + 1) : 1;
				year[i] = (currentMonth < 12) ? currentYear : (currentYear + 1);				
				mode[i] = 2;
				nextmonthDays++;
			}
		}
		
		switch(selectedMode)
		{
			case 0:
			{
				break;
			}
			case 1:
			{
				mode[startDayOfWeek + selectedDay - 1] = 3;
				sel_day_count = 1;
				break;
			}
			case 2:
			{
				for(var i = 0; i < 7; i++)
				{
					mode[((selectedIndex * 7) + i)] = 3;
					sel_day_count = 7;
				}
				break;
			}
			case 3:
			{
				for(var i = 0; i < daysInMonth; i++)
				{
					mode[startDayOfWeek + i] = 3;
					sel_day_count = daysInMonth;
				}				
				break;
			}
		}
		


		var table = "<form action='index.php' method='get'>";		
    table = table + "<table cellspacing='0' cellpadding='0' border='0'>";

		table = table + "<input type='hidden' name='page' value='report_form'>";
		var utc_time = new Date(selectedYear, selectedMonth - 1, selectedDay);
		table = table + "<input type='hidden' name='from' value='"+utc_time.getTime() / 1000+"'>";		
		var cur_time = new Date(currentYear, currentMonth - 1, currentDay);
		table = table + "<input type='hidden' name='current' value='"+cur_time.getTime() / 1000+"'>";
		table = table + "<input type='hidden' name='sel_mode' value='"+selectedMode+"'>";
		table = table + "<input type='hidden' name='day_count' value='"+sel_day_count+"'>";		
		table = table + "<input type='hidden' name='sel_index' value='"+selectedIndex+"'>";	
		table = table + "<input type='hidden' name='sub_opt' value=\""+sub_opt+"\">";    

    table = table + "<tr class='calendar_header'>";
    table = table + "  <td colspan='2' class='calendar_previous'><a href='javascript:changeCalendarControlMonth(-1);'>&lt;</a> <a href='javascript:changeCalendarControlYear(-1);'>&laquo;</a></td>";
    table = table + "  <td colspan='4' class='calendar_title'>" + months[currentMonth-1] + "<br>" + currentYear + "</td>";
    table = table + "  <td colspan='2' class='calendar_next'><a href='javascript:changeCalendarControlYear(1);'>&raquo;</a> <a href='javascript:changeCalendarControlMonth(1);'>&gt;</a></td>";
    table = table + "</tr>";
    table = table + "<tr><th>W</th><th>Mo</th><th>Tu</th><th>We</th><th>Th</th><th>Fr</th><th>Sa</th><th>Su</th></tr>";

		var index;
    for(var week=0; week < 6; week++) {
      table = table + "<tr><td><a class=\"calendar_week\" href=\"javascript:setCalendarControlDate(2,"+year[week * 7]+","+month[week * 7]+","+days[week * 7]+","+week+");\">"+weekOfYear+"</a></td>";
      for(var dayOfWeek=0; dayOfWeek < 7; dayOfWeek++) {
				
				index = (week * 7) + dayOfWeek;
			
				switch(mode[index])
				{
					case 1:
						{
							table = table + "<td><a class='calendar_weekday' href=\"javascript:setCalendarControlDate(1,"+year[index]+","+month[index]+","+days[index]+","+index+");\">"+days[index]+"</a></td>";			
							break;
						}
					case 2:
						{
							table = table + "<td><a class='calendar_otherweekday' href=\"javascript:void(0);\">"+days[index]+"</a></td>";			
							break;
						}			
					case 3:
						{
							table = table + "<td><a class='calendar_current' href=\"javascript:setCalendarControlDate(1,"+year[index]+","+month[index]+","+days[index]+","+index+");\">"+days[index]+"</a></td>";			
							break;
						}
				}
				
				day++;
      }
			weekOfYear = getCurrentWeek(currentYear, currentMonth-1, day, startDayOfWeek);
      table = table + "</tr>";
    }



    table = table + "<tr class='calendar_header'><td><a class=\"calendar_month\" href=\"javascript:setCalendarControlDate(3,"+currentYear+","+currentMonth+",1,1);\">M</a></td><th colspan='7'></th></tr>";

    for (var i=0; (filt_head[i] != null) && (filt_body[i] != null); i++) {
      if( filt_style[i].length )
      { // definovan styl
        table = table + "<tr align='left' class=\""+filt_style[i]+"\"><td colspan='8'>"+filt_head[i]+" "+filt_body[i]+"</td></tr>"      
      }
      else
      {  
        table = table + "<tr align='left'><th colspan='4'>"+filt_head[i]+"</th><th colspan='4'>"+filt_body[i]+"</th></tr>"
      }
    }

		table = table + "<tr align='right'><th colspan='8'>";
		table = table + "<input type='submit' value='View Report'>&nbsp</th></tr>";

    table = table + "</table>";

		table = table + "</form>";		
		
    return table;
  }

  this.show = show;
  function show() {

    if (!(selectedYear && selectedMonth && selectedDay)) {
      selectedMonth = getCurrentMonth();
      selectedDay = getCurrentDay();
      selectedYear = getCurrentYear();
    }

    if (!(currentYear && currentMonth && currentDay)) {
      currentMonth = getCurrentMonth();
      currentDay = getCurrentDay();
      currentYear = getCurrentYear();
    }		
		
    if(document.getElementById){
      calendar = document.getElementById(calendarId);
      calendar.innerHTML = calendarDrawTable(currentYear, currentMonth);
    }
  }
}

var calendarControl = new CalendarControl();

function showCalendarControl() {
  calendarControl.show();
}

function setCalendarControlDate(mode,year, month, day, index) {
  calendarControl.setDate(mode,year, month, day, index);
}

function changeCalendarControlYear(change) {
  calendarControl.changeYear(change);
}

function changeCalendarControlMonth(change) {
  calendarControl.changeMonth(change);
}

