<?php
/***************************************************************************/
/*                                                                         */
/*  FORMULAR PRO PRIDAVANI ZARIZENI					                               */
/*                                                                         */
/***************************************************************************/

	// pripojeni hlavicky
  include ("php/head.php");

	// pripojeni menu
  include ("php/menu.php");

	require_once "config.inc.php";

  include ("php/js_misc.php");

  js_begin( "
              function CheckForm()
              {
                if( (GetValue(document.f.access_mode) == \"0\") && IsEmpty(document.f.add_hostname)){
                  return Error( 'In Polling mode you must specify hostname.', document.f.add_hostname );
                }
                if( !IsEmpty(document.f.add_hostname) && !IsValidHostname(document.f.add_hostname)){
                  return Error( 'Invalid hostname.', document.f.add_hostname );
                }
                if( !IsEmpty(document.f.add_hostname_alt) && !IsValidHostname(document.f.add_hostname_alt)){
                  return Error( 'Invalid hostname alt.', document.f.add_hostname_alt );
                }
                if( (GetValue(document.f.access_mode) == \"1\") && IsEmpty(document.f.add_mac)){
                  return Error( 'In Trap mode you must specify MAC address.', document.f.add_mac );
                }
                if( IsEmpty(document.f.add_community) ){
                  return Error( 'Missing community.', document.f.add_community );
                }
                if( !IsInRange(document.f.add_period, 1, 65535, false) ){
                  return Error( 'Missing or invalid read period.', document.f.add_period );
                }
                return true;
              }
    " );

?>
            <tr>
              <th  colspan="3">Add Device</td>
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td align="center" class="header">Manually</td>
                  </tr>
                  <tr>
                    <td>
                      <form name="f" action="index.php" method="post">
                      <input type="hidden" name="page" value="device_change">
                      <input type="hidden" name="oper" value="add">
                      <table>
                        <tr>
                          <td></td><td></td><td>Accounting start</td>
                        </tr>
                        <tr>
                          <td width="150px">Hostname *</td><td><input type="text" name="add_hostname" value=""></td>
                          <td>
                            <select name="add_accounting_start">
<?php
  for($i = 1;$i < 32;$i++)
  {
    echo "                              <option value=\"".$i."\">".$i."\n";
  }
?>
                            </select>
                          </td>
                        </tr>
                        <tr>
                          <td>2nd Hostname*</td><td><input type="text" name="add_hostname_alt" value=""></td>
                          <td>
                            <select name="add_accounting_start_alt">
<?php
  for($i = 1;$i < 32;$i++)
  {
    echo "                              <option value=\"".$i."\">".$i."\n";
  }
?>
                            </select>
                          </td>
                        </tr>
                        <tr>
                          <td>3rd Hostname*</td><td><input type="text" name="add_hostname_alt2" value=""></td>
                          <td>
                            <select name="add_accounting_start_alt2">
<?php
  for($i = 1;$i < 32;$i++)
  {
    echo "                              <option value=\"".$i."\">".$i."\n";
  }
?>
                            </select>
                          </td>
                        </tr>
                        <tr>
                          <td>MAC Address *</td><td><input type="text" name="add_mac" value="">
                        <tr>
                          <td>Description *</td><td><input type="text" name="add_description" value=""></td>
                        </tr>
                        <tr>
                          <td>Community</td><td><input type="text" name="add_community" value="<?php echo($cfg['default_community'])?>"></td>
                        </tr>
                        <tr>
                          <td>Location *</td><td><input type="text" name="add_location" value=""></td>
                        </tr>
                        <tr>
                          <td>Note *</td><td><input type="text" name="add_note" value=""></td>
                        </tr>
                        <tr>
                          <td>Phone *</td><td><input type="text" name="add_phone" value=""></td>
                        </tr>
                        <tr>
                          <td>Phone Alt *</td><td><input type="text" name="add_phone_alt" value=""></td>
                        </tr>
<?php
  ob_start();

  echo "                        <tr>\n";
  echo "                          <td width=\"150px\">Group</td>\n";
  echo "                          <td>\n";
  echo "                            <select name=\"group_id\">\n";

	// pripojeni k databazi
	$link = db_connect();

  if( is_superadmin() )
  {
    $sql = 'SELECT groups.group_id, groups.description, companies.name
      FROM groups
      LEFT JOIN companies ON groups.company_id = companies.company_id';
  }
  else
  {
    $sql = 'SELECT groups.group_id, groups.description, companies.name
      FROM groups
      LEFT JOIN companies ON groups.company_id = companies.company_id
      WHERE groups.company_id = "'.get_company_id().'"';
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);

  $selected_group = get_group_id();

  while( list( $group_id, $description, $comp_name ) = mysqli_fetch_row( $result ) )
  {
    if( is_superadmin() )
    {
      echo "                              <option value=\"".$group_id."\"".($group_id == $selected_group ? " selected" : "").">".$comp_name." - ".$description."\n";
    }
    else
    {
      echo "                              <option value=\"".$group_id."\"".($group_id == $selected_group ? " selected" : "").">".$description."\n";
    }
  }

  echo "                            </select>\n";
  echo "                          </td>\n";
  echo "                        </tr>\n";
  $group_selection = ob_get_clean();
  echo $group_selection;

?>
                        <tr>
                          <td>Read period</td><td><input type="text" name="add_period" value="15">min</td>
                        </tr>
                        <tr>
                          <td>Access mode</td>
                          <td>
                            <select name="access_mode">
                              <option value="0">Polling
                              <option value="1">Trap
                            </select>
                          </td>
                        </tr>
						<tr>
							<td colspan="2"><input type="checkbox" id="snmp_enabled" name="snmp_enabled" value="1"> <label for="snmp_enabled">Enable SNMP V3</label></td>
						</tr>
						<tr>
							<td><label class="left-margin" for="snmp_username">Username</label></td>
							<td><input type="text" name="snmp_username" id="snmp_username"></td>
						</tr>
						<tr>
							<td><label class="left-margin"  for="snmp_auth">Authentication</label></td>
							<td>
								<select name="snmp_auth">
									<option value="0">None
									<option value="1">MD5
									<option value="2">SHA1
								</select>
							</td>
						</tr>
						<tr>
							<td><label class="left-margin"  for="snmp_auth_password">Auth. Password</label></td>
							<td><input type="text" name="snmp_auth_password" id="snmp_auth_password"></td>
						</tr>
						<tr>
							<td><label class="left-margin"  for="snmp_privacy">Privacy</label></td>
							<td>
								<select name="snmp_privacy">
									<option value="0">None
									<option value="1">DES
									<option value="2">AES
								</select>
							</td>
						</tr>
						<tr>
							<td><label class="left-margin"  for="snmp_privacy_password">Privacy Password</label></td>
							<td><input type="text" name="snmp_privacy_password" id="snmp_privacy_password"></td>
						</tr>
                        <tr>
                          <td>* <i>can be blank</i></td><td></td>
                        </tr>
                        <tr>
                          <td><input type="submit" value="Add Device"></td><td></td>
                        </tr>
                      </table>
                      </form>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td align="center" class="header">From CSV file</td>
                  </tr>
                  <tr>
                    <td>
                      <form action="index.php" method="post" enctype="multipart/form-data">
                      <input type="hidden" name="page" value="device_change">
                      <input type="hidden" name="oper" value="import">
                      <table>
                        <tr>
                          <td width="150px">File:</td><td><input type="file" name="import_file" value=""></td>
                          <td>Accounting start</td>
                        </tr>
                        <tr>
                          <td>Delimiter</td>
                          <td>
                            <select name="delim">
                              <option value="comma">, - comma</option>
                              <option value="semicolon">; - semicolon</option>
                            </select>
                          </td>
                        </tr>
<?php
  $values = array ( "hostname_col" => "Hostname *",
    "hostname_alt_col" => "2nd Hostname *",
    "hostname_alt_col2" => "3rd Hostname *",
    "mac_col" => "MAC Address *",
    "description_col" => "Description *",
    "location_col" => "Location *",
    "note_col" => "Note *",
    "phone_col" => "Phone *",
    "phone_alt_col" => "Phone Alt *" );

  $i = 0;
  foreach($values as $val_col_name => $val_name)
  {
    echo "                        <tr>\n";
    echo "                          <td>".$val_name."</td>\n";
    echo "                          <td>\n";
    echo "                            <select name=\"".$val_col_name."\">\n";
    for($j = 0;$j < count($values);$j++)
    {
      echo "                              <option value=\"".$j."\"".($i == $j ? " selected" : "").">".($j + 1).".Column\n";
    }
    echo "                              <option value=\"".$j."\">None\n";
    echo "                            </select>\n";
    echo "                          </td>\n";

    if( $val_col_name == "hostname_col" )
    {
      echo "                          <td>\n";
      echo "                            <select name=\"add_accounting_start\">\n";
      for($i = 1;$i < 32;$i++)
      {
        echo "                              <option value=\"".$i."\">".$i."\n";
      }

      echo "                            </select>\n";
      echo "                          </td>\n";
    }

    if( $val_col_name == "hostname_alt_col" )
    {
      echo "                          <td>\n";
      echo "                            <select name=\"add_accounting_start_alt\">\n";
      for($i = 1;$i < 32;$i++)
      {
        echo "                              <option value=\"".$i."\">".$i."\n";
      }

      echo "                            </select>\n";
      echo "                          </td>\n";
    }

    if( $val_col_name == "hostname_alt_col2" )
    {
      echo "                          <td>\n";
      echo "                            <select name=\"add_accounting_start_alt2\">\n";
      for($i = 1;$i < 32;$i++)
      {
        echo "                              <option value=\"".$i."\">".$i."\n";
      }

      echo "                            </select>\n";
      echo "                          </td>\n";
    }

    echo "                        </tr>\n";
    $i++;
  }
?>
                        <tr>
                          <td>Community</td><td><input type="text" name="add_community" value="<?php echo($cfg['default_community'])?>"></td>
                        </tr>
<?php
  echo $group_selection;
?>
                        <tr>
                          <td>Read period</td><td><input type="text" name="add_period" value="15">min</td>
                        </tr>
                        <tr>
                          <td>Access mode</td>
                          <td>
                            <select name="access_mode">
                              <option value="0">Polling
                              <option value="1">Trap
                            </select>
                          </td>
                        </tr>
						<tr>
							<td colspan="2"><input type="checkbox" id="snmp_enabled" name="snmp_enabled" value="1"> <label for="snmp_enabled">Enable SNMP V3</label></td>
						</tr>
						<tr>
							<td><label class="left-margin" for="snmp_username">Username</label></td>
							<td><input type="text" name="snmp_username" id="snmp_username"></td>
						</tr>
						<tr>
							<td><label class="left-margin"  for="snmp_auth">Authentication</label></td>
							<td>
								<select name="snmp_auth">
									<option value="0">None
									<option value="1">MD5
									<option value="2">SHA1
								</select>
							</td>
						</tr>
						<tr>
							<td><label class="left-margin"  for="snmp_auth_password">Auth. Password</label></td>
							<td><input type="text" name="snmp_auth_password" id="snmp_auth_password"></td>
						</tr>
						<tr>
							<td><label class="left-margin"  for="snmp_privacy">Privacy</label></td>
							<td>
								<select name="snmp_privacy">
									<option value="0">None
									<option value="1">DES
									<option value="2">AES
								</select>
							</td>
						</tr>
						<tr>
							<td><label class="left-margin"  for="snmp_privacy_password">Privacy Password</label></td>
							<td><input type="text" name="snmp_privacy_password" id="snmp_privacy_password"></td>
						</tr>
                        <tr>
                          <td>* <i>can be "None"</i></td><td></td>
                        </tr>
                        <tr>
                          <td><input type="submit" name="submit" value="Import Devices"></td><td></td>
                        </tr>
                      </table>
                      </form>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
<?php

  js_end( "
              document.f.onsubmit = CheckForm;
              document.f.add_hostname.focus();
    " );

	// pripojeni paticky
  include ("php/bottom.php");

?>
