<?php
/***************************************************************************/
/*                                                                         */
/*  FORMULAR PRO PRIDAVANI SKUPIN  					                               */
/*                                                                         */
/***************************************************************************/

	// pripojeni hlavicky
  include ("php/head.php");
	
	// pripojeni menu
  include ("php/menu.php");
	require_once "config.inc.php";	

  include ("php/js_misc.php");

  js_begin( " 
              function CheckForm()
              {
                if( IsEmpty(document.f.add_name) ){
                  return Error( 'Missing group name.', document.f.add_name );
                }
                if( !IsInRange(document.f.add_level_limit,-120,-30 ,1) ){
                  return Error( 'Invalid Level Limit value.', document.f.add_level_limit );
                }
                if( !IsInRange(document.f.add_qual_limit_lo,-35,0 ,1) ){
                  return Error( 'Invalid Quality Limit value.', document.f.add_qual_limit_lo );
                }
                if( !IsInRange(document.f.add_traffic_limit,0,100000 ,1) ){
                  return Error( 'Invalid Traffic Limit value.', document.f.add_traffic_limit );
                }
                if( !IsInRange(document.f.add_traffic_limit_alt,0,100000 ,1) ){
                  return Error( 'Invalid 2nd Traffic Limit value.', document.f.add_traffic_limit_alt );
                }
                if( !IsInRange(document.f.add_traffic_limit_alt2,0,100000 ,1) ){
                  return Error( 'Invalid 3rd Traffic Limit value.', document.f.add_traffic_limit_alt2 );
                }
                if( !IsInRange(document.f.add_temp_limit_lo,-50,90 ,1) ){
                  return Error( 'Invalid Min Temp Limit value.', document.f.add_temp_limit_lo );
                }
                if( !IsInRange(document.f.add_temp_limit_hi,-50,90 ,1) ){
                  return Error( 'Invalid Max Temp Limit value.', document.f.add_temp_limit_hi );
                }
                if( !IsInRange(document.f.add_volt_limit_lo,5,60 ,1) ){
                  return Error( 'Invalid Min Voltage Limit value.', document.f.add_volt_limit_lo );
                }
                if( !IsInRange(document.f.add_volt_limit_hi,5,60 ,1) ){
                  return Error( 'Invalid Max Voltage Limit value.', document.f.add_volt_limit_hi );
                }
                if( !IsInRange(document.f.add_group_window,1,1440 ,0) ){
                  return Error( 'Invalid or missing group window value.', document.f.add_group_window );
                }
                if( !IsInRange(document.f.add_max_fails,1,255 ,1) ){
                  return Error( 'Invalid or missing Max fails for avail value.', document.f.add_max_fails );
                }
                if( !IsInRange(document.f.add_max_fails_msg,1,255 ,1) ){
                  return Error( 'Invalid or missing Max fails for msg value.', document.f.add_max_fails_msg );
                }
                if( !IsInRange(document.f.add_delay_msg,1,255 ,1) ){
                  return Error( 'Invalid or missing Delay for msg value.', document.f.add_delay_msg );
                }
                return true;
              }
    " );

?>
            <tr>    
              <th  colspan="3">Add Group</td>  
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td>
                      <form name="f" action="index.php" method="get">
                      <input type="hidden" name="page" value="group_change">
                      <input type="hidden" name="oper" value="add">
                      <input type="hidden" name="company_id" value="<?php echo get_company_id();?>">
                      <table>
                        <tr>
                          <td width="150px">Name</td><td><input type="text" name="add_name" value=""></td>
                        </tr>
<?php
  if( is_superadmin() )
  {
    echo "                        <tr>\n";
    echo "                          <td width=\"150px\">Company</td>\n";
    echo "                          <td>\n";
    echo "                            <select name=\"company_id\">\n";

  	// pripojeni k databazi
  	$link = db_connect();

    $sql = 'SELECT company_id, name
            FROM
            companies';

	  // vykonani SQL prikazu
  	$result = db_query($link, $sql);

    while( list( $company_id, $name ) = mysqli_fetch_row( $result ) )
    {
      echo "                              <option value=\"".$company_id."\"".( $company_id == get_company_id() ? ' selected' : '' ).">".$name."\n";
    }

    echo "                            </select>\n";
    echo "                          </td>\n";
    echo "                        </tr>\n";
  }
?>
                        <tr>
                          <td>Level Limit *</td><td><input type="text" name="add_level_limit" value=""></td><td>dBm</td>
                        </tr>
                        <tr>
                          <td>Quality Limit *</td><td><input type="text" name="add_qual_limit_lo" value=""></td><td>dB</td>
                        </tr>
                        <tr>
                          <td>Traffic Limit *</td><td><input type="text" name="add_traffic_limit" value=""></td><td>MB</td>
                        </tr>
                        <tr>
                          <td>2nd Traffic Limit*</td><td><input type="text" name="add_traffic_limit_alt" value=""></td><td>MB</td>
                        </tr>
                        <tr>
                          <td>3rd Traffic Limit*</td><td><input type="text" name="add_traffic_limit_alt2" value=""></td><td>MB</td>
                        </tr>
                        <tr>
                          <td>Min Temp Limit*</td><td><input type="text" name="add_temp_limit_lo" value=""></td><td>&deg;C</td>
                        </tr>
                        <tr>
                          <td>Max Temp Limit*</td><td><input type="text" name="add_temp_limit_hi" value=""></td><td>&deg;C</td>
                        </tr>
                        <tr>
                          <td>Min Voltage Limit*</td><td><input type="text" name="add_volt_limit_lo" value=""></td><td>V</td>
                        </tr>
                        <tr>
                          <td>Max Voltage Limit*</td><td><input type="text" name="add_volt_limit_hi" value=""></td><td>V</td>
                        </tr>
                        <tr>
                          <td>Report group window</td><td><input type="text" name="add_group_window" value="15"></td><td>min</td>
                        </tr>
                        <tr>
                          <td>Max fails for avail </td><td><input type="text" name="add_max_fails" value="<?php echo $max_fails;?>"></td><td></td>
                        </tr>
                        <tr>
                          <td>Max fails for msg </td><td><input type="text" name="add_max_fails_msg" value="<?php echo $max_fails_msg;?>"></td><td></td>
                        </tr>
                        <tr>
                          <td>Max Delay for msg </td><td><input type="text" name="add_delay_msg" value="<?php echo $delay_msg;?>"></td><td>min</td>
                        </tr>
                        <tr>
                          <td>* <i>can be blank</i></td><td></td> 
                        </tr>
                        <tr>
                          <td><input type="submit" value="Add Group"></td><td></td>
                        </tr>
                      </table>
                      </form>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
<?php
  js_end( "
              document.f.onsubmit = CheckForm;
              document.f.add_name.focus();
    " );

	// pripojeni paticky
  include ("php/bottom.php");

?>