<?php
/***************************************************************************/
/*                                                                         */
/*  FORMULAR PRO PRIDAVANI SKUPIN  					                               */
/*                                                                         */
/***************************************************************************/

	// pripojeni hlavicky
  include ("php/head.php");
	
	// pripojeni menu
  include ("php/menu.php");
	require_once "config.inc.php";	

  include ("php/js_misc.php");

  js_begin( " 
              function CheckForm()
              {
                if( IsEmpty(document.f.add_username) ){
                  return Error( 'Missing username.', document.f.add_username );
                }
                if( IsEmpty(document.f.add_passwd) ){
                  return Error( 'Missing password.', document.f.add_passwd );
                }
                if( IsEmpty(document.f.add_passwd2) ){
                  return Error( 'Missing confirm password.', document.f.add_passwd2 );
                }
                if( GetValue(document.f.add_passwd) != GetValue(document.f.add_passwd2) ){
                  return Error( 'Passwords are not same.', document.f.add_passwd );
                }
                return true;
              }
              function RoleChanged()
              {
                role = GetValue( document.f.add_rights );
                edit_device_checkbox = document.getElementById(\"edit_device\");
                if( role == 2 )
                {
                  edit_device_checkbox.disabled = false;
                }
                else
                {
                  edit_device_checkbox.disabled = true;
                }
              }
              ".(is_superadmin() ? '
              function CheckCompany()
              {
                RoleChanged();
                var rights = GetValue(document.f.add_rights);
                if( rights == 0 )
                {
                  document.f.company_id.disabled = true;
                }
                else
                {
                  document.f.company_id.disabled = false;                
                }
              }
              ' : ''));

	// pripojeni k databazi
	$link = db_connect();

?>
            <tr>    
              <th  colspan="3">Add User</td>  
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td>
                      <form name="f" action="index.php" method="post">
                      <input type="hidden" name="page" value="user_change">
                      <input type="hidden" name="oper" value="add">
                      <table>
                        <tr>
                          <td width="150px">Username</td><td><input type="text" name="add_username" value=""></td>
                        </tr>
                        <tr>
                          <td width="150px">Password</td><td><input type="password" name="add_passwd"></td>
                        </tr>
                        <tr>
                          <td width="150px">Confirm Password</td><td><input type="password" name="add_passwd2"></td>
                        </tr>
                        <tr>
                          <td width="150px">Name *</td><td><input type="text" name="add_name"></td>
                        </tr>
                        <tr>
                          <td width="150px">Surname *</td><td><input type="text" name="add_surname"></td>
                        </tr>
                        <tr>
                          <td width="150px">Email *</td><td><input type="text" name="add_email"></td>
                        </tr>
                        <tr>
                          <td width="150px">Phone *</td><td><input type="text" name="add_phone"></td>
                        </tr>
                        <tr>
                          <td width="150px">Role</td>
                          <td>
                            <select name="add_rights">
                              <option value="2" selected>Guest
                              <option value="1">Admin
<?php
  if( is_superadmin() )
  {
    echo "                              <option value=\"0\">Superadmin\n";
  }
?>
                            </select>
                            <input type="checkbox" id="edit_device" name="can_edit_device" value="1"> Can edit device
                          </td>
                        </tr>
<?php
  if( is_superadmin() )
  {
    echo "                        <tr>\n";
    echo "                          <td width=\"150px\">Company</td>\n";
    echo "                          <td>\n";
    echo "                            <select name=\"company_id\">\n";

    $sql = 'SELECT company_id, name
            FROM
            companies';

	  // vykonani SQL prikazu
  	$result = db_query($link, $sql);

    while( list( $company_id, $name ) = mysqli_fetch_row( $result ) )
    {
      echo "                              <option value=\"".$company_id."\"".( $company_id == get_company_id() ? ' selected' : '' ).">".$name."\n";
    }

    echo "                            </select>\n";
    echo "                          </td>\n";
    echo "                        </tr>\n";
  }
?>
                        <tr>
                          <td>* <i>can be blank</i></td><td></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr align="center">
                    <td class="header">Group settings</td>
                  </tr>
                  <tr>
                    <td>
                      <table>
                        <tr>
                          <td>
                            <table cellspacing="0" cellpadding="1" border="1" style="border-collapse:collapse;">
                              <tr>
                                <th>Group</th><th>Enable</th><th colspan="16">Events</th>
                              </tr>
                              <tr align="center">
                                <td></td><td></td><td colspan="2" align="center">Online/Offline</td><td colspan="2">Traffic</td><td colspan="2">Level</td><td colspan="2">Quality</td><td colspan="2">Temperature</td><td colspan="2">Voltage</td><td colspan="2">Unexpected trap</td><td colspan="2">Disk space</td>
                              </tr>
                              <tr align="center">
                                <td></td><td></td>
                                <td width="50px">Email</td><td width="50px">SMS</td>
                                <td width="50px">Email</td><td width="50px">SMS</td>
                                <td width="50px">Email</td><td width="50px">SMS</td>
                                <td width="50px">Email</td><td width="50px">SMS</td>
                                <td width="50px">Email</td><td width="50px">SMS</td>
                                <td width="50px">Email</td><td width="50px">SMS</td>
                                <td width="50px">Email</td><td width="50px">SMS</td>
                                <td width="50px">Email</td><td width="50px">SMS</td>
                              </tr>
<?php

  if( is_superadmin() )
  {
    $sql = 'SELECT groups.group_id, groups.description, companies.name
            FROM groups
            LEFT JOIN companies ON groups.company_id = companies.company_id';
  }
  else
  {
    $sql = 'SELECT groups.group_id, groups.description, companies.name
            FROM groups
            LEFT JOIN companies ON groups.company_id = companies.company_id
            WHERE groups.company_id = "'.get_company_id().'"';  
  }

  $result = db_query($link, $sql);

  $i = 0;

  while(list( $group_id, $group_name, $comp_name ) = mysqli_fetch_row( $result ))
  {
    echo "                              <tr>\n"; 

    if( is_superadmin() )
    {    
      echo "                                <td nowrap>".$comp_name." - ".$group_name."</td>\n";      
    }
    else
    {
      echo "                                <td nowrap>".$group_name."</td>\n";          
    }
    echo "                                <td align=\"center\">\n";
    echo "                                  <input type=\"checkbox\" name=\"sel_".$i."\" value=\"1\">\n";
    echo "                                  <input type=\"hidden\" name=\"group_".$i."\" value=\"".$group_id."\">\n";
    echo "                                </td>\n";

    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"status_email_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"status_sms_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"traffic_email_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"traffic_sms_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"level_email_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"level_sms_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"qual_email_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"qual_sms_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"temp_email_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"temp_sms_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"volt_email_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"volt_sms_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"trap_poll_email_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"trap_poll_sms_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"space_email_".$i."\" value=\"".$group_id."\"></td>\n";
    echo "                                <td align=\"center\"><input type=\"checkbox\" name=\"space_sms_".$i."\" value=\"".$group_id."\"></td>\n";

    echo "                              </tr>\n";      
    $i++;
  }

  echo "                              <input type=\"hidden\" name=\"group_count\" value=\"".$i."\">\n";      

?>
                            </table>
                          </td>
                        </tr>
                        <tr>
                          <td><input type="submit" value="Add User"></td><td></td>
                        </tr>
                      </table>
                      </form>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
<?php
  js_end( "
              document.f.onsubmit = CheckForm;".(is_superadmin() ? '
              document.f.add_rights.onchange = CheckCompany;' : '
              document.f.add_rights.onchange = RoleChanged;')."
              document.f.add_username.focus();
              RoleChanged();
    " );

	// pripojeni paticky
  include ("php/bottom.php");

?>
