<?php
/***************************************************************************/
/*                                                                         */
/*  HLAVNI STRANKA - SEZNAM ZARIZENI				                               */
/*                                                                         */
/***************************************************************************/

  include ("php/head.php");
  include ("php/menu.php");
  flush();
  require_once ("php/misc.php");

  include ("php/device_columns.php");

  include ("php/js_misc.php");

  define("COL_NAME_WIDTH", "120");

  js_begin("
              function updateTableHeader() {
                var window_pos = GetScrollY();
                var head_line = document.getElementById('head_line');
                var head_div = document.getElementById('table_header');

                if( window_pos > GetPos(head_line) )
                {
                  head_div.style.visibility = \"visible\";
                  head_div.style.width = \"0px\";
                  head_div.style.top = document.body.scrollTop;
                }
                else
                {
                  head_div.style.visibility = \"hidden\";
                }
              }
  ");

  $_SESSION['last'] = $_SERVER['REQUEST_URI'];

  if (isset($_GET['company_id']) && is_numeric( $_GET['company_id'] ) && is_superadmin())
  {
    $company_id = sanitize_number($_GET['company_id']);
    set_company_id( $company_id );
  }
  else
  {
    $company_id = get_company_id( );
  }

	if(isset($_GET['dir']))
	{
		$_SESSION['dir'] = urldecode($_GET['dir']);
  }
  else
  {
    $_SESSION['dir'] = 'up';
  }

  $group_id = URI_get_int("group_filter");

  if( !is_null($group_id) )
  { // je nastaveno group_id, zapamatujeme si jej
    set_group_id( $group_id );
  }

  if( !is_null( $group_id ) || ( isset($_SESSION['group_filter']) && strlen($_SESSION['group_filter']) ) )
  {	// je nastaven filtr group
    if( !in_array("group",$cols_selected) )
    { // sloupec group neni mezi zobrazovanymi, kvuli filtru group je potreba jej videt ...
      $cols_selected[] = "group";
    }
  }

  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi sloupec s firmou
    $cols_selected[] = "company";
  }

  // otevreni docasneho csv souboru
  $csv = fopen($temp_path."/temp.csv",'w');

?>
            <tr>
              <th colspan="3">Device List</th>
            </tr>
            <tr>
              <td align="center" colspan="3">
                <table cellspacing="0" cellpadding="1" border="1" style="border-collapse:collapse;" id="dev_list_table">
                  <tr id="head_line">
                    <td nowrap width="50px" height="25px" align="center" class="header"><a href="index.php?page=device_list&ord=dev_num&dir=<?php echo($_SESSION['dir'] == 'up' ? 'down' : 'up')?>">:.</a></td>
<?php

  $header = array();

  $header['hostname'] = "                    <td nowrap align=\"center\" class=\"header\" width=\"170px\"><a href=\"index.php?page=device_list&ord=hostname&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['hostname']."</a> | <a href=\"index.php?page=device_list&ord=health&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">Status</a></td>\n";
  $header['hostname_alt'] = "                    <td nowrap align=\"center\" class=\"header\" width=\"170px\"><a href=\"index.php?page=device_list&ord=hostname_alt&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['hostname_alt']."</a> | <a href=\"index.php?page=device_list&ord=health_alt&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">Status</a></td>\n";
  $header['hostname_alt2'] = "                    <td nowrap align=\"center\" class=\"header\" width=\"170px\"><a href=\"index.php?page=device_list&ord=hostname_alt2&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['hostname_alt2']."</a> | <a href=\"index.php?page=device_list&ord=health_alt2&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">Status</a></td>\n";
  $header["description"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"150px\"><a href=\"index.php?page=device_list&ord=description&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['description']."</a></td>\n";
  $header["location"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"150px\"><a href=\"index.php?page=device_list&ord=location&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['location']."</a></td>\n";
  $header["device"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"120px\"><a href=\"index.php?page=device_list&ord=product&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['device']."</a></td>\n";
  $header["note"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"150px\"><a href=\"index.php?page=device_list&ord=note&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['note']."</a></td>\n";
  $header["tx"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=tx_account&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['tx']."</a></td>\n";
  $header["rx"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=rx_account&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['rx']."</a></td>\n";
  $header["total"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=total&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['total']."</a></td>\n";
  $header["tx_alt"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=tx_account&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['tx_alt']."</a></td>\n";
  $header["rx_alt"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=rx_account&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['rx_alt']."</a></td>\n";
  $header["total_alt"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=total_alt&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['total_alt']."</a></td>\n";
  $header["tx_alt2"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=tx_account2&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['tx_alt2']."</a></td>\n";
  $header["rx_alt2"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=rx_account2&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['rx_alt2']."</a></td>\n";
  $header["total_alt2"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=total_alt2&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['total_alt2']."</a></td>\n";
  $header["level"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=last_level&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['level']."</a></td>\n";
  $header["data_service"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"90px\"><a href=\"index.php?page=device_list&ord=last_status&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['data_service']."</a></td>\n";
  $header["firmware"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=firmware&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['firmware']."</a></td>\n";
  $header["enabled"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"65px\"><a href=\"index.php?page=device_list&ord=enabled&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['enabled']."</a></td>\n";
  $header["autoupdate"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\">".$cols['autoupdate']."</td>\n";
  $header["report"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"55px\"></td>\n";
  $header["sn"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"100px\"><a href=\"index.php?page=device_list&ord=sn&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['sn']."</a></td>\n";
  $header["imei"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"125px\"><a href=\"index.php?page=device_list&ord=imei&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['imei']."</a></td>\n";
  $header["esn"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"100px\"><a href=\"index.php?page=device_list&ord=esn&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['esn']."</a></td>\n";
  $header["access_mode"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"90px\"><a href=\"index.php?page=device_list&ord=trap&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['access_mode']."</a></td>\n";
  $header["mac"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"150px\"><a href=\"index.php?page=device_list&ord=mac&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['mac']."</a></td>\n";
  $header["group"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"150px\">".$cols['group']."</td>\n";
  $header["company"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"150px\"><a href=\"index.php?page=device_list&ord=comp_name&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['company']."</a></td>\n";
  $header["uptime"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=uptime&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['uptime']."</a></td>\n";
  $header["quality"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"75px\"><a href=\"index.php?page=device_list&ord=last_quality&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['quality']."</a></td>\n";
  $header["temp"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"95px\"><a href=\"index.php?page=device_list&ord=last_temp&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['temp']."</a></td>\n";
  $header["voltage"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"110px\"><a href=\"index.php?page=device_list&ord=last_volt&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['voltage']."</a></td>\n";
  $header["name"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"COL_NAME_WIDTHpxpx\"><a href=\"index.php?page=device_list&ord=name&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['name']."</a></td>\n";
  $header["snmp_prot"] = "                    <td nowrap align=\"center\" class=\"header\" width=\"120px\"><a href=\"index.php?page=device_list&ord=snmp_prot&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">".$cols['snmp_prot']."</a></td>\n";

  foreach( $cols_selected as $id => $cell_name )
  {
    echo $header[$cell_name];
    fwrite($csv,",\"".$cols[$cell_name]."\"");
  }

  fwrite($csv,"\n");

  // pokud jsme prihlaseni, zobrazimehe sloupec navic
  if( is_admin() )
  {
    echo "                    <td nowrap align=\"center\" class=\"header\" style=\"width:70px;\" colspan=\"2\">Operation</td>\n";
    echo "                    <td nowrap align=\"center\" class=\"header\" style=\"width:115px;\">Device Selection</td>\n";
  }
?>
                  </tr>
<?php
  require_once "php/mysql.php";

  // pripojeni k DB
  $link = db_connect();

  // ukazatel na aktualni stranku seznamu
  if (!isset($_GET['set']))
  { // otevrit prvni stranku seznamu
    $set = 1;
  }
  else
  {	// otevrit zadanou stranku seznamu
    $set = sanitize_number($_GET['set']);
  }


  // pocet polozek na strance seznamu

  if( isset($_GET['on_page']) )
  {
    if( ($_GET['on_page'] == 25) | ($_GET['on_page'] == 100) | ($_GET['on_page'] == 1000) )
    {
      $_SESSION['count_on_page'] = $_GET['on_page'];
    }
  }
  if( !isset($_SESSION['count_on_page']) )
  {
    $_SESSION['count_on_page'] = 25;
  }

  // zjisteni poctu vsech zarizeni
  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $sql = 'SELECT COUNT(*) FROM devices';
  }
  else if( is_admin() )
  {
    $sql = 'SELECT COUNT(*) FROM devices WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = '.get_company_id( ).')';
  }
  else
  {
    $sql = 'SELECT COUNT(*) FROM devices WHERE group_id IN (SELECT group_id FROM user_group WHERE user_id = '.get_user_id( ).')';
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);

  list($temp_set) = mysqli_fetch_row($result);
  $count_all_devices = $temp_set;
  $temp_set = ceil($temp_set / 25);
  if($set > $temp_set)
  { // neplatna hodnota $set
    $set = $temp_set;
  }

  if($set<1)
  {	// neplatna hodnota set
    $set = 1;
  }

  if(isset($_GET['desc_filter']))
  {	// je nastaven filtr description
    $_SESSION['desc_filter'] = sanitize_text($_GET['desc_filter']);
  }

  if(isset($_GET['host_filter']))
  {	// je nastaven filtr hostname
    $_SESSION['host_filter'] = sanitize_text($_GET['host_filter']);
  }

  if(isset($_GET['health_filter']))
  {	// je nastaven filtr health
    $_SESSION['health_filter'] = sanitize_number($_GET['health_filter']);
  }

  if(isset($_GET['host_alt_filter']))
  {	// je nastaven filtr hostname alt
    $_SESSION['host_alt_filter'] = sanitize_text($_GET['host_alt_filter']);
  }

  if(isset($_GET['health_alt_filter']))
  {	// je nastaven filtr health alt
    $_SESSION['health_alt_filter'] = sanitize_number($_GET['health_alt_filter']);
  }

  if(isset($_GET['host_alt_filter2']))
  {	// je nastaven filtr hostname alt 2
    $_SESSION['host_alt_filter2'] = sanitize_text($_GET['host_alt_filter2']);
  }

  if(isset($_GET['health_alt_filter2']))
  {	// je nastaven filtr health alt 2
    $_SESSION['health_alt_filter2'] = sanitize_number($_GET['health_alt_filter2']);
  }

  if(isset($_GET['prod_filter']))
  {	// je nastaven filtr product
    $_SESSION['prod_filter'] = sanitize_text($_GET['prod_filter']);
  }

  if(isset($_GET['loc_filter']))
  {	// je nastaven filtr location
    $_SESSION['loc_filter'] = sanitize_text($_GET['loc_filter']);
  }

  if(isset($_GET['note_filter']))
  {	// je nastaven filtr note
    $_SESSION['note_filter'] = sanitize_text($_GET['note_filter']);
  }

  if(isset($_GET['stat_filter']))
  {	// je nastaven filtr location
    $_SESSION['stat_filter'] = sanitize_number($_GET['stat_filter']);
  }

  if(isset($_GET['firm_filter']))
  {	// je nastaven filtr firmware
    $_SESSION['firm_filter'] = sanitize_text($_GET['firm_filter']);
  }

  if(isset($_GET['sn_filter']))
  {	// je nastaven filtr sn
    $_SESSION['sn_filter'] = sanitize_text($_GET['sn_filter']);
  }

  if(isset($_GET['imei_filter']))
  {	// je nastaven filtr imei
    $_SESSION['imei_filter'] = sanitize_text($_GET['imei_filter']);
  }

  if(isset($_GET['esn_filter']))
  {	// je nastaven filtr esn
    $_SESSION['esn_filter'] = sanitize_text($_GET['esn_filter']);
  }

  if(isset($_GET['mac_filter']))
  {	// je nastaven filtr MAC
    $_SESSION['mac_filter'] = sanitize_text($_GET['mac_filter']);
  }

  if(isset($_GET['group_filter']))
  {	// je nastaven filtr group
    $_SESSION['group_filter'] = sanitize_text($_GET['group_filter']);
  }

  if(isset($_GET['name_filter']))
  {	// je nastaven filtr product
    $_SESSION['name_filter'] = sanitize_text($_GET['name_filter']);
  }

  if(isset($_GET['ord']))
  {	// je nastaven filtr firmware
    $_SESSION['ord'] = sanitize_identifier($_GET['ord']);
  }
  else
  {
    unset($_SESSION['ord']);
    unset($_SESSION['dir']);
  }

  $filter = array();

  echo "                  <tr class=\"tab_line1\" align=\"center\">\n";
  echo "                  <form id=\"filtr\" action=\"index.php\" method=\"get\">\n";
  echo "                    <input id=\"filtr\" type=\"hidden\" name=\"page\" value=\"device_list\">\n";
  echo "                    <td><input id=\"filtr\" class=\"filter_button\" type=\"submit\" value=\"Filter\"></td>\n";


  $temp = "                    <td>\n";
  $temp = $temp."                      <input id=\"filtr\" type=\"text\" name=\"host_filter\" value=\"".(isset($_SESSION['host_filter']) ? $_SESSION['host_filter'] : '')."\" size=\"10\">\n";
  $temp = $temp."                      <select id=\"filtr\" name=\"health_filter\" size=\"1\" style=\"width: 70px;\">\n";
  $temp = $temp."                        <option value=\"\">\n";
  $temp = $temp."                        <option value=\"0\" class=\"health_green\"".((isset($_SESSION['health_filter']) ? $_SESSION['health_filter'] == "0" : false) ? ' selected' : '').">Online\n";
  $temp = $temp."                        <option value=\"1\" class=\"health_orange\"".((isset($_SESSION['health_filter']) ? $_SESSION['health_filter'] == "1" : false) ? ' selected' : '').">Faulting\n";
  $temp = $temp."                        <option value=\"2\" class=\"health_red\"".((isset($_SESSION['health_filter']) ? $_SESSION['health_filter'] == "2" : false) ? ' selected' : '').">Offline\n";
  $temp = $temp."                        <option value=\"3\" class=\"health_blue\"".((isset($_SESSION['health_filter']) ? $_SESSION['health_filter'] == "3" : false) ? ' selected' : '').">New\n";
  $temp = $temp."                      </select>\n";
  $temp = $temp."                    </td>\n";

  $filter["hostname"] = $temp;

  $temp = "                    <td>\n";
  $temp = $temp."                      <input id=\"filtr\" type=\"text\" name=\"host_alt_filter\" value=\"".(isset($_SESSION['host_alt_filter']) ? $_SESSION['host_alt_filter'] : '')."\" size=\"10\">\n";
  $temp = $temp."                      <select id=\"filtr\" name=\"health_alt_filter\" size=\"1\" style=\"width: 70px;\">\n";
  $temp = $temp."                        <option value=\"\">\n";
  $temp = $temp."                        <option value=\"0\" class=\"health_green\"".((isset($_SESSION['health_alt_filter']) ? $_SESSION['health_alt_filter'] == "0" : false) ? ' selected' : '').">Online\n";
  $temp = $temp."                        <option value=\"1\" class=\"health_orange\"".((isset($_SESSION['health_alt_filter']) ? $_SESSION['health_alt_filter'] == "1" : false) ? ' selected' : '').">Faulting\n";
  $temp = $temp."                        <option value=\"2\" class=\"health_red\"".((isset($_SESSION['health_alt_filter']) ? $_SESSION['health_alt_filter'] == "2" : false) ? ' selected' : '').">Offline\n";
  $temp = $temp."                        <option value=\"3\" class=\"health_blue\"".((isset($_SESSION['health_alt_filter']) ? $_SESSION['health_alt_filter'] == "3" : false) ? ' selected' : '').">New\n";
  $temp = $temp."                      </select>\n";
  $temp = $temp."                    </td>\n";

  $filter["hostname_alt"] = $temp;

  $temp = "                    <td>\n";
  $temp = $temp."                      <input id=\"filtr\" type=\"text\" name=\"host_alt_filter2\" value=\"".(isset($_SESSION['host_alt_filter2']) ? $_SESSION['host_alt_filter2'] : '')."\" size=\"10\">\n";
  $temp = $temp."                      <select id=\"filtr\" name=\"health_alt_filter2\" size=\"1\" style=\"width: 70px;\">\n";
  $temp = $temp."                        <option value=\"\">\n";
  $temp = $temp."                        <option value=\"0\" class=\"health_green\"".((isset($_SESSION['health_alt_filter2']) ? $_SESSION['health_alt_filter2'] == "0" : false) ? ' selected' : '').">Online\n";
  $temp = $temp."                        <option value=\"1\" class=\"health_orange\"".((isset($_SESSION['health_alt_filter2']) ? $_SESSION['health_alt_filter2'] == "1" : false) ? ' selected' : '').">Faulting\n";
  $temp = $temp."                        <option value=\"2\" class=\"health_red\"".((isset($_SESSION['health_alt_filter2']) ? $_SESSION['health_alt_filter2'] == "2" : false) ? ' selected' : '').">Offline\n";
  $temp = $temp."                        <option value=\"3\" class=\"health_blue\"".((isset($_SESSION['health_alt_filter2']) ? $_SESSION['health_alt_filter2'] == "3" : false) ? ' selected' : '').">New\n";
  $temp = $temp."                      </select>\n";
  $temp = $temp."                    </td>\n";

  $filter["hostname_alt2"] = $temp;

//  $filter["hostname_alt"] = "                    <td><input id=\"filtr\" type=\"text\" name=\"host_alt_filter\" value=\"".(isset($_SESSION['host_alt_filter']) ? $_SESSION['host_alt_filter'] : '')."\" size=\"10\"></td>\n";
  $filter["description"] = "                    <td><input id=\"filtr\" type=\"text\" name=\"desc_filter\" value=\"".(isset($_SESSION['desc_filter']) ? $_SESSION['desc_filter'] : '')."\" size=\"10\"></td>\n";
  $filter["location"] = "                    <td><input id=\"filtr\" type=\"text\" name=\"loc_filter\" value=\"".(isset($_SESSION['loc_filter']) ? $_SESSION['loc_filter'] : '')."\" size=\"10\"></td>\n";


  // vyhledani vsech ruznych hodnot pro filtr product
  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $sql = 'SELECT DISTINCT product FROM devices WHERE !(product is null) AND product != "" ORDER BY product';
  }
  else if( is_admin() )
  {
    $sql = 'SELECT DISTINCT product FROM devices WHERE !(product is null) AND product != "" AND group_id IN (SELECT group_id FROM groups WHERE company_id = '.get_company_id( ).') ORDER BY product';
  }
  else
  {
    $sql = 'SELECT DISTINCT product FROM devices WHERE !(product is null) AND product != "" AND group_id IN (SELECT group_id FROM user_group WHERE user_id = '.get_user_id( ).') ORDER BY product';
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);

  $i = 0;

  $prod_f = array();
  // vyzvednuti dat z odpovedi
  while (list($prod_f[$i]) = mysqli_fetch_row($result))
  {
    $i++;
  }

  // vytvareni filtru product
  $temp = "                    <td align=\"center\">\n";
  $temp = $temp."                      <select id=\"filtr\" name=\"prod_filter\" size=\"1\">\n";
  $temp = $temp."                        <option value=\"\">\n";
  for($j = 0;$j < $i;$j++)
	{	// naplneni seznamu vyrazu
	  $temp = $temp."                        <option value=\"".urlencode($prod_f[$j])."\"".((isset($_SESSION['prod_filter']) ? $prod_f[$j] == $_SESSION['prod_filter'] : false) ? ' selected' : '').">".$prod_f[$j]."\n";
	}
  $temp = $temp."                      </select>\n";
  $temp = $temp."                    </td>\n";

  $filter["device"] = $temp;


  $filter["note"] = "                    <td><input id=\"filtr\" type=\"text\" name=\"note_filter\" value=\"".(isset($_SESSION['note_filter']) ? $_SESSION['note_filter'] : '')."\" size=\"10\"></td>\n";
  $filter["tx"] = "                    <td></td>\n";
  $filter["rx"] = "                    <td></td>\n";
  $filter["total"] = "                    <td></td>\n";
  $filter["tx_alt"] = "                    <td></td>\n";
  $filter["rx_alt"] = "                    <td></td>\n";
  $filter["total_alt"] = "                    <td></td>\n";
  $filter["tx_alt2"] = "                    <td></td>\n";
  $filter["rx_alt2"] = "                    <td></td>\n";
  $filter["total_alt2"] = "                    <td></td>\n";
  $filter["level"] = "                    <td></td>\n";


  // vyhledani vsech ruznych hodnot pro filtr data service
  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $sql = 'SELECT DISTINCT last_status FROM devices WHERE !(last_status is null) AND last_status != ""';
  }
  else if( is_admin() )
  {
    $sql = 'SELECT DISTINCT last_status FROM devices WHERE !(last_status is null) AND last_status != "" AND group_id IN (SELECT group_id FROM groups WHERE company_id = '.get_company_id( ).')';
  }
  else
  {
    $sql = 'SELECT DISTINCT last_status FROM devices WHERE !(last_status is null) AND last_status != "" AND group_id IN (SELECT group_id FROM user_group WHERE user_id = '.get_user_id( ).')';
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);

  $i = 0;

  $status_f = array();
  // vyzvednuti dat z odpovedi
  while (list($status_f[$i]) = mysqli_fetch_row($result))
  {
    $i++;
  }

  // vytvareni filtru data service
  $temp = "                    <td align=\"center\">\n";
  $temp = $temp."                      <select id=\"filtr\" name=\"stat_filter\" size=\"1\">\n";
  $temp = $temp."                        <option value=\"\">\n";
  for($j = 0;$j < $i;$j++)
  {	// naplneni seznamu vyrazu
    $temp = $temp."                        <option value=\"".urlencode($status_f[$j])."\"".((isset($_SESSION['stat_filter']) ? $status_f[$j] == $_SESSION['stat_filter'] : false) ? ' selected' : '').">".decoding_network_status($status_f[$j])."\n";
  }
  $temp = $temp."                      </select>\n";
  $temp = $temp."                    </td>\n";

  $filter["data_service"] = $temp;

  // vyhledani vsech ruznych hodnot pro filtr firmware
  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $sql = 'SELECT DISTINCT firmware FROM devices WHERE !(firmware is null) AND firmware != "" ORDER BY firmware';
  }
  else if( is_admin() )
  {
    $sql = 'SELECT DISTINCT firmware FROM devices WHERE !(firmware is null) AND firmware != "" AND group_id IN (SELECT group_id FROM groups WHERE company_id = '.get_company_id( ).') ORDER BY firmware';
  }
  else
  {
    $sql = 'SELECT DISTINCT firmware FROM devices WHERE !(firmware is null) AND firmware != "" AND group_id IN (SELECT group_id FROM user_group WHERE user_id = '.get_user_id( ).') ORDER BY firmware';
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);

  $i = 0;

  $firm_f = array();
  // vyzvednuti dat z odpovedi
  while (list($firm_f[$i]) = mysqli_fetch_row($result))
  {
    $i++;
  }

  // vytvareni filtru firmware
  $temp = "                    <td align=\"center\">\n";
  $temp = $temp."                      <select id=\"filtr\" name=\"firm_filter\" size=\"1\" style=\"width: 70px;\">\n";
  $temp = $temp."                        <option value=\"\">\n";
  for($j = 0;$j < $i;$j++)
  {	// naplneni seznamu vyrazu
    $temp = $temp."                        <option value=\"".urlencode($firm_f[$j])."\"".((isset($_SESSION['firm_filter']) ? $firm_f[$j] == $_SESSION['firm_filter'] : false) ? ' selected' : '').">".$firm_f[$j]."\n";
  }
  $temp = $temp."                      </select>\n";
  $temp = $temp."                    </td>\n";

  $filter["firmware"] = $temp;

  $filter["enabled"] = "                    <td></td>\n";
  $filter["autoupdate"] = "                    <td></td>\n";
  $filter["report"] = "                    <td></td>\n";
  $filter["sn"] = "                    <td><input id=\"filtr\" type=\"text\" name=\"sn_filter\" value=\"".(isset($_SESSION['sn_filter']) ? $_SESSION['sn_filter'] : '')."\" size=\"10\"></td>\n";
  $filter["imei"] = "                    <td><input id=\"filtr\" type=\"text\" name=\"imei_filter\" value=\"".(isset($_SESSION['imei_filter']) ? $_SESSION['imei_filter'] : '')."\" size=\"10\"></td>\n";
  $filter["esn"] = "                    <td><input id=\"filtr\" type=\"text\" name=\"esn_filter\" value=\"".(isset($_SESSION['esn_filter']) ? $_SESSION['esn_filter'] : '')."\" size=\"10\"></td>\n";
  $filter["access_mode"] = "                    <td></td>\n";
  $filter["mac"] = "                    <td><input id=\"filtr\" type=\"text\" name=\"mac_filter\" value=\"".(isset($_SESSION['mac_filter']) ? $_SESSION['mac_filter'] : '')."\" size=\"10\"></td>\n";

  // vyhledani vsech ruznych hodnot pro filtr group
  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $sql = 'SELECT DISTINCT group_id, description FROM groups';
  }
  else if( is_admin() )
  {
    $sql = 'SELECT DISTINCT group_id, description FROM groups WHERE company_id = '.get_company_id( );
  }
  else
  {
    $sql = 'SELECT DISTINCT group_id, description FROM groups WHERE group_id IN(SELECT group_id FROM user_group WHERE user_id = "'.get_user_id( ).'")';
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);

  // vytvareni filtru data service
  $temp = "                    <td align=\"center\">\n";
  $temp = $temp."                      <select id=\"filtr\" name=\"group_filter\" size=\"1\">\n";
  $temp = $temp."                        <option value=\"\">\n";

  // vyzvednuti dat z odpovedi
  while (list($f_group_id, $f_description) = mysqli_fetch_row($result))
  {
    $temp = $temp."                        <option value=\"".urlencode($f_group_id)."\"".((isset($_SESSION['group_filter']) ? $f_group_id == $_SESSION['group_filter'] : false) ? ' selected' : '').">".(is_null($f_description) ? 'Group_'.$f_group_id : $f_description)."\n";

  }

  $temp = $temp."                      </select>\n";
  $temp = $temp."                    </td>\n";

  $filter["group"] = $temp;
  $filter["company"] = "                    <td></td>\n";
  $filter["uptime"] = "                    <td></td>\n";
  $filter["quality"] = "                    <td></td>\n";
  $filter["temp"] = "                    <td></td>\n";
  $filter["voltage"] = "                    <td></td>\n";
  $filter["snmp_prot"] = "                    <td></td>\n";
  $filter["name"] = "                    <td><input id=\"filtr\" type=\"text\" name=\"name_filter\" value=\"".(isset($_SESSION['name_filter']) ? $_SESSION['name_filter'] : '')."\" size=\"10\"></td>\n";

  foreach( $cols_selected as $id => $cell_name )
  {
    echo $filter[$cell_name];
  }


  // kontrola stavu prihlaseni
  if( is_admin() )
  {	// prihlasen, odesleme sloupec navic
    echo "                    <td colspan=\"2\"></td>\n";
    echo "                  </form id=\"filtr\">\n";
    echo "                    <td nowrap>\n";
    echo "                  <form id=\"devselect\" action=\"index.php\" method=\"get\">\n";
    echo "                    <input type=\"hidden\" name=\"page\" value=\"device_select\">\n";
    echo "                    <input type=\"submit\" name=\"sel\" value=\"Checked\" class=\"select_button1\">\n";
    echo "                    <input type=\"submit\" name=\"sel\" value=\"All\" class=\"select_button2\">\n";
    echo "                    </td>\n";
    echo "                  </tr>\n";
  }
  else
  {
    echo "                  </form id=\"filtr\">\n";
    echo "                  </tr>\n";
  }

  $sql = '';

  if((isset($_SESSION['desc_filter'])) && ($_SESSION['desc_filter'] != ''))
  {
    $sql = $sql.'AND description LIKE "%'.mysqli_real_escape_string($link,$_SESSION['desc_filter']).'%" ';
  }

  if((isset($_SESSION['host_filter'])) && ($_SESSION['host_filter'] != ''))
  {
    $sql = $sql.'AND hostname LIKE "%'.mysqli_real_escape_string($link,$_SESSION['host_filter']).'%" ';
  }

  if((isset($_SESSION['host_alt_filter'])) && ($_SESSION['host_alt_filter'] != ''))
  {
    $sql = $sql.'AND hostname_alt LIKE "%'.mysqli_real_escape_string($link,$_SESSION['host_alt_filter']).'%" ';
  }

  if((isset($_SESSION['host_alt_filter2'])) && ($_SESSION['host_alt_filter2'] != ''))
  {
    $sql = $sql.'AND hostname_alt2 LIKE "%'.mysqli_real_escape_string($link,$_SESSION['host_alt_filter2']).'%" ';
  }

  if((isset($_SESSION['prod_filter'])) && ($_SESSION['prod_filter'] != ''))
  {
    $sql = $sql.'AND product="'.mysqli_real_escape_string($link,$_SESSION['prod_filter']).'" ';
  }

  if((isset($_SESSION['loc_filter'])) && ($_SESSION['loc_filter'] != ''))
  {
    $sql = $sql.'AND location LIKE "%'.mysqli_real_escape_string($link,$_SESSION['loc_filter']).'%" ';
  }

  if((isset($_SESSION['note_filter'])) && ($_SESSION['note_filter'] != ''))
  {
    $sql = $sql.'AND note LIKE "%'.mysqli_real_escape_string($link,$_SESSION['note_filter']).'%" ';
  }

  if((isset($_SESSION['stat_filter'])) && ($_SESSION['stat_filter'] != ''))
  {
    $sql = $sql.'AND last_status="'.mysqli_real_escape_string($link,$_SESSION['stat_filter']).'" ';
  }

  if((isset($_SESSION['firm_filter'])) && ($_SESSION['firm_filter'] != ''))
  {
    $sql = $sql.'AND firmware="'.mysqli_real_escape_string($link,$_SESSION['firm_filter']).'" ';
  }

  if((isset($_SESSION['sn_filter'])) && ($_SESSION['sn_filter'] != ''))
  {
    $sql = $sql.'AND sn LIKE "%'.mysqli_real_escape_string($link,$_SESSION['sn_filter']).'%" ';
  }

  if((isset($_SESSION['imei_filter'])) && ($_SESSION['imei_filter'] != ''))
  {
    $sql = $sql.'AND imei LIKE "%'.mysqli_real_escape_string($link,$_SESSION['imei_filter']).'%" ';
  }

  if((isset($_SESSION['esn_filter'])) && ($_SESSION['esn_filter'] != ''))
  {
    $sql = $sql.'AND esn LIKE "%'.mysqli_real_escape_string($link,$_SESSION['esn_filter']).'%" ';
  }

  if((isset($_SESSION['mac_filter'])) && ($_SESSION['mac_filter'] != ''))
  {
    $sql = $sql.'AND mac LIKE "%'.mysqli_real_escape_string($link,$_SESSION['mac_filter']).'%" ';
  }

  if((isset($_SESSION['group_filter'])) && ($_SESSION['group_filter'] != ''))
  {
    $sql = $sql.'AND group_id="'.mysqli_real_escape_string($link,$_SESSION['group_filter']).'" ';
  }

  if((isset($_SESSION['name_filter'])) && ($_SESSION['name_filter'] != ''))
  {
    $sql = $sql.'AND name LIKE "%'.mysqli_real_escape_string($link,$_SESSION['name_filter']).'%" ';
  }

  /*
  // ziskani poctu jednotlivych stavu zarizeni
  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse

    $result = db_query($link,'create temporary table snmpmon.temp engine=memory select devices.group_id as dev_group_id,
                              health, health_alt, health_alt2, new FROM snmpmon.devices WHERE group_id IN (SELECT groups.group_id
                              FROM groups WHERE  enabled = 1  '.$sql);

    $result = db_query($link,'SELECT SUM(IF((health = 0) | (health_alt = 0) | (health_alt2 = 0),1,0)),
                              SUM(IF(((health > 0)&&(health<groups.max_fails)) | ((health_alt>0)&&(health_alt<groups.max_fails)) |
                                ((health_alt2 > 0)&&(health_alt2<groups.max_fails)),1,0)),
                              SUM(IF(health>=groups.max_fails,IF(health_alt>=groups.max_fails, IF(health_alt2>=groups.max_fails, 1, 0), 0),0)), SUM(IF((new = 1),1,0))
                              FROM snmpmon.temp LEFT JOIN snmpmon.groups ON dev_group_id = groups.group_id');
  }
  else if( is_admin() )
  {
    $result = db_query($link,'create temporary table snmpmon.temp engine=memory select devices.group_id as dev_group_id,
          health, health_alt, health_alt2, new FROM snmpmon.devices WHERE group_id IN (SELECT groups.group_id FROM groups WHERE company_id = '.get_company_id( ).')
                              AND enabled = 1  '.$sql);

    $result = db_query($link,'select SUM(IF((health = 0) | (health_alt = 0) | (health_alt2 = 0),1,0)),
                              SUM(IF(((health > 0) && (health < groups.max_fails)) | ((health_alt > 0) && (health_alt < groups.max_fails)) | ((health_alt2 > 0) && (health_alt2 < groups.max_fails)),1,0)),
                              SUM(IF(health>=groups.max_fails,IF(health_alt>=groups.max_fails, IF(health_alt2>=groups.max_fails, 1, 0), 0),0)),
                              SUM(IF(new = 1, 1,0 ))
                    from snmpmon.temp LEFT JOIN snmpmon.groups ON dev_group_id = groups.group_id');  }
  else
  {
    $result = db_query($link,'create temporary table snmpmon.temp engine=memory select devices.group_id as dev_group_id,
          health, health_alt, health_alt2, new FROM snmpmon.devices WHERE group_id IN (SELECT groups.group_id FROM groups
                 WHERE user_id = '.get_user_id( ).')
                              AND enabled = 1  '.$sql);
     $result = db_query($link,'select SUM(IF((health = 0) | (health_alt = 0) | (health_alt2 = 0),1,0)),
                              SUM(IF(((health > 0) && (health < groups.max_fails)) | ((health_alt > 0) && (health_alt < groups.max_fails)) | ((health_alt2 > 0) && (health_alt2 < groups.max_fails)),1,0)),
                              SUM(IF(health>=groups.max_fails,IF(health_alt>=groups.max_fails, IF(health_alt2>=groups.max_fails, 1, 0), 0),0)),
                              SUM(IF(new = 1, 1,0 ))
                    from snmpmon.temp LEFT JOIN snmpmon.groups ON dev_group_id = groups.group_id');  }

    }
     */


      // ziskani poctu jednotlivych stavu zarizeni
  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $result = db_query($link,'SELECT SUM(IF((health = 0) | (health_alt = 0) | (health_alt2 = 0),1,0)),
                                   SUM(IF(((health>0)&&(health<255)) | ((health_alt>0)&&(health_alt<255)) | ((health_alt2>0)&&(health_alt2<255)),1,0)),
                                   SUM(IF(health = 255,IF(health_alt = 255, IF(health_alt2 = 255, 1, 0), 0),0)),
                                     SUM(IF((new = 1),1,0))
                              FROM devices WHERE enabled = 1 '.$sql);
  }
  else if( is_admin() )
  {
// puvodni   $result = db_query($link,'SELECT SUM(IF((health = 0) | (health_alt = 0) | (health_alt2 = 0),1,0)), SUM(IF((health = 1) | (health_alt = 1) | (health_alt2 = 1),1,0)), SUM(IF(health = 2,IF(health_alt = 2, IF(health_alt2 = 2, 1, 0), 0),0)), SUM(IF((new = 1),1,0))
//                              FROM devices WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = '.get_company_id( ).') AND enabled = 1 '.$sql);

  //  $result = db_query($link,'SELECT SUM(IF((health = 90) | (health_alt = 0) | (health_alt2 = 0),1,0)),
  //                                   SUM(IF(((health>0) && (health<groups.max_fails)) | ((health_alt>0)&&(health_alt<groups.max_fails)) | ((health_alt2>0)&(health_alt2<max_fails)),1,0)),
  //                                   SUM(IF(health>=groups.max_fails,IF(health_alt>=groups.max_fails, IF(health_alt2>=groups.max_fails, 1, 0), 0),0)), SUM(IF((new = 1),1,0))
  //                            FROM devices,groups
  //                            WHERE devices.group_id IN (SELECT groups.group_id FROM groups,devices WHERE groups.company_id = '.get_company_id( ).')
  //                            AND enabled = 1 AND devices.group_id=groups.group_id '.$sql);


  /*
     $result = db_query($link,'SELECT SUM(IF((health = 90) | (health_alt = 0) | (health_alt2 = 0),1,0)),
                                     SUM(IF(((health>0) && (health<groups.max_fails)) | ((health_alt>0)&&(health_alt<groups.max_fails)) | ((health_alt2>0)&&(health_alt2<max_fails)),1,0)),
                                     SUM(IF(health>=groups.max_fails,IF(health_alt>=groups.max_fails, IF(health_alt2>=groups.max_fails, 1, 0), 0),0)), SUM(IF((new = 1),1,0))
                              FROM devices LEFT JOIN groups ON  devices.group_id=groups.group_id
                              WHERE devices.group_id IN (SELECT groups.group_id FROM groups WHERE company_id = '.get_company_id( ).')
                              AND enabled = 1 '.$sql);
   */
    $result = db_query($link,'create temporary table snmpmon.temp engine=memory select devices.group_id as dev_group_id,
          health, health_alt, health_alt2, new FROM snmpmon.devices WHERE group_id IN (SELECT groups.group_id FROM groups WHERE company_id = '.get_company_id( ).')
                              AND enabled = 1  '.$sql);

    $result = db_query($link,'select SUM(IF((health = 0) | (health_alt = 0) | (health_alt2 = 0),1,0)),
                              SUM(IF(((health > 0) && (health < groups.max_fails)) | ((health_alt > 0) && (health_alt < groups.max_fails)) | ((health_alt2 > 0) && (health_alt2 < groups.max_fails)),1,0)),
                              SUM(IF(health>=groups.max_fails,IF(health_alt>=groups.max_fails, IF(health_alt2>=groups.max_fails, 1, 0), 0),0)),
                              SUM(IF(new = 1, 1,0 ))
                    from snmpmon.temp LEFT JOIN snmpmon.groups ON dev_group_id = groups.group_id');


  //  $result = db_query($link,'SELECT SUM(IF((health = 90) | (health_alt = 0) | (health_alt2 = 0),1,0)),
  //  SUM(IF(((health > 0) && (health < groups.max_fails)) = 1) | ((health_alt > 0)&&(health_alt < groups.max_fails)) | ((health_alt2 > 0) && (health_2 < groups.max_fails))),1,0)),
  //  SUM(IF(health = 2,IF(health_alt = 2, IF(health_alt2 = 2, 1, 0), 0),0)), SUM(IF((new = 1),1,0))
  //                            FROM devices LEFT JOIN groups ON groups.group_id = devices.group_id WHERE enabled = 1 '.$sql);

  }
  else
  {
   // puvodni:
   // $result = db_query($link,'SELECT SUM(IF((health = 0) | (health_alt = 0) | (health_alt2 = 0),1,0)),
   //                                  SUM(IF((health = 1) | (health_alt = 1) | (health_alt2 = 1),1,0)),
   //                                  SUM(IF(health = 2,IF(health_alt = 2, IF(health_alt2 = 2, 1, 0), 0),0)), SUM(IF((new = 1),1,0))
   //                           FROM devices WHERE group_id IN (SELECT group_id FROM user_group WHERE user_id = '.get_user_id( ).') AND
   //                           enabled = 1 '.$sql);

   $result = db_query($link,'create temporary table snmpmon.temp engine=memory select devices.group_id as dev_group_id,
          health, health_alt, health_alt2, new FROM snmpmon.devices WHERE group_id IN (SELECT user_group.group_id FROM user_group
           WHERE user_id = '.get_user_id( ).') AND enabled = 1  '.$sql);
   $result = db_query($link,'select SUM(IF((health = 0) | (health_alt = 0) | (health_alt2 = 0),1,0)),
                              SUM(IF(((health > 0) && (health < groups.max_fails)) | ((health_alt > 0) && (health_alt < groups.max_fails)) | ((health_alt2 > 0) && (health_alt2 < groups.max_fails)),1,0)),
                              SUM(IF(health>=groups.max_fails,IF(health_alt>=groups.max_fails, IF(health_alt2>=groups.max_fails, 1, 0), 0),0)),
                              SUM(IF(new = 1, 1,0 ))
                    from snmpmon.temp LEFT JOIN snmpmon.groups ON dev_group_id = groups.group_id');

   // $result = db_query($link,'SELECT SUM(IF((health = 0) | (health_alt = 0) | (health_alt2 = 0),1,0)),
   //                                  SUM(IF(((health>0) && (health<groups.max_fails)) | ((health_alt>0)&&(health_alt<groups.max_fails)) | ((health_alt2>0)&(health_alt2<max_fails)),1,0)),
   //                                  SUM(IF(health>=groups.max_fails,IF(health_alt>=groups.max_fails, IF(health_alt2>=groups.max_fails, 1, 0), 0),0)), SUM(IF((new = 1),1,0))
   //                           FROM devices,groups
   //                           WHERE devices.group_id IN (SELECT user_group.group_id FROM user_group WHERE user_group.user_id = '.get_user_id( ).')
   //                           AND enabled = 1 AND devices.group_id=groups.group_id '.$sql);


  }


  // vyzvednuti dat z odpovedi
  list($health_green, $health_orange, $health_red, $health_blue) = mysqli_fetch_row($result);


  // ziskani poctu jednotlivych stavu zarizeni
  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $result = db_query($link,'SELECT COUNT(*)
                              FROM devices WHERE enabled = 0 '.$sql);
  }
  else if( is_admin() )
  {
    $result = db_query($link,'SELECT COUNT(*)
                              FROM devices WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = '.get_company_id( ).') AND enabled = 0 '.$sql);
  }
  else
  {
    $result = db_query($link,'SELECT COUNT(*)
                              FROM devices WHERE group_id IN (SELECT group_id FROM user_group WHERE user_id = '.get_user_id( ).') AND enabled = 0 '.$sql);
  }

  // vyzvednuti dat z odpovedi
  list($health_gray) = mysqli_fetch_row($result);

  if((isset($_SESSION['health_filter'])) && ($_SESSION['health_filter'] != ''))
  {
    if($_SESSION['health_filter'] != 3)
    {
      $sql = $sql.'AND health = "'.mysqli_real_escape_string($link,$_SESSION['health_filter']).'" ';
    }
    else
    { // v pripade, ze filter = 3 hledame routry s priznakem new
      $sql = $sql.'AND new = "1" ';
    }
  }

  if((isset($_SESSION['health_alt_filter'])) && ($_SESSION['health_alt_filter'] != ''))
  {
    if( $_SESSION['health_alt_filter'] != 3 )
    {
      $sql = $sql.'AND health_alt = "'.mysqli_real_escape_string($link,$_SESSION['health_alt_filter']).'" ';
    }
    else
    { // v pripade, ze filter = 3 hledame routry s priznakem new
      $sql = $sql.'AND new = "1" ';
    }
  }

  if((isset($_SESSION['health_alt_filter2'])) && ($_SESSION['health_alt_filter2'] != ''))
  {
    if( $_SESSION['health_alt_filter2'] != 3 )
    {
      $sql = $sql.'AND health_alt2 = "'.mysqli_real_escape_string($link,$_SESSION['health_alt_filter2']).'" ';
    }
    else
    { // v pripade, ze filter = 3 hledame routry s priznakem new
      $sql = $sql.'AND new = "1" ';
    }
  }

  $sql_filters = $sql;

  $count_info_mode = ($sql == "") ? 1 : 2;

  if((isset($_SESSION['ord'])) && ($_SESSION['ord'] != ''))
  {
    if( $_SESSION['ord'] == 'health' )
    {
      $sql = $sql.'ORDER BY enabled DESC, '.mysqli_real_escape_string($link,$_SESSION['ord']).' ';
    }
    else if($_SESSION['ord'] == 'health_alt')
    {
      $sql = $sql.'ORDER BY enabled DESC, LENGTH(hostname_alt) > 1 DESC, '.mysqli_real_escape_string($link,$_SESSION['ord']).' ';
    }
    else if($_SESSION['ord'] == 'health_alt2')
    {
      $sql = $sql.'ORDER BY enabled DESC, LENGTH(hostname_alt2) > 1 DESC, '.mysqli_real_escape_string($link,$_SESSION['ord']).' ';
    }
    else
    {
      $sql = $sql.'ORDER BY '.mysqli_real_escape_string($link,$_SESSION['ord']).' ';
    }
  }

  if((isset($_SESSION['dir'])) && ($_SESSION['dir'] != ''))
  {
    if($_SESSION['dir'] == 'down')
    {
      $sql = $sql.'DESC ';
    }
  }

  $_SESSION['sql_filters'] = $sql;

  $sql = $sql.'LIMIT '. (($set - 1) * $_SESSION['count_on_page']).','.$_SESSION['count_on_page'];

  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $sql = 'call sp_GetDevicesAll(\''.$sql.'\')';
  }
  else if( is_admin() )
  {
    $sql = 'call sp_GetDevicesCompany(\''.$sql.'\',\''.get_company_id().'\')';
  }
  else
  {
    $sql = 'call sp_GetDevicesUser(\''.$sql.'\',\''.get_user_id().'\')';
  }
  // vykonani SQL prikazu
	$result = db_multi_query($link, $sql);


  $i = 0;

  $dev_num            = array();
  $device_id          = array();
  $description        = array();
  $hostname           = array();
  $hostname_alt       = array();
  $hostname_alt2      = array();
  $location           = array();
  $coordinates        = array();
  $note               = array();
  $enabled            = array();
  $product            = array();
  $firmware           = array();
  $sn                 = array();
  $imei               = array();
  $esn                = array();
  $rx                 = array();
  $tx                 = array();
  $total              = array();
  $rx_alt             = array();
  $tx_alt             = array();
  $total_alt          = array();
  $rx_alt2            = array();
  $tx_alt2            = array();
  $total_alt2         = array();
  $level              = array();
  $network_status     = array();
  $autoupdate         = array();
  $healh_state        = array();
  $healh_state_alt    = array();
  $last_comm_time     = array();
  $last_comm_time_alt = array();
  $last_comm_time_alt2= array();
  $is_trap            = array();
  $mac                = array();
  $group              = array();
  $comp_name          = array();
  $uptime             = array();
  $is_new             = array();
  $quality            = array();
  $temperature        = array();
  $voltage            = array();
  $level_limit        = array();
  $traffic_limit      = array();
  $traffic_limit_alt  = array();
  $traffic_limit_alt2 = array();
  $temp_limit_lo      = array();
  $temp_limit_hi      = array();
  $volt_limit_lo      = array();
  $volt_limit_hi      = array();
  $qual_limit_lo      = array();
  $name               = array();
  $snmp_prot          = array();
  $max_fails          = array();

  // nacteni dat z odpovedi
  while (list($dev_num[$i],$device_id[$i],$description[$i],$hostname[$i], $hostname_alt[$i], $hostname_alt2[$i], $location[$i],
		  $coordinates[$i], $note[$i], $enabled[$i], $product[$i], $firmware[$i], $sn[$i], $imei[$i], $esn[$i], $tx[$i], $rx[$i],
		  $total[$i], $tx_alt[$i], $rx_alt[$i], $total_alt[$i], $tx_alt2[$i], $rx_alt2[$i], $total_alt2[$i], $level[$i],
		  $network_status[$i], $autoupdate[$i], $healh_state[$i], $healh_state_alt[$i], $healh_state_alt2[$i],
		  $last_comm_time[$i], $last_comm_time_alt[$i], $last_comm_time_alt2[$i], $is_trap[$i], $mac[$i], $group[$i],
		  $comp_name[$i], $uptime[$i], $is_new[$i], $quality[$i], $temperature[$i], $voltage[$i], $level_limit[$i],
		  $traffic_limit[$i], $traffic_limit_alt[$i], $traffic_limit_alt2[$i], $temp_limit_lo[$i], $temp_limit_hi[$i],
		  $volt_limit_lo[$i], $volt_limit_hi[$i], $qual_limit_lo[$i], $name[$i], $max_fails[$i], $snmp_prot[$i]) = mysqli_fetch_row($result))
  {
    $i++;
  }

	if(mysqli_more_results($link))
	{	//Catch 'OK'/'ERR'
		while(mysqli_next_result($link));
	}

  $totals = array('total' => 0, 'total_alt' => 0, 'total_alt2' => 0);
  // ziskani rx, tx, level pro kazde zarizeni
  for($j = 0;$j < $i;$j++)
  {

// kontrola hodnot
    $description[$j]    = is_null($description[$j]) ? "---" : $description[$j];
    $hostname[$j]       = is_null($hostname[$j]) || (strlen($hostname[$j]) < 3) ? "Not read" : $hostname[$j];
    $hostname_alt[$j]   = is_null($hostname_alt[$j]) || (strlen($hostname_alt[$j]) < 3) ? "---" : $hostname_alt[$j];
    $hostname_alt2[$j]  = is_null($hostname_alt2[$j]) || (strlen($hostname_alt2[$j]) < 3) ? "---" : $hostname_alt2[$j];
    $location[$j]       = is_null($location[$j]) ? "---" : $location[$j];
    $note[$j]           = is_null($note[$j]) ? "---" : $note[$j];
    $network_status[$j] = is_null($network_status[$j]) ? "---" : decoding_network_status($network_status[$j]);
    $product[$j]        = is_null($product[$j]) ? "---" : $product[$j];
    
    if (mb_strpos($firmware[$j], " ") == false)
    $firmware[$j]       = is_null($firmware[$j]) ? "---" : substr($firmware[$j], 0, 6)."..";
    else
    
    $firmware[$j]       = is_null($firmware[$j]) ? "---" : substr($firmware[$j], 0, 6);
    $sn[$j]             = is_null($sn[$j]) ? "---" : $sn[$j];
    $imei[$j]           = is_null($imei[$j]) ? "---" : $imei[$j];
    $esn[$j]            = is_null($esn[$j]) ? "---" : $esn[$j];
    $tx[$j]             = is_null($tx[$j]) ? "---" : ConvertNumBytes($tx[$j]);
    $rx[$j]             = is_null($rx[$j]) ? "---" : ConvertNumBytes($rx[$j]);
    $tx_alt[$j]         = is_null($tx_alt[$j]) ? "---" : ConvertNumBytes($tx_alt[$j]);
    $rx_alt[$j]         = is_null($rx_alt[$j]) ? "---" : ConvertNumBytes($rx_alt[$j]);
    $tx_alt2[$j]        = is_null($tx_alt[$j]) ? "---" : ConvertNumBytes($tx_alt2[$j]);
    $rx_alt2[$j]        = is_null($rx_alt[$j]) ? "---" : ConvertNumBytes($rx_alt2[$j]);
    $mac[$j]            = is_null($mac[$j]) ? "---" : $mac[$j];
    $uptime[$j]         = is_null($uptime[$j]) ? "---" : UptimeToStr($uptime[$j]);
    $name[$j]           = is_null($name[$j]) ? "---" : $name[$j];
    $snmp_prot[$j]      = is_null($snmp_prot[$j]) ? "---" : ($snmp_prot[$j] == 0 ? 'SNMP V1' : 'SNMP V3');

    // prevod stavu na css styl
    if($enabled[$j] == 1)
    {
      if(!is_null($healh_state[$j]))
      {
        if($hostname[$j] != "---" )
        {
          if( $is_new[$j] == 0 )
          {
            switch($healh_state[$j])
            {
              case "0": $host_style = 'class="health_green"'; break;
              case "1": $host_style = 'class="health_orange"'; break;
              case "2": if(($healh_state_alt[$j] == "2") && ($healh_state_alt2[$j] == "2"))
                        {
                          $host_style = 'class="health_red"'; break;
                        }
                        else
                        {
                          $host_style = 'class="health_gray"'; break;
                        }
              default: $host_style = ''; break;
            }
          }
          else
          {
            $host_style = 'class="health_blue"';
          }
        }
        else
        {
          $host_style = '';
        }
      }
      else
      {
        $host_style = '';
      }
    }
    else
    {
      if(	$hostname[$j] != "---" )
      {
        $host_style = 'class="health_dark_gray"';
      }
    }

    // prevod stavu na css styl
    $host_alt_style = '';
    if($enabled[$j] == 1)
    {
      if(!is_null($healh_state_alt[$j]))
      {
        if($hostname_alt[$j] != "---" )
        {
          if( $is_new[$j] == 0 )
          {
            switch($healh_state_alt[$j])
            {
              case "0": $host_alt_style = 'class="health_green"'; break;
              case "1": $host_alt_style = 'class="health_orange"'; break;
              case "2": if(($healh_state[$j] == "2") && ($healh_state_alt2[$j] == "2"))
                        {
                          $host_alt_style = 'class="health_red"'; break;
                        }
                        else
                        {
                          $host_alt_style = 'class="health_gray"'; break;
                        }
              default: $host_alt_style = ''; break;
            }
          }
          else
          {
            $host_alt_style = 'class="health_blue"';
          }
        }
      }
    }
    else
    {
      if($hostname_alt[$j] != "---" )
      {
        $host_alt_style = 'class="health_dark_gray"';
      }
    }

    // prevod stavu na css styl
    $host_alt_style2 = '';
    if($enabled[$j] == 1)
    {
      if(!is_null($healh_state_alt2[$j]))
      {
        if($hostname_alt2[$j] != "---" )
        {
          if( $is_new[$j] == 0 )
          {
            switch($healh_state_alt2[$j])
            {
              case "0": $host_alt_style2 = 'class="health_green"'; break;
              case "1": $host_alt_style2 = 'class="health_orange"'; break;
              case "2": if(($healh_state[$j] == "2") && ($healh_state_alt[$j] == "2"))
                        {
                          $host_alt_style2 = 'class="health_red"'; break;
                        }
                        else
                        {
                          $host_alt_style2 = 'class="health_gray"'; break;
                        }
              default: $host_alt_style2 = ''; break;
            }
          }
          else
          {
            $host_alt_style2 = 'class="health_blue"';
          }
        }
      }
    }
    else
    {
      if(	$hostname_alt2[$j] != "---" )
      {
        $host_alt_style2 = 'class="health_dark_gray"';
      }
    }

    $last_comm_time[$j] = is_null($last_comm_time[$j]) ? "---" : $last_comm_time[$j];
    $last_comm_time_alt[$j] = is_null($last_comm_time_alt[$j]) ? "---" : $last_comm_time_alt[$j];

    $sql = 'SELECT COUNT(*) FROM selection WHERE device_id = "'.mysqli_real_escape_string($link,$device_id[$j]).'" AND session_id = "'.session_id().'"';

    // vykonani SQL prikazu
    $result = db_query($link, $sql);

    list($selected) = mysqli_fetch_row($result);

    $cell = array();
    $cell_csv = array();

    // vytvoreni jednoho radku tabulky
    echo "                  <tr align=\"center\" class=\"tab_line".($j % 2)."\" height=\"27px\">\n";
    echo "                    <td>".$dev_num[$j]."</td>\n";

    if($hostname[$j] != "0.0.0.0")
    {
      $temp = "<td ".$host_style." nowrap><table width=\"100%\"><tr><td><div style=\"width:110px;overflow:hidden;white-space: nowrap;\"><a href=\"index.php?page=device_status&device_id=".$device_id[$j]."\" title=\"Last successful reading: ".$last_comm_time[$j]."\">".$hostname[$j]."</div></a></td>\n";
// s SSH tlacitkem        $cell[0] = $cell[0]."                    <td align=\"right\"><input type=\"button\" align=\"right\" id=\"ping_button\" onclick=\"javascript:window.open('php/ping.php?hostname=".$hostname[$j]."&color_scheme=".$_SESSION['Web.color_scheme']."','_blank','height=600,width=550,left=100, top=100,resizable=no,scrollbars=no');\" value=\"Ping\"><input type=\"button\" align=\"right\" id=\"ssh_button\" onclick=\"javascript:window.open('php/ssh_form.php?hostname=".$hostname[$j]."&color_scheme=".$_SESSION['Web.color_scheme']."','_blank','height=815,width=1055,left=100, top=100,resizable=no,scrollbars=no');\" value=\"SSH\"></td>\n";
      if( $hostname[$j] != "Not read" )
      {
        $temp = $temp."                    <td align=\"right\"><input type=\"button\" align=\"right\" id=\"ping_button\" onclick=\"javascript:window.open('index.php?page=ping&hostname=".$hostname[$j]."','_blank','height=600,width=550,left=100, top=100,resizable=no,scrollbars=no,location=yes');\" value=\"Ping\"></td>\n";
      }
      $temp = $temp."                        </tr>\n";
      $temp = $temp."                      </table>\n";
      $temp = $temp."                    </td>\n";
      $temp_cvs = $hostname[$j];
    }
    else
    {
      $temp = "                    <td ".$host_style." nowrap><a href=\"index.php?page=device_status&device_id=".$device_id[$j]."\" title=\"Last successful reading: ".$last_comm_time[$j]."\">Behind NAT</div></a></td>\n";
      $temp_cvs = "Behind NAT";
    }


    $cell["hostname"] = $temp;
    $cell_csv["hostname"] = $temp_cvs;

    if( ($hostname_alt[$j] == '---') || ($hostname_alt[$j] == '') )
    {
      $temp = "<td ".$host_alt_style." nowrap>".$hostname_alt[$j]."</a></td>\n";
      $temp_cvs = $hostname_alt[$j];
    }
    else
    {
      if($hostname_alt[$j] != "0.0.0.0")
      {
        $temp = "                    <td ".$host_alt_style." nowrap><table width=\"100%\"><tr><td><div style=\"width:110px;overflow:hidden;white-space: nowrap;\"><a href=\"index.php?page=device_status&device_id=".$device_id[$j]."\" title=\"Last successful reading: ".$last_comm_time_alt[$j]."\">".$hostname_alt[$j]."</div></a></td>\n";
        /*        $temp = $temp."                    <td align=\"right\"><input type=\"button\" align=\"right\" id=\"ping_button\" onclick=\"javascript:window.open('php/ping.php?hostname=".$hostname_alt[$j]."&color_scheme=".$_SESSION['Web.color_scheme']."','_blank','height=600,width=550,left=100, top=100,resizable=no,scrollbars=no');\" value=\"Ping\"><input type=\"button\" align=\"right\" id=\"ssh_button\" onclick=\"javascript:window.open('php/ssh_form.php?hostname=".$hostname_alt[$j]."&color_scheme=".$_SESSION['Web.color_scheme']."','_blank','height=815,width=1055,left=100, top=100,resizable=no,scrollbars=no');\" value=\"SSH\"></td>\n";*/
$temp = $temp."                    <td align=\"right\"><input type=\"button\" align=\"right\" id=\"ping_button\" onclick=\"javascript:window.open('index.php?page=ping&hostname=".$hostname_alt[$j]."','_blank','height=600,width=550,left=100, top=100,resizable=no,scrollbars=no');\" value=\"Ping\"></td>\n";

        $temp = $temp."                        </tr>\n";
        $temp = $temp."                      </table>\n";
        $temp = $temp."                    </td>\n";
        $temp_cvs = $hostname_alt[$j];
      }
      else
      {
        $temp = "<td ".$host_alt_style." nowrap><a href=\"index.php?page=device_status&device_id=".$device_id[$j]."\" title=\"Last successful reading: ".$last_comm_time_alt[$j]."\">Behind NAT</div></a></td>\n";
        $temp_cvs = "Behind NAT";
      }
    }

    $cell["hostname_alt"] = $temp;
    $cell_csv["hostname_alt"] = $temp_cvs;

    if( ($hostname_alt2[$j] == '---') || ($hostname_alt2[$j] == '') )
    {
      $temp = "<td ".$host_alt_style2." nowrap>".$hostname_alt2[$j]."</a></td>\n";
      $temp_cvs = $hostname_alt2[$j];
    }
    else
    {
      if($hostname_alt2[$j] != "0.0.0.0")
      {
        $temp = "                    <td ".$host_alt_style2." nowrap><table width=\"100%\"><tr><td><div style=\"width:110px;overflow:hidden;white-space: nowrap;\"><a href=\"index.php?page=device_status&device_id=".$device_id[$j]."\" title=\"Last successful reading: ".$last_comm_time_alt2[$j]."\">".$hostname_alt2[$j]."</div></a></td>\n";
        /*        $temp = $temp."                    <td align=\"right\"><input type=\"button\" align=\"right\" id=\"ping_button\" onclick=\"javascript:window.open('php/ping.php?hostname=".$hostname_alt[$j]."&color_scheme=".$_SESSION['Web.color_scheme']."','_blank','height=600,width=550,left=100, top=100,resizable=no,scrollbars=no');\" value=\"Ping\"><input type=\"button\" align=\"right\" id=\"ssh_button\" onclick=\"javascript:window.open('php/ssh_form.php?hostname=".$hostname_alt[$j]."&color_scheme=".$_SESSION['Web.color_scheme']."','_blank','height=815,width=1055,left=100, top=100,resizable=no,scrollbars=no');\" value=\"SSH\"></td>\n";*/
$temp = $temp."                    <td align=\"right\"><input type=\"button\" align=\"right\" id=\"ping_button\" onclick=\"javascript:window.open('index.php?page=ping&hostname=".$hostname_alt2[$j]."','_blank','height=600,width=550,left=100, top=100,resizable=no,scrollbars=no');\" value=\"Ping\"></td>\n";

        $temp = $temp."                        </tr>\n";
        $temp = $temp."                      </table>\n";
        $temp = $temp."                    </td>\n";
        $temp_cvs = $hostname_alt2[$j];
      }
      else
      {
        $temp = "<td ".$host_alt_style2." nowrap><a href=\"index.php?page=device_status&device_id=".$device_id[$j]."\" title=\"Last successful reading: ".$last_comm_time_alt2[$j]."\">Behind NAT</div></a></td>\n";
        $temp_cvs = "Behind NAT";
      }
    }

    $cell["hostname_alt2"] = $temp;
    $cell_csv["hostname_alt2"] = $temp_cvs;

    $cell["description"] = "<td nowrap title=\"".$description[$j]."\"><div style=\"width:147px;overflow:hidden;white-space: nowrap;\">".$description[$j]."</div></td>\n";
    $cell_csv["description"] = $description[$j];

    if (preg_match('/(-?[0-9]?[0-9]?[0-9].[0-9]{5,},?){2}/', $coordinates[$j]))
    { // mame gps souradnice
            //$temp = "                    <td nowrap title=\"".$location[$j]."\"><table width=\"100%\"><tr><td nowrap><div style=\"width:96px;overflow:hidden;white-space: nowrap;\">".$location[$j]."</div></td><td align=\"right\"><input type=\"button\" align=\"right\" id=\"map_button\" onclick=\"openChild('index.php?page=device_map&device_id=".$device_id[$j]."&color_scheme=".$_SESSION['Web.color_scheme']."','win2','800','600')\" value=\"Map\"></td></tr></table></td>\n";
      //$temp = "<td nowrap title=\"".$location[$j]."\"><a href=\"javascript:void(0);\" onclick=\"openChild('http://maps.google.com?q=".$coordinates[$j]." (".$product[$j].(!is_null($description[$j]) ? ' - '.$description[$j] : '').")&output=embed','win2','800','600')\"><div style=\"width:96px;overflow:hidden;white-space: nowrap;\">".$location[$j]."</div></a></td>\n";
      $desc_temp=$description[$j];
      $dis_char="'";
      if (mb_strpos($desc_temp, $dis_char) !== false) 
      {
        $desc_temp = str_replace($dis_char, ' ', $desc_temp);
      }
      $temp = "                    <td nowrap title=\"".$location[$j]."\"><table width=\"100%\"><tr><td nowrap align=\"center\"><div style=\"width:96px;overflow:hidden;white-space: nowrap;\">".$location[$j]."</div></td><td align=\"right\"><input type=\"button\" align=\"right\" id=\"map_button\" onclick=\"openChild('http://maps.google.com?q=".$coordinates[$j]." (".$product[$j].(!is_null($desc_temp) ? ' - '.$desc_temp : '').")&output=embed','win2','800','600')\" value=\"Map\"></td></tr></table></td>\n";
    }
    else
    { // nemame gps souradnice
      $temp = "<td nowrap title=\"".$location[$j]."\"><div style=\"width:147px;overflow:hidden;white-space: nowrap;\">".$location[$j]."</div></td>\n";
    }

    $cell["location"] = $temp;
    $cell_csv["location"] = $location[$j];

    $cell["device"] = "<td nowrap>".$product[$j]."</td>\n";
    $cell_csv["device"] = $product[$j];

    $cell["note"] = "<td title=\"".$note[$j]."\"><div style=\"width:147px;overflow:hidden;white-space: nowrap;\">".$note[$j]."</td></td>\n";
    $cell_csv["note"] = $note[$j];

    $cell["tx"] = "<td nowrap>".$tx[$j]."</td>\n";
    $cell_csv["tx"] = $tx[$j];

    $cell["rx"] = "<td nowrap>".$rx[$j]."</td>\n";
    $cell_csv["rx"] = $rx[$j];

    if( is_null($total[$j]) )
    {
      $cell["total"] = "<td nowrap>---</td>\n";
      $cell_csv["total"] = "---";
    }
    else
    {
      $cell_style = "";

      if( !is_null( $traffic_limit[$j] ) )
      {
        if( $total[$j] > $traffic_limit[$j] )
        {
          $cell_style = " class=\"out_of_range\" title=\"Value is higher than limit ".round($traffic_limit[$j] / 1000000,1)." MB\"";
        }
      }

      $cell["total"] = "<td nowrap".$cell_style.">".ConvertNumBytes($total[$j])."</td>\n";
      $cell_csv["total"] = $total[$j];
      $totals['total'] += $total[$j];
    }

    $cell["tx_alt"] = "<td nowrap>".$tx_alt[$j]."</td>\n";
    $cell_csv["tx_alt"] = $tx_alt[$j];

    $cell["rx_alt"] = "<td nowrap>".$rx_alt[$j]."</td>\n";
    $cell_csv["rx_alt"] = $rx_alt[$j];

    if( is_null($total_alt[$j]) )
    {
      $cell["total_alt"] = "<td nowrap>---</td>\n";
      $cell_csv["total_alt"] = "---";
    }
    else
    {
      $cell_style = "";

      if( !is_null( $traffic_limit_alt[$j] ) )
      {
        if( $total_alt[$j] > $traffic_limit_alt[$j] )
        {
          $cell_style = " class=\"out_of_range\" title=\"Value is higher than limit ".round($traffic_limit_alt[$j] / 1000000,1)." MB\"";
        }
      }

      $cell["total_alt"] = "<td nowrap".$cell_style.">".ConvertNumBytes($total_alt[$j])."</td>\n";
      $cell_csv["total_alt"] = $total_alt[$j];
      $totals['total_alt'] += $total_alt[$j];

    }

    $cell["tx_alt2"] = "<td nowrap>".$tx_alt2[$j]."</td>\n";
    $cell_csv["tx_alt2"] = $tx_alt2[$j];

    $cell["rx_alt2"] = "<td nowrap>".$rx_alt2[$j]."</td>\n";
    $cell_csv["rx_alt2"] = $rx_alt[$j];

    if( is_null($total_alt2[$j]) )
    {
      $cell["total_alt2"] = "<td nowrap>---</td>\n";
      $cell_csv["total_alt2"] = "---";
    }
    else
    {
      $cell_style = "";

      if( !is_null( $traffic_limit_alt2[$j] ) )
      {
        if( $total_alt2[$j] > $traffic_limit_alt2[$j] )
        {
          $cell_style = " class=\"out_of_range\" title=\"Value is higher than limit ".round($traffic_limit_alt2[$j] / 1000000,1)." MB\"";
        }
      }

      $cell["total_alt2"] = "<td nowrap".$cell_style.">".ConvertNumBytes($total_alt2[$j])."</td>\n";
      $cell_csv["total_alt2"] = $total_alt2[$j];
      $totals['total_alt2'] += $total_alt2[$j];

    }

    if( is_null($level[$j]) )
    {
      $cell["level"] = "<td nowrap>---</td>\n";
      $cell_csv["level"] = "---";
    }
    else
    {
      $cell_style = "";

      if( !is_null( $level_limit[$j] ) )
      {
        if( $level[$j] < $level_limit[$j] )
        {
          $cell_style = " class=\"out_of_range\" title=\"Value is worse than limit ".$level_limit[$j]." dBm\"";
        }
      }

      $cell["level"] = "<td nowrap".$cell_style.">".$level[$j]." dBm</td>\n";
      $cell_csv["level"] = $level[$j];

    }

    $cell["data_service"] = "<td>".$network_status[$j]."</td>\n";
    $cell_csv["data_service"] = $network_status[$j];

    $cell["firmware"] = "<td nowrap>".$firmware[$j]."</td>\n";
    $cell_csv["firmware"] = $firmware[$j];

    // pripojime doplnujici sloupce dle stavu prihlaseni
    if( is_admin() )
    {	// zobrazime vse vcetne editace
      $cell["enabled"] = "<td><input type=\"checkbox\" onclick=\"do_link('index.php?page=device_change&oper=change_enabled&enabled=".($enabled[$j] ? "0" : "1")."&device_id=".$device_id[$j]."','Are you sure?');\" ".($enabled[$j] ? "checked" : "")."></td>\n";
      $cell["autoupdate"] = "<td><input type=\"checkbox\" onclick=\"do_link('index.php?page=device_change&oper=change_autoupdate&autoupdate=".($autoupdate[$j] ? "0" : "1")."&device_id=".$device_id[$j]."','Are you sure?');\" ".($autoupdate[$j] ? "checked" : "")."></td>\n";
    }
    else
    {	// zobrazime vse pouze pro cteni
      $cell["enabled"] = "<td><input type=\"checkbox\" disabled ".($enabled[$j] ? "checked" : "")."></td>\n";
      $cell["autoupdate"] = "<td><input type=\"checkbox\" disabled ".($autoupdate[$j] ? "checked" : "")."></td>\n";
    }

    $cell_csv["enabled"] = $enabled[$j];
    $cell_csv["autoupdate"] = $autoupdate[$j];

    $cell["report"] = "<td nowrap><input type=\"button\" id=report_button onclick=\"javascript:window.open('index.php?page=report_form&data_src=host&host=".$hostname[$j]."','_self');\" value=\"Report\"></td>\n";
    $cell_csv["report"] = "";

    $cell["sn"] = "<td nowrap>".$sn[$j]."</td>\n";
    $cell_csv["sn"] = $sn[$j];

    $cell["imei"] = "<td nowrap>".$imei[$j]."</td>\n";
    $cell_csv["imei"] = $imei[$j];

    $cell["esn"] = "<td nowrap>".$esn[$j]."</td>\n";
    $cell_csv["esn"] = $esn[$j];

    $cell["access_mode"] = "<td nowrap>".($is_trap[$j] == '0' ? 'Polling' : 'Trap')."</td>\n";
    $cell_csv["access_mode"] = ($is_trap[$j] == '0' ? 'Polling' : 'Trap');

    $cell["mac"] = "<td nowrap>".$mac[$j]."</td>\n";
    $cell_csv["mac"] = $mac[$j];

    $cell["group"] = "<td nowrap>".$group[$j]."</td>\n";
    $cell_csv["group"] = $group[$j];

    $cell["company"] = "<td nowrap>".$comp_name[$j]."</td>\n";
    $cell_csv["company"] = $comp_name[$j];

    $cell["uptime"] = "<td nowrap>".$uptime[$j]."</td>\n";
    $cell_csv["uptime"] = $uptime[$j];


    if( is_null($quality[$j]) )
    {
      $cell["quality"] = "<td nowrap>---</td>\n";
      $cell_csv["quality"] = "---";
    }
    else
    {
      $cell_style = "";

      if( !is_null( $qual_limit_lo[$j] ) )
      {
        if( $quality[$j] < $qual_limit_lo[$j] )
        {
          $cell_style = " class=\"out_of_range\" title=\"Value is worse than limit ".$qual_limit_lo[$j]." dB\"";
        }
      }

      $cell["quality"] = "<td nowrap".$cell_style.">".$quality[$j]." dB</td>\n";
      $cell_csv["quality"] = $quality[$j];

    }

    if( is_null($temperature[$j]) )
    {
      $cell["temp"] = "<td nowrap>---</td>\n";
      $cell_csv["temp"] = "---";
    }
    else
    {
      $cell_style = "";

      if( !is_null( $temp_limit_lo[$j] ) )
      {
        if( $temperature[$j] < $temp_limit_lo[$j] )
        {
          $cell_style = " class=\"out_of_range\" title=\"Value is lower than limit ".$temp_limit_lo[$j]." &deg;C\"";
        }
      }

      if( !is_null( $temp_limit_hi[$j] ) )
      {
        if( $temperature[$j] > $temp_limit_hi[$j] )
        {
          $cell_style = " class=\"out_of_range\" title=\"Value is higher than limit ".$temp_limit_hi[$j]." &deg;C\"";
        }
      }

      $cell["temp"] = "<td nowrap".$cell_style.">".$temperature[$j]." &deg;C</td>\n";
      $cell_csv["temp"] = $temperature[$j];

    }

    if( is_null($voltage[$j]) )
    {
      $cell["voltage"] = "<td nowrap>---</td>\n";
      $cell_csv["voltage"] = "---";
    }
    else
    {
      $cell_style = "";

      if( !is_null( $volt_limit_lo[$j] ) )
      {
        if( $voltage[$j] < $volt_limit_lo[$j] )
        {
          $cell_style = " class=\"out_of_range\" title=\"Value is lower than limit ".$volt_limit_lo[$j]." V\"";
        }
      }

      if( !is_null( $volt_limit_hi[$j] ) )
      {
        if( $voltage[$j] > $volt_limit_hi[$j] )
        {
          $cell_style = " class=\"out_of_range\" title=\"Value is higher than limit ".$volt_limit_hi[$j]." V\"";
        }
      }

      $cell["voltage"] = "<td nowrap".$cell_style.">".round( $voltage[$j], 1)." V</td>\n";
      $cell_csv["voltage"] = $voltage[$j];

    }

    $cell["name"] = "<td nowrap title=\"".$name[$j]."\"><div style=\"width:COL_NAME_WIDTHpx;overflow:hidden;white-space: nowrap;\">".$name[$j]."</div></td>\n";
    $cell_csv["name"] = $name[$j];

	$cell["snmp_prot"] = "<td>" . $snmp_prot[$j] . "</td>\n";
	$cell_csv["snmp_prot"] = $snmp_prot[$j];

    foreach( $cols_selected as $id => $cell_name )
    {
      echo "                    ".$cell[$cell_name];
      fwrite($csv,",\"".$cell_csv[$cell_name]."\"");
    }

    fwrite($csv,"\n");

    // pripojime doplnujici sloupce dle stavu prihlaseni
    if( is_admin() )
    {	// zobrazime vse vcetne editace
      echo "                    <td><img src=\"img/pencil.png\" border=\"0\" valign=\"center\" onclick=\"window.open('index.php?page=device_status&device_id=".$device_id[$j]."&sub_stat=device_status_edit','_self')\" title=\"Edit device\"></td>\n";
      echo "                    <td><img src=\"img/cross.png\" border=\"0\" valign=\"center\" onclick=\"do_link('index.php?page=device_change&oper=remove&remove_devID=".$device_id[$j]."','Are you sure?');\" title=\"Remove device\"></td>\n";
      echo "                    <td><input id=\"devselect\" type=\"checkbox\" name=\"checkbox".$j."\" value=\"".$device_id[$j]."\" ".($selected ? "checked":"")."></td>\n";
    }
    echo "                  </tr>\n";
  }
  echo '<tr><td nowrap width="50px" height="25px" align="center" class="header">SUM</td>';
  foreach( $cols_selected as $id => $cell_name )
  {
       if (in_array($cell_name, array('total', 'total_alt', 'total_alt2'))) {
           echo "                    <td class=\"header\" align=\"center\">" . ConvertNumBytes($totals[$cell_name]) . "</td>";
       } else {
           echo "                    <td class=\"header\">&nbsp;</td>";
       }
  }
  echo '</tr>';

  if( is_admin() )
  {
    echo "                  </form id=\"devselect\">\n";
  }

  // ziskani poctu vsech zarizeni vyhovujicich filtru
  if( is_superadmin() && ($company_id == 0) )
  { // prihlaseny superadmin, ktery nema vybranou konkretni firmu uvidi vse
    $sql = 'SELECT COUNT(*) FROM devices WHERE "" = "" '.$sql_filters;
  }
  else if( is_admin() )
  {
    $sql = 'SELECT COUNT(*) FROM devices WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = '.get_company_id( ).') '.$sql_filters;
  }
  else
  {
    $sql = 'SELECT COUNT(*) FROM devices WHERE group_id IN (SELECT group_id FROM user_group WHERE user_id = '.get_user_id( ).') '.$sql_filters;
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);

  // nacteni dat z odpovedi
  list($count_filtered) = mysqli_fetch_row($result);

  // uvolneni pameti
  mysqli_free_result($result);
  // uzavreni spojeni s DB
  mysqli_close($link);

?>
                </table>
              </td>
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td align="left">
                      <table>
                        <tr>
                          <td>
                            <form action="index.php" method="get">
                              <input type="hidden" name="page" value="device_status">
                              <label for="openhostname">Open Hostname</label>
                              <input type="text" name="hostname" id="openhostname" size="10">
                            </form>
                          </td>
                        </tr>
<?php

  if( $cfg['user_link_target'] != '')
  {
    echo "                        <tr>\n";
    echo "                          <td><a href=\"http://".$cfg['user_link_target']."\">".($cfg['user_link_text'] == '' ? $cfg['user_link_target'] : $cfg['user_link_text'])."</a></td>\n";
    echo "                        </tr>\n";
  }

?>
                      </table>
                    </td>
                    <td align="center">
                      <table>
                        <tr>
                          <td align="center" colspan="4">
<?php
  if($count_info_mode == 2)
  {
    echo "                            Found ".$count_filtered." devices of ".$count_all_devices."\n";
  }
  else
  {
    echo "                            ".$count_all_devices." devices\n";
  }
?>
                          </td>
                        </tr>
                        <tr height="20px">
                          <td class="health_green" width="50px" title="Online devices" align="center"><?php echo($health_green)?></td>
                          <td class="health_orange" width="50px" title="Devices with the first error in reading" align="center"><?php echo($health_orange)?></td>
                          <td class="health_red" width="50px" title="Offline devices" align="center"><?php echo($health_red)?></td>
                          <td class="health_dark_gray" width="50px" title="Disabled devices" align="center"><?php echo($health_gray)?></td>
                          <td class="health_blue" width="50px" title="New devices" align="center"><?php echo($health_blue)?></td>
                        </tr>
                      </table>
                    </td>
                    <td align="right">
<?php

// generovani tlacitek strankovani

  // funkce pro vytvoreni odkazu
  function getPageLink($i, $page)
  {
    if($i == $page)
    {	// aktualni stranka nebude odkazem
      return "                        <td class=\"aktivni\">". $i ."</td>\n";
    }
    // odkaz na stranku
    return "                        <td><a href=\"".($i != 1 ? '?set='.$i : '.')."\">".$i."</a></td>\n";
  }

  // celkovy pocet stranek
  $maxset = ceil($count_filtered/$_SESSION['count_on_page']);

  // pocet okolnich stranek
  $neighbours = 9;

  echo "                      <table class=\"navlist\">\n";
  echo "                        <tr>\n";

  // odkaz na prvni stranku bude vzdy
  echo(getPageLink(1, $set));

  if($set > $neighbours)
  {	// stranka po prvni strance je dale nez $neighbours
    echo "                        <td>...</td>\n";
  }

  // pocet stranek mezi
  $to = min($maxset, $set + $neighbours);
  for($i = max(2, $set - $neighbours + 1); $i < $to; $i++)
  {	// generovani prostrednich stranek
    echo(getPageLink($i, $set));
  }

  if($set + $neighbours < $maxset)
  {	// stranka pred posledni strankou je dale nez $neighbours
    echo "                        <td>...</td>\n";
  }

  if($maxset > 1)
  {	// odkaz na posledni stranku bude vzdy
    echo(getPageLink($maxset, $set));
  }
  echo "                        </tr>\n";
  echo "                      </table>\n";
?>
                      <a href=index.php?on_page=25>25</a> | <a href=index.php?on_page=100>100</a> | <a href=index.php?on_page=1000>1000</a> devices per page
                      <form style="margin-bottom: 0px" action="index.php" method="get">
                        <a href="index.php?page=csv_export&name=Device_List_<?php echo date("d_m_Y_H_i", time())?>.csv">CSV</a> |
                        <a href="index.php?page=device_list_csv">CSV(All Devices)</a> |
                        <label for="gotopage">Go to page</label>
                        <input type="text" name="set" id="gotopage" size="3">
                      </form>
                    </td>
                  </tr>
                </table>
                <style>
                  #table_header{
                    position: absolute;
                    visibility: hidden;
                  }
                </style>
                <div id="table_header">
                  <table cellspacing="0" cellpadding="1" border="1" style="border-collapse:collapse;" width="100%">
                    <tr>
                      <td nowrap align="center" class="header" width="50px" height="25px"><a href="index.php?page=device_list&ord=dev_num&dir=up">:.</a></td>
<?php

  foreach( $cols_selected as $id => $cell_name )
  {
    echo $header[$cell_name];
  }

  // pokud jsme prihlaseni, zobrazime sloupec navic
  if( is_admin() )
  {
    echo "                      <td nowrap align=\"center\" class=\"header\" width=\"70px\" colspan=\"2\">Operation</td>\n";
    echo "                      <td nowrap align=\"center\" class=\"header\" width=\"115px\">Device Selection</td>\n";
  }
?>
                    </tr>
                    <tr>
<?php
  echo "                  <tr class=\"tab_line1\" align=\"center\">\n";
  echo "                  <form id=\"filtr\" action=\"index.php\" method=\"get\">\n";
  echo "                    <td><input id=\"filtr\" class=\"filter_button\" type=\"submit\" value=\"Filter\"></td>\n";

  foreach( $cols_selected as $id => $cell_name )
  {
    echo $filter[$cell_name];
  }


  // kontrola stavu prihlaseni
  if( is_admin() )
  {	// prihlasen, odesleme sloupec navic
    echo "                    <td colspan=\"2\"></td>\n";
    echo "                  </form id=\"filtr\">\n";
    echo "                    <td nowrap>\n";
    echo "                  <form id=\"devselect\" action=\"index.php\" method=\"get\">\n";
    echo "                    <input type=\"hidden\" name=\"page\" value=\"device_select\">\n";
    echo "                    <input type=\"submit\" name=\"sel\" value=\"Checked\" class=\"select_button1\">\n";
    echo "                    <input type=\"submit\" name=\"sel\" value=\"All\" class=\"select_button2\">\n";
    echo "                    </td>\n";
    echo "                  </tr>\n";
  }
  else
  {
    echo "                  </form id=\"filtr\">\n";
    echo "                  </tr>\n";
  }
?>
                    </tr>
                  </table>
                </div>
              </td>
            </tr>
<?php

  fclose($csv);

  js_end("
            window.onscroll = function () {
              updateTableHeader();
            }
    ");

	// pripojeni paticky
  include ("php/bottom.php");

?>