<?php
/***************************************************************************/
/*                                                                         */
/*  STRANKA DEVICE STATUS                                                  */
/*                                                                         */
/***************************************************************************/

$sub_stats = array("device_status_info","device_status_edit",
	"device_status_graph","device_status_notes", "device_status_stats");

include ("php/head.php");
include ("php/menu.php");
flush();

require_once "php/mysql.php"; 
require_once "php/misc.php";

// priznak existence zarizeni
$device_not_found=0;

// pripojeni k DB
$link = db_connect();

if (!isset($_GET['device_id']))
{	// neni zadano device_id
	$device_id = 1;
	$hostname = URI_get_string("hostname");
	if( !is_null($hostname))
	{ // je zadano hostname

		// ziskani device_id z hostname
		$sql = 'SELECT device_id FROM devices WHERE hostname="'.$hostname.'" LIMIT 1';

		// vykonani SQL prikazu
		$result = db_query($link, $sql);
		
		if(mysqli_num_rows($result) == 0)
		{ // zarizeni nenalezeno, zkusime hledat mezi alternativnima adresama
			// ziskani device_id z hostname
			$sql = 'SELECT device_id FROM devices WHERE hostname_alt="'.$hostname.'" LIMIT 1';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			if(mysqli_num_rows($result) == 0)			
			{	// zarizeni nenalezeno
				$device_not_found=1;
			}
			else
			{	// nacteni ziskaneho device_id
				list($device_id) = mysqli_fetch_row($result);	
			}
		}
		else
		{	// nacteni ziskaneho device_id
			list($device_id) = mysqli_fetch_row($result);	
		}
	}
}else
{	// nacteni predaneho device_id
	$device_id = URI_get_int("device_id");
}

$sub_stat = URI_get_string("sub_stat");
if(!in_array($sub_stat, $sub_stats) )
{
	$sub_stat = $sub_stats[0];
}

if( is_null($device_id) )
{
	echo "Missing device ID";
	exit;
}

if($device_not_found == 1)
{ // zarizeni nenalezeno, vypiseme pouze chybu
?>
            <tr>
              <th nowrap colspan="3">Device Status</td>	
            </tr>
            <tr>
              <td>Device not found !!!</td>
            </tr>
<?php
}
else
{	// zarizeni existuje, vratime zadanou stranku

	$sql = 'SELECT hostname, description, location, note, product FROM devices WHERE device_id = "'.$device_id.'" LIMIT 1';

	// vykonani SQL prikazu
	$result = db_query($link, $sql);
	list($hostname, $desc, $location, $note, $product) = mysqli_fetch_row( $result );

	$header_str = $product;

	if( !is_null( $hostname ) && ($hostname != "0.0.0.0") )
		$header_str = $header_str.', '.$hostname;

	if( !is_null( $desc ) )
		$header_str = $header_str.', '.$desc;

	if( !is_null( $location ) ) 
		$header_str = $header_str.', '.$location;

	if( !is_null( $note ) )
		$header_str = $header_str.', '.$note;

	echo "            <tr>\n";
	echo "              <th nowrap colspan=\"3\">".$header_str." - Device Status</td>\n";
	echo "            </tr>\n";
	echo "            <tr>\n";
	echo "              <td colspan=\"3\">\n";
	echo "                <table>\n";
	echo "                  <tr>\n";
	echo "                    <td>\n";

	echo "                      <a href=\"index.php?page=device_status&device_id=".$device_id."&sub_stat=device_status_info\">System Information</a> | \n";

	$sql = 'SELECT hostname_alt, hostname_alt2
		FROM devices
		WHERE device_id = "'.$device_id.'"';

	$result = db_query($link, $sql);
	list($hostname_alt, $hostname_alt2) = mysqli_fetch_row( $result );

	if( is_null( $hostname_alt ) )
	{
		echo "                      <a href=\"index.php?page=device_status&device_id=".$device_id."&sub_stat=device_status_stats&sim_id=0\">Stats</a> | \n";
	}
	else
	{
		echo "                      <a href=\"index.php?page=device_status&device_id=".$device_id."&sub_stat=device_status_stats&sim_id=0\">Stats - SIM1</a> | \n";
		echo "                      <a href=\"index.php?page=device_status&device_id=".$device_id."&sub_stat=device_status_stats&sim_id=1\">Stats - SIM2</a> | \n";
		if( !is_null( $hostname_alt2 ) )
		{
			echo "                      <a href=\"index.php?page=device_status&device_id=".$device_id."&sub_stat=device_status_stats&sim_id=2\">Stats - CDMA</a> | \n";
		}
	}

	echo "                      <a href=\"index.php?page=device_status&device_id=".$device_id."&sub_stat=device_status_notes\">Notes</a>\n";
	if(can_user_edit_device())
	{
		echo "                      | <a href=\"index.php?page=device_status&device_id=".$device_id."&sub_stat=device_status_edit\">Device Parameters</a>\n";
	}

	echo "                    </td>\n";
	echo "                  </tr>\n";
	echo "                </table>\n";
	echo "              </td>\n";
	echo "            </tr>\n";

	include($sub_stat.".php");  
?>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td align="left">
                      <table>
                        <tr>
                          <td>
                            <form action="index.php" method="get">
                              <input type="hidden" name="page" value="device_status">
                              <label for="openhostname">Open Hostname</label>
                              <input type="text" name="hostname" id="openhostname" size="10">
                            </form>
                          </td>
                        </tr>
<?php

	if( $cfg['user_link_target'] != '')
	{
		echo "                        <tr>\n";
		echo "                          <td><a href=\"http://".$cfg['user_link_target']."\">".($cfg['user_link_text'] == '' ? $cfg['user_link_target'] : $cfg['user_link_text'])."</a></td>\n";
		echo "                        </tr>\n";
	}

?>
                      </table>
                    </td>
<?php
/*	if( ($sub_stat == "device_status_info") || ($sub_stat == "device_status_stats") )
	{
		echo "                    <td align=\"right\">\n";
		echo "                      <a href=\"index.php?page=pdf_export&name=Device_Status_".date("d_m_Y_H_i", time()).".pdf\">PDF</a>\n";
		echo "                    </td>\n";
	} */
?>
                  </tr>
                </table>
              </td>
            </tr>
<?php 
}
// pripojeni paticky
include ("php/bottom.php");
?>
