<?php

  if( !can_user_edit_device( ) )
  { //
    echo "You are not allowed edit device !!!";
    exit;
  }

	// pripojeni k DB
	$link = db_connect();

	// popis zarizeni
	$sql    = 	'SELECT hostname, hostname_alt, hostname_alt2, description, community, location, coordinates, note,
		enabled, autoupdate, phone, phone_alt, trap, group_id, accounting_start, accounting_start_alt,
		accounting_start_alt2, read_location, period, read_gps, read_temp_volt,
		snmp_prot, v3_username, v3_authentication, v3_authpsw, v3_privacy, v3_privpsw
		FROM devices
				WHERE device_id="'.$device_id.'"';

	// vykonani SQL prikazu
	$result = db_query($link, $sql);

	// nacteni dat z odpovedi
	list($hostname, $hostname_alt, $hostname_alt2, $description, $community, $location, $coordinates, $note, $enabled,
			$autoupdate, $phone, $phone_alt, $trap, $group_id, $accounting_start, $accounting_start_alt,
			$accounting_start_alt2, $read_location, $period, $read_gps, $read_temp_volt,
			$snmp_enabled, $snmp_username, $snmp_auth, $snmp_auth_password, $snmp_privacy, $snmp_privacy_password) = mysqli_fetch_row($result);

	if(is_null($description))
	{
		$description = '';
	}

	if(is_null($hostname) || (strlen($hostname) < 3))
  {
		$hostname = '';
	}

	if(is_null($hostname_alt) || (strlen($hostname_alt) < 3))
  {
		$hostname_alt = '';
	}

	if(is_null($hostname_alt2) || (strlen($hostname_alt2) < 3))
  {
		$hostname_alt2 = '';
	}

	if(is_null($location))
	{
		$location = '';
	}

	if(is_null($note))
	{
		$note = '';
	}

	if(is_null($phone))
	{
		$phone = '';
	}

	if(is_null($phone_alt))
	{
		$phone_alt = '';
	}

  if(is_null($period) || ($period < 1))
  {
    $period = 15;
  }

?>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <form action="index.php" method="post" name="f">
                  <tr>
                    <td align="center" class="header" colspan="2">Device Parameters</td>
                  </tr>
                  <tr>
                    <td align="center" colspan="2">Accounting Start</td>
                  </tr>
                  <tr valign="top">
                    <td>
                      <input type="hidden" name="page" value="device_change">
                      <input type="hidden" name="oper" value="change">
                      <input type="hidden" name="device_id" value="<?php echo($device_id)?>">
                      <table>
                        <tr>
                          <td width="150px">Hostname</td><td><input type="text" name="hostname" value="<?php echo($hostname)?>"></td>
                          <td>
                            <select name="add_accounting_start">
<?php
  for($i = 1;$i < 32;$i++)
  {
    echo "                              <option value=\"".$i."\"".($i == $accounting_start ? ' selected' : '').">".$i."\n";
  }
?>
                            </select>
                          </td>
                        </tr>
                        <tr>
                          <td width="150px">2nd Hostname</td><td><input type="text" name="hostname_alt" value="<?php echo($hostname_alt)?>"></td>
                          <td>
                            <select name="add_accounting_start_alt">
<?php
  for($i = 1;$i < 32;$i++)
  {
    echo "                              <option value=\"".$i."\"".($i == $accounting_start_alt ? ' selected' : '').">".$i."\n";
  }
?>
                            </select>
                          </td>
                        </tr>
                        <tr>
                          <td width="150px">3rd Hostname</td><td><input type="text" name="hostname_alt2" value="<?php echo($hostname_alt2)?>"></td>
                          <td>
                            <select name="add_accounting_start_alt2">
<?php
  for($i = 1;$i < 32;$i++)
  {
    echo "                              <option value=\"".$i."\"".($i == $accounting_start_alt2 ? ' selected' : '').">".$i."\n";
  }
?>
                            </select>
                          </td>
                        </tr>
                        <tr>
                          <td width="150px">Description</td><td><input type="text" name="description" value="<?php echo($description)?>"></td>
                        </tr>
                        <tr>
                          <td width="150px">Location</td><td><input type="text" name="location" value="<?php echo($location)?>"></td>
                        </tr>
                        <tr>
                          <td width="150px">Coordinates</td><td><input type="text" name="coordinates" value="<?php echo($coordinates)?>"></td>
                        </tr>
                        <tr>
                          <td>Note</td><td><input type="text" name="note" value="<?php echo($note)?>"></td>
                        </tr>
                        <tr>
                          <td>Community</td><td><input type="text" name="community" value="<?php echo($community)?>"></td>
                        </tr>
                        <tr>
                          <td>Group</td>
                          <td>
                            <select name="group_id">
<?php
  $sql = 'SELECT group_id, description
          FROM groups
          WHERE company_id = (SELECT company_id FROM groups WHERE group_id = "'.$group_id.'")';

  	// vykonani SQL prikazu
	$result = db_query($link, $sql);

  while( list( $group, $description ) = mysqli_fetch_row( $result ) )
  {
    echo "                              <option value=\"".$group."\" ".($group == $group_id ? 'selected' : '').">".$description."\n";
  }


?>
                            </select>
                          </td>
                        </tr>
                        <tr>
                          <td>Read period</td><td><input type="text" name="add_period" value="<?php echo($period)?>"></td>
                        </tr>
                        <tr>
                          <td>Phone</td><td><input type="text" name="phone" value="<?php echo($phone)?>"></td>
                        </tr>
                        <tr>
                          <td>Phone Alt</td><td><input type="text" name="phone_alt" value="<?php echo($phone_alt)?>"></td>
                        </tr>
                        <tr>
                          <td>Enabled</td>
                          <td>
                            <input type="checkbox" name="enabled" value="1" <?php echo($enabled == 1 ? "checked" : "")?>>
                          </td>
                        </tr>
                        <tr>
                          <td>Autoupdate</td>
                          <td>
                            <input type="checkbox" name="autoupdate" value="1"  <?php echo($autoupdate == 1 ? "checked" : "")?>>
                          </td>
                        </tr>
                        <tr>
                          <td>Read location</td>
                          <td>
                            <input type="checkbox" name="read_location" value="1"  <?php echo($read_location == 1 ? "checked" : "")?>>
                          </td>
                        </tr>
                        <tr>
                          <td>Read GPS</td>
                          <td>
                            <input type="checkbox" name="read_gps" value="1"  <?php echo($read_gps == 1 ? "checked" : "")?>>
                          </td>
                        </tr>
                        <tr>
                          <td>Read Voltage & Temperature</td>
                          <td>
                            <input type="checkbox" name="read_temp_volt" value="1"  <?php echo($read_temp_volt == 1 ? "checked" : "")?>>
                          </td>
                        </tr>
                        <tr>
                          <td>Access mode</td>
                          <td>
                            <select name="access_mode">
                              <option value="0" <?php echo($trap == 0 ? "selected" : "")?>>Polling
                              <option value="1" <?php echo($trap == 1 ? "selected" : "")?>>Trap
                            </select>
                          </td>
                        </tr>
                      </table>
                    </td>
					<td>
						<table>
							<tr>
								<td colspan="2"><input type="checkbox" id="snmp_enabled" name="snmp_enabled" value="1" <?php echo($snmp_enabled == 1 ? "checked" : "")?>> <label for="snmp_enabled">Enable SNMP V3</label></td>
							</tr>
							<tr>
								<td><label class="left-margin" for="snmp_username">Username</label></td>
								<td><input type="text" name="snmp_username" id="snmp_username" value="<?php echo($snmp_username)?>"></td>
							</tr>
							<tr>
								<td><label class="left-margin" for="snmp_auth">Authentication</label></td>
								<td>
									<select name="snmp_auth">
										<option value="0" <?php echo($snmp_auth == 0 ? "selected" : "")?>>None
										<option value="1" <?php echo($snmp_auth == 1 ? "selected" : "")?>>MD5
										<option value="2" <?php echo($snmp_auth == 2 ? "selected" : "")?>>SHA1
									</select>
								</td>
							</tr>
							<tr>
								<td><label class="left-margin" for="snmp_auth_password">Authentication Password</label></td>
								<td><input type="text" name="snmp_auth_password" id="snmp_auth_password" value="<?php echo($snmp_auth_password)?>"></td>
							</tr>
							<tr>
								<td><label class="left-margin" for="snmp_privacy">Privacy</label></td>
								<td>
									<select name="snmp_privacy">
										<option value="0" <?php echo($snmp_privacy == 0 ? "selected" : "")?>>None
										<option value="1" <?php echo($snmp_privacy == 1 ? "selected" : "")?>>DES
										<option value="2" <?php echo($snmp_privacy == 2 ? "selected" : "")?>>AES
									</select>
								</td>
							</tr>
							<tr>
								<td><label class="left-margin" for="snmp_privacy_password">Privacy Password</label></td>
								<td><input type="text" name="snmp_privacy_password" id="snmp_privacy_password" value="<?php echo($snmp_privacy_password)?>"></td>
							</tr>
						</table>
					</td>
                  </tr>
                  <tr>
                    <td>
                      <table>
                        <tr>
                          <td><input type="submit" value="Apply"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  </form>
                </table>
              </td>
            </tr>
