<?php

	// pripojeni k DB
	$link = db_connect();

	// popis zarizeni
  $sql = 'SELECT hostname, hostname_alt, hostname_alt2, devices.description, community, location, coordinates, note, enabled
          , product, firmware, mac, sn, imei, esn,DATE_FORMAT(cfg_update_time,"%Y-%m-%d %H:%i")
          , phone, phone_alt, health, health_alt, health_alt2, period, trap, groups.description
          , DATE_FORMAT(last_time_act,"%Y-%m-%d %H:%i"), DATE_FORMAT(last_time_act_alt,"%Y-%m-%d %H:%i")
		  , snmp_prot, v3_username, v3_authentication, v3_authpsw, v3_privacy, v3_privpsw
          FROM devices
          LEFT JOIN groups ON devices.group_id = groups.group_id
  				WHERE device_id="'.$device_id.'"';

	// vykonani SQL prikazu
	$result = db_query($link, $sql);

	// nacteni dat z odpovedi
	list($hostname, $hostname_alt, $hostname_alt2, $description, $community, $location, $coordinates,
		$note, $enabled, $product, $firmware, $mac, $sn, $imei, $esn, $cfg_update_time, $phone, $phone_alt,
		$healh_state, $healh_state_alt, $healh_state_alt2, $period, $is_trap, $group_name, $last_time_act, $last_time_act_alt,
		$snmp_enabled, $snmp_username, $snmp_auth, $snmp_auth_password, $snmp_privacy, $snmp_privacy_password) = mysqli_fetch_row($result);

	// nacteni informaci o stavu zarizeni
  $sql    = 	'SELECT plmn, status, cell, level, channel, channel_n1, channel_n2, channel_n3, channel_n4, channel_n5, '.
        'level_n1, level_n2, level_n3, level_n4, level_n5, uptime, signal_quality, temp, voltage '.
				'FROM stats ' .
				'WHERE device_id="'.$device_id.'" ORDER BY stat_id DESC LIMIT 1';

	// vykonani SQL prikazu
	$result = db_query($link, $sql);

	// nacteni hodnot z odpovedi
  list( $plmn, $network_status, $cell, $level, $channel, $channel_1, $channel_2, $channel_3, $channel_4,
  $channel_5, $level_1, $level_2, $level_3, $level_4, $level_5, $uptime, $signal_quality, $temp, $voltage) = mysqli_fetch_row($result);

  $plmn = is_null($plmn) ? '---' : $plmn;
	$level = is_null($level) ? '---' : $level;
	$channel = is_null($channel) ? '---' : $channel;

	if(is_null($description))
	{
		$description = '---';
	}

	if(is_null($hostname) || (strlen($hostname) < 3))
  {
		$hostname = '---';
	}

	if(is_null($hostname_alt) || (strlen($hostname_alt) < 3))
  {
		$hostname_alt = '---';
	}

	if(is_null($hostname_alt2) || (strlen($hostname_alt2) < 3))
  {
		$hostname_alt2 = '---';
	}

	if(is_null($location))
	{
		$location = '---';
	}

	if(is_null($note))
	{
		$note = '---';
	}

	if(is_null($product))
	{
		$product = '---';
	}

	if(is_null($firmware))
	{
		$firmware = '---';
	}

	if(is_null($mac))
	{
		$mac = '---';
  }

	if(is_null($sn))
	{
		$sn = '---';
	}

	if(is_null($imei))
	{
		$imei = '---';
	}

	if(is_null($esn))
	{
		$esn = '---';
	}

	if(is_null($cfg_update_time))
	{
		$cfg_update_time = '---';
	}

	if(is_null($phone) || ($phone == ''))
	{
		$phone = '---';
	}

	if(is_null($phone_alt) || ($phone_alt == ''))
	{
		$phone_alt = '---';
	}

	if(is_null($period))
	{
		$period = '---';
	}

  if( is_null($last_time_act) && is_null($last_time_act_alt) )
  {
    $last_read_time = '---';
  }
  else
  {
    $last_read_time = $last_time_act > $last_time_act_alt ? $last_time_act : $last_time_act_alt;
  }

	if(is_null($signal_quality))
	{
		$signal_quality = '---';
	}

	if(is_null($temp))
	{
		$temp = '---';
	}

	if(is_null($voltage))
	{
		$voltage = '---';
	}

   // prevod stavu na css styl
  if($enabled == 1)
  {
    if(!is_null($healh_state))
    {
      if($hostname != "---" )
      {
        switch($healh_state)
        {
          case "0": $host_style = 'class="health_green"'; break;
          case "1": $host_style = 'class="health_orange"'; break;
          case "2": if(($healh_state_alt == "2") && ($healh_state_alt2 == "2"))
                    {
                      $host_style = 'class="health_red"'; break;
                    }
                    else
                    {
                      $host_style = 'class="health_gray"'; break;
                    }
          default: $host_style = ''; break;
        }
      }
      else
      {
        $host_style = '';
      }
    }
    else
    {
      $host_style = '';
    }
  }
  else
  {
    if(	$hostname != "---" )
    {
      $host_style = 'class="health_dark_gray"';
    }
  }

   // prevod stavu na css styl
  if($enabled == 1)
  {
    if(!is_null($healh_state_alt))
    {
      if($hostname_alt != "---" )
      {
        switch($healh_state_alt)
        {
          case "0": $host_alt_style = 'class="health_green"'; break;
          case "1": $host_alt_style = 'class="health_orange"'; break;
          case "2": if(($healh_state == "2") && ($healh_state_alt2 == "2"))
                    {
                      $host_alt_style = 'class="health_red"'; break;
                    }
                    else
                    {
                      $host_alt_style = 'class="health_gray"'; break;
                    }
          default: $host_alt_style = ''; break;
        }
      }
      else
      {
        $host_alt_style = '';
      }
    }
    else
    {
      $host_alt_style = '';
    }
  }
  else
  {
    if(	$hostname_alt != "---" )
    {
      $host_alt_style = 'class="health_dark_gray"';
    }
  }

   // prevod stavu na css styl
  if($enabled == 1)
  {
    if(!is_null($healh_state_alt2))
    {
      if($hostname_alt2 != "---" )
      {
        switch($healh_state_alt2)
        {
          case "0": $host_alt_style2 = 'class="health_green"'; break;
          case "1": $host_alt_style2 = 'class="health_orange"'; break;
          case "2": if(($healh_state == "2") && ($healh_state_alt == "2"))
                    {
                      $host_alt_style2 = 'class="health_red"'; break;
                    }
                    else
                    {
                      $host_alt_style2 = 'class="health_gray"'; break;
                    }
          default: $host_alt_style2 = ''; break;
        }
      }
      else
      {
        $host_alt_style2 = '';
      }
    }
    else
    {
      $host_alt_style2 = '';
    }
  }
  else
  {
    if(	$hostname_alt2 != "---" )
    {
      $host_alt_style2 = 'class="health_dark_gray"';
    }
  }

?>
            <tr>
              <td colspan="3">
                <table width="100%">
<?php
  // odchyceni stranky
  ob_start();
?>
                  <tr valign="top">
                    <td rowspan="3" width="50%">
                      <table cellspacing="2" cellpadding="2" border="1" width="100%" style="border-collapse: collapse;">
                        <tr>
                          <th colspan="2">Device Information</th>
                        </tr>
                        <tr>
                          <td width="150">Device</td>
                          <td>
                            <table cellspacing="0" cellpadding="0" width="100%">
                              <tr>
                                <td nowrap><?php echo($product."\n")?></td>
<?php
  if(is_admin())
  {
    echo "                            <td align=\"right\"><input type=\"button\" id=\"device_refresh_button\" onclick=\"window.open('index.php?page=device_change&oper=refresh&device_id=".$device_id."','_self');\" value=\"Refresh\"></td>\n";
  }
?>
                              </tr>
                            </table>
                          </td>
                        </tr>
                        <tr>
                          <td nowrap>IP Address</td>
                          <td>
                            <table cellspacing="0" cellpadding="0" width="100%">
                              <tr>
                                <td <?php echo($host_style)?> nowrap>
<?php
  if( is_admin() && ($hostname != "---") && ($hostname != "0.0.0.0"))
  {
    echo "                            <a href=\"index.php?page=open_device&hostname=".$hostname."\" title=\"Open Web Interface\" target=\"_blank\">".$hostname."</a>\n";
  }
  else
  {
    echo "                            ".($hostname == "0.0.0.0" ? "Behind NAT" : $hostname);
  }
?>
                                </td>
<?php
  if( ($hostname != '---') && ($hostname != '0.0.0.0'))
  {
    echo "                            <td align=\"right\" ".$host_style."><input type=\"button\"id=\"ping_button\" onclick=\"javascript:window.open('index.php?page=ping&hostname=".$hostname."','_blank','height=600,width=550,left=100, top=100,resizable=no,scrollbars=no,');\" value=\"Ping\"><!-- <input type=\"button\" id=\"telnet_button\" onclick=\"javascript:window.open('php/telnet_form.php?hostname=".$hostname."','_blank','height=700,width=700,left=100, top=100,resizable=no,scrollbars=no');\" value=\"Telnet\" align=\"right\">--></td>\n";
  }
?>
                              </tr>
                            </table>
                          </td>
                        </tr>
                        <tr>
                          <td nowrap>2nd IP Address</td>
                          <td>
                            <table cellspacing="0" cellpadding="0" width="100%">
                              <tr>
                                <td <?php echo($host_alt_style)?> nowrap>
<?php
  if( is_admin() && ($hostname_alt != "---") && ($hostname_alt != "0.0.0.0") )
  {
    echo "                                <a href=\"index.php?page=open_device&hostname=".$hostname_alt."\" title=\"Open Web Interface\" target=\"_blank\">".$hostname_alt."</a>\n";
  }
  else
  {
    echo "                                ".($hostname_alt == "0.0.0.0" ? "Behind NAT" : $hostname_alt);
  }
?>
                                </td>
<?php
  if( ($hostname_alt != '---') && ($hostname_alt != '0.0.0.0'))
  {
    echo "                            <td align=\"right\" ".$host_alt_style."><input type=\"button\"  style=\"float: right;\" id=\"ping_button\" onclick=\"javascript:window.open('index.php?page=ping&hostname=".$hostname_alt."','_blank','height=600,width=550,left=100, top=100,resizable=no,scrollbars=no,');\" value=\"Ping\"></td>\n";
  }
?>

                              </tr>
                            </table>
                          </td>
                        </tr>
                        <tr>
                          <td nowrap>3rd IP Address</td>
                          <td>
                            <table cellspacing="0" cellpadding="0" width="100%">
                              <tr>
                                <td <?php echo($host_alt_style2)?> nowrap>
<?php
  if( is_admin() && ($hostname_alt2 != "---") && ($hostname_alt2 != "0.0.0.0") )
  {
    echo "                                <a href=\"index.php?page=open_device&hostname=".$hostname_alt2."\" title=\"Open Web Interface\" target=\"_blank\">".$hostname_alt2."</a>\n";
  }
  else
  {
    echo "                                ".($hostname_alt2 == "0.0.0.0" ? "Behind NAT" : $hostname_alt2);
  }
?>
                                </td>
<?php
  if( ($hostname_alt2 != '---') && ($hostname_alt2 != '0.0.0.0'))
  {
    echo "                            <td align=\"right\" ".$host_alt_style2."><input type=\"button\"  style=\"float: right;\" id=\"ping_button\" onclick=\"javascript:window.open('index.php?page=ping&hostname=".$hostname_alt2."','_blank','height=600,width=550,left=100, top=100,resizable=no,scrollbars=no,');\" value=\"Ping\"></td>\n";
  }
?>

                              </tr>
                            </table>
                          </td>
                        </tr>
                        <tr>
                          <td nowrap>Phone Number</td>
                          <td>
                            <table cellspacing="0" cellpadding="0" width="100%">
                              <tr>
                                <td nowrap><?php echo($phone)?></td>
<?php

  if(is_admin() && ($phone != '---'))
  {
    echo "                            <td align=\"right\"><input type=\"button\" id=sms_button onclick=\"javascript:window.open('index.php?page=sms_form&phone=".urlencode($phone)."','_self');\" value=\"Send SMS\"></td>\n";
  }

?>
                              </tr>
                            </table>
                          </td>
                        </tr>
                        <tr>
                          <td nowrap>Alt. Phone Number</td>
                          <td>
                            <table cellspacing="0" cellpadding="0" width="100%">
                              <tr>
                                <td nowrap><?php echo($phone_alt)?></td>
<?php

  if(is_admin() && ($phone_alt != '---'))
  {
    echo "                            <td align=\"right\"><input type=\"button\" id=sms_button onclick=\"javascript:window.open('index.php?page=sms_form&phone=".urlencode($phone_alt)."','_self');\" value=\"Send SMS\"></td>\n";
  }

?>
                              </tr>
                            </table>
                          </td>
                        </tr>
                        <tr>
                          <td>SN</td><td><?php echo($sn)?></td>
                        </tr>
                        <tr>
                          <td>MAC address</td><td><?php echo($mac)?></td>
                        </tr>
                        <tr>
                          <td>IMEI</td><td><?php echo($imei)?></td>
                        </tr>
                        <tr>
                          <td>ESN</td><td><?php echo($esn)?></td>
                        </tr>
                        <tr>
                          <td>Firmware</td><td><?php echo($firmware)?></td>
                        </tr>
                        <tr>
                          <td width="150">Description</td><td><?php echo($description)?></td>
                        </tr>
                        <tr>
                          <td>Location</td>
                          <td>
                            <table cellspacing="0" cellpadding="0" width="100%">
                              <tr>
                                <td nowrap><?php echo($location)?></td>
<?php
    if (preg_match('/(-?[0-9]?[0-9]?[0-9].[0-9]{6},?){2}/', $coordinates))
    { // mame gps souradnice
//      echo "                                  <input type=\"button\" align=\"right\" id=\"map_button\" onclick=\"openChild('php/device_map.php?device_id=".$device_id."&color_scheme=".$_SESSION['Web.color_scheme']."','win2','800','600')\" value=\"Map\">\n";
      echo "                            <td align=\"right\"><input type=\"button\" id=\"map_button\" onclick=\"openChild('http://maps.google.com?q=".$coordinates." (".$product.(!is_null($description) ? ' - '.$description : '').")&output=embed','win2','800','600')\" value=\"Map\"></td>\n";

    }
?>
                              </tr>
                            </table>
                          </td>
                        </tr>
                        <tr>
                          <td>Note</td><td><?php echo ($note)?></td>
                        </tr>
                        <tr>
                          <td>Group</td><td><?php echo ($group_name)?></td>
                        </tr>
                        <tr>
                          <td>Supply Voltage</td><td><?php echo ($voltage)?> V</td>
                        </tr>
                        <tr>
                          <td>Temperature</td><td><?php echo ($temp)?> &deg;C</td>
                        </tr>
                        <tr>
                          <td>Uptime</td>
                          <td nowrap>
                            <?php echo(UptimeToStr($uptime)) ?>
                          </td>
                        </tr>
                      </table>
                    </td>
                    <td>
                      <table cellspacing="2" cellpadding="2" border="1" width="100%" style="border-collapse: collapse;">
                        <tr>
                          <th colspan="2">Mobile Network Information</th>
                        </tr>
                        <tr>
                          <td width="150">Technology</td><td><?php echo(is_null($network_status) ? "---" : decoding_network_status($network_status))?></td>
                        </tr>
                        <tr>
                          <td>PLMN</td><td><?php echo($plmn)?></td>
                        </tr>
                        <tr>
                          <td>Cell</td><td><?php echo(is_null($cell) ? '---' : strtoupper(dechex($cell)))?></td>
                        </tr>
                        <tr>
                          <td>Channel</td><td><?php echo($channel)?></td>
                        </tr>
                        <tr>
                          <td>Signal Strength</td><td><?php echo($level)?> dBm</td>
                        </tr>
<?php

  if( $network_status < 5 )
  { // GPRS/EDGE
    $neighbours = "";

    for($i = 1;$i <= 5;$i++)
    {
      if(!is_null(${"channel_".$i}))
      {
        $neighbours = $neighbours.${"level_".$i}." dBm (".${"channel_".$i}.") <br>";
      }
    }

    echo "                        <tr valign=\"top\">\n";
    echo "                          <td>Neighbours</td><td>".($neighbours == "" ? "---" : $neighbours)."</td>\n";
    echo "                        </tr>\n";

  }
  else
  { // lepsi jak EDGE -> misto sousedu mame kvalitu signalu

    echo "                        <tr>\n";
    echo "                          <td>Signal Quality</td><td>".$signal_quality." dB</td>\n";
    echo "                        </tr>\n";

  }

?>
                      </table>
                    </td>
                  </tr>
                  <tr valign="top">
                    <td>
                      <table cellspacing="2" cellpadding="2" border="1" width="100%" style="border-collapse: collapse;">
                        <tr>
                          <th colspan="2">System Information</th>
                        </tr>
<?php
  if(is_admin())
  {
    echo "                        <tr>\n";
    echo "                          <td>Community</td><td>".$community."</td>\n";
    echo "                        </tr>\n";
  }
?>
                        <tr>
                          <td width="150">Enabled</td><td><input type="checkbox" disabled <?php echo($enabled ? "checked" : "")?>></td>
                        </tr>
<?php
  if($is_trap == '0')
  {
    echo "                        <tr>\n";
    echo "                          <td>Access mode</td>\n";
    echo "                          <td>Polling</td>\n";
    echo "                        </tr>\n";
    echo "                        <tr>\n";
    echo "                          <td>Poll period</td>\n";
    echo "                          <td>".$period." min</td>\n";
    echo "                        </tr>\n";
  }
  else
  {
    echo "                        <tr>\n";
    echo "                          <td>Access mode</td>\n";
    echo "                          <td>Trap</td>\n";
    echo "                        </tr>\n";
    echo "                        <tr>\n";
    echo "                          <td>Trap period</td>\n";
    echo "                          <td>".$period." min</td>\n";
    echo "                        </tr>\n";
  }
?>
                        <tr>
                          <td nowrap>Last Read Time</td><td><?php echo($last_read_time)?></td>
                        </tr>
                        <tr>
                          <td nowrap>Update Configuration</td><td><?php echo($cfg_update_time)?></td>
                        </tr>
                      </table>
					</td>
				</tr>
				<tr valign="top">
                    <td>
                      <table cellspacing="2" cellpadding="2" border="1" width="100%" style="border-collapse: collapse;">
                        <tr>
                          <th colspan="2">SNMP V3 Protocol</th>
                        </tr>
                        <tr>
                          <td width="150">Enabled</td><td><input type="checkbox" disabled <?php echo($snmp_enabled ? "checked" : "")?>></td>
                        </tr>
                        <tr>
                          <td nowrap>Username</td><td><?php echo($snmp_username)?></td>
                        </tr>
                        <tr>
                          <td nowrap>Authentication</td><td><?php echo(snmp_auth_to_string($snmp_auth))?></td>
                        </tr>
                        <tr>
                          <td nowrap>Auth. Password</td><td><?php echo($snmp_auth_password)?></td>
                        </tr>
                        <tr>
                          <td nowrap>Privacy</td><td><?php echo(snmp_privacy_to_string($snmp_privacy))?></td>
                        </tr>
                        <tr>
                          <td nowrap>Privacy Password</td><td><?php echo($snmp_privacy_password)?></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
<?php
  // konec odchyceni stranky
  $page = ob_get_clean();
  echo $page;

  $page = "<h1 align=\"center\">Device Status</h1><table width=\"100%\">".$page."</table>";


  $fd = fopen($temp_path."/temp.html",'w');
  fwrite($fd, $page);
  fclose($fd);
?>
                </table>
              </td>
            </tr>
