<?php

//***************************************************************************/
//*                                                                         */
//*  STRANKA TABULKY ZARIZENI     	  					                   */            */
//*                                                                         */
//***************************************************************************/

  //register_globals = 1;
  //echo "start ";

  require_once "config.inc.php";
  require_once "php/mysql.php";
  require_once "php/misc.php";

  include("pGraph/pData.class");
  include("pGraph/pChart.class");


  //	header("Content-Type: image/png");


  $graph_type = URI_get_string("graph_tab");
  $hostname =   URI_get_string("hostname");
  if( is_null( $graph_type ) )
  {
    echo "Missing or invalid graph type!!!";
    exit;
  }

  $device_id = URI_get_int("device_id");
  if( is_null( $device_id ) )
  {
    echo "Missing or invalid device ID.";
    exit;
  }

  switch($cfg['color_scheme'])
  {
    case "green":
      $scheme_file="style_green.css";
      break;
    case "blue":
      $scheme_file="style_blue.css";
      break;
    case "default":
    default:
      $scheme_file="style.css";
  }

   // $graph_type='ploss_tod';
   //echo "testik";
   //echo "typ=$graph_type";
   //exit;

   $link = db_connect();

   switch($graph_type)
   {
        case 'ploss_tod':
		{
			$title = 'Packet Loss ('.$hostname.') - Today';

            echo $title;
            echo "<BR>";
            echo "<BR>";

            $YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "H:i";

			$from_timestamp = mktime(0, 0, 0, date("m") , date("d"), date("Y"));
			$to_timestamp = time();

			//$sql = 'CALL sp_GetDevDayListPLoss2('.$from_timestamp.','.$to_timestamp.','.$device_id.')';
            $sql = 'SELECT time from fails where time BETWEEN FROM_UNIXTIME('.$from_timestamp.') AND FROM_UNIXTIME('.$to_timestamp.') AND device_id='.$device_id.' ORDER BY TIME DESC;' ;

            // vykonani SQL prikazu
			$result = db_multi_query($link, $sql);

			$j = mysqli_num_rows($result);


            echo "<table cellspacing=\"2\" cellpadding=\"2\" border=\"1\"  style=\"border-collapse:collapse;\">\n";
            echo "<th>Time of failure</th>\n";
            for($i = 0;$i < $j;$i++)
			{
				list($temp_day) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				//$y_data1[$i] = round($temp_ploss,1);

            echo "<tr align=\"center\">\n";
            echo "<td nowrap>".$x_data1[$i]." hod</td>\n";
            echo "</tr>\n";
            }

            echo "</table>\n";
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}

			$y_bottom = 0;
			$y_top = 100;

			break;
		}

		case 'ploss_yes':
		{
			$title = 'Packet Loss ('.$hostname.') - Yesterday';
            echo $title;
            echo "<BR>";
            echo "<BR>";
			$YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "H:i";

			$from_timestamp = mktime(0, 0, 0, date("m") , date("d")-1, date("Y"));
			$to_timestamp = mktime(0, 0, 0, date("m") , date("d"), date("Y"));

			//$sql = 'CALL sp_GetDevDayListPLoss2('.$from_timestamp.','.$to_timestamp.','.$device_id.')';
            $sql = 'SELECT time from fails where time BETWEEN FROM_UNIXTIME('.$from_timestamp.') AND FROM_UNIXTIME('.$to_timestamp.') AND device_id='.$device_id.' ORDER BY TIME DESC;' ;


			// vykonani SQL prikazu
			$result = db_multi_query($link, $sql);

			$j = mysqli_num_rows($result);

            echo "<table cellspacing=\"2\" cellpadding=\"2\" border=\"1\"  style=\"border-collapse:collapse;\">\n";
            echo "<th>Time of failure</th>\n";
            for($i = 0;$i < $j;$i++)
			{
				list($temp_day) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				//$y_data1[$i] = round($temp_ploss,1);

            echo "<tr align=\"center\">\n";
            echo "<td nowrap>".$x_data1[$i]." hod</td>\n";
            echo "</tr>\n";
            }

            echo "</table>\n";
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}

			$y_bottom = 0;
			$y_top = 100;

			break;
		}

		case 'ploss_week':
		{
			$title = 'Packet Loss ('.$hostname.') - Last 7 Days';
            echo $title;
            echo "<BR>";
            echo "<BR>";

			$YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "d/m";

			$from_timestamp = mktime(0, 0, 0, date("m") , date("d") - 7, date("Y"));
			$to_timestamp = time();

			//$sql = 'CALL sp_GetDevDayListPLoss2('.$from_timestamp.','.$to_timestamp.','.$device_id.')';
            $sql = 'SELECT time from fails where time BETWEEN FROM_UNIXTIME('.$from_timestamp.') AND FROM_UNIXTIME('.$to_timestamp.') AND device_id='.$device_id.' ORDER BY TIME DESC;' ;

            // vykonani SQL prikazu
			$result = db_multi_query($link, $sql);
            $j = mysqli_num_rows($result);

			echo "<table cellspacing=\"2\" cellpadding=\"2\" border=\"1\"  style=\"border-collapse:collapse;\">\n";
            echo "<th>Time of failure</th>\n";
            for($i = 0;$i < $j;$i++)
			{
				list($temp_day) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				//$y_data1[$i] = round($temp_ploss,1);

            echo "<tr align=\"center\">\n";
            echo "<td nowrap>".$x_data1[$i]." hod</td>\n";
            echo "</tr>\n";
            }

            echo "</table>\n";
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}

			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}

			$y_bottom = 0;
			$y_top = 100;

			break;
		}

		case 'ploss_cur':
		{
			$title = 'Packet Loss ('.$hostname.') - Current Period';
            echo $title;
            echo "<BR>";
            echo "<BR>";
			$YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "d/m";

			$from_timestamp = mktime(0, 0, 0, date("m") , 1, date("Y"));
			$to_timestamp = time();

			//$sql = 'CALL sp_GetDevDayListPLoss2('.$from_timestamp.','.$to_timestamp.','.$device_id.')';
            $sql = 'SELECT time from fails where time BETWEEN FROM_UNIXTIME('.$from_timestamp.') AND FROM_UNIXTIME('.$to_timestamp.') AND device_id='.$device_id.' ORDER BY TIME DESC;' ;


			// vykonani SQL prikazu
			$result = db_multi_query($link, $sql);

			$j = mysqli_num_rows($result);

			echo "<table cellspacing=\"2\" cellpadding=\"2\" border=\"1\"  style=\"border-collapse:collapse;\">\n";
            echo "<th>Time of failure</th>\n";
            for($i = 0;$i < $j;$i++)
			{
				list($temp_day) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				//$y_data1[$i] = round($temp_ploss,1);

            echo "<tr align=\"center\">\n";
            echo "<td nowrap>".$x_data1[$i]." hod</td>\n";
            echo "</tr>\n";
            }

            echo "</table>\n";
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}

			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}

			$y_bottom = 0;
			$y_top = 100;

			break;
		}

		case 'ploss_last':
		{
			$title = 'Packet Loss ('.$hostname.') - Last Period';
			echo $title;
			echo "<BR>";
			echo "<BR>";
			$YAxisName = 'Packet Loss';
			$YAxisUnit = '%';
			$date_format = "d/m";

			$from_timestamp = mktime(0, 0, 0, date("m") - 1, 1, date("Y"));
			$to_timestamp = mktime(0, 0, 0, date("m") , 0, date("Y"));


			//$sql = 'CALL sp_GetDevDayListPLoss2('.$from_timestamp.','.$to_timestamp.','.$device_id.')';
            $sql = 'SELECT time from fails where time BETWEEN FROM_UNIXTIME('.$from_timestamp.') AND FROM_UNIXTIME('.$to_timestamp.') AND device_id='.$device_id.' ORDER BY TIME DESC;' ;

			// vykonani SQL prikazu
			$result = db_multi_query($link, $sql);

			$j = mysqli_num_rows($result);

		    echo "<table cellspacing=\"2\" cellpadding=\"2\" border=\"1\"  style=\"border-collapse:collapse;\">\n";
            echo "<th>Time of failure</th>\n";
            for($i = 0;$i < $j;$i++)
			{
				list($temp_day) = mysqli_fetch_row($result);
				$x_data1[$i] = $temp_day;
				//$y_data1[$i] = round($temp_ploss,1);

            echo "<tr align=\"center\">\n";
            echo "<td nowrap>".$x_data1[$i]." hod</td>\n";
            echo "</tr>\n";
            }

            echo "</table>\n";
			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}

			if(mysqli_more_results($link))
			{	//Catch 'OK'/'ERR'
				while(mysqli_next_result($link));
			}

			$y_bottom = 0;
			$y_top = 100;

			break;
		}
  }






?>





<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/plain; charset=utf-8" />
		<meta name="description" content="TODO - info" />
    <meta http-equiv="pragma" content="no-cache">
    <meta http-equiv="cache-control" content="no-cache">
		<title>Device Status</title>
    <link rel='stylesheet' href='css/<?php echo $scheme_file;?>' type='text/css' />
    <link rel='stylesheet' href='css/wait_indicator.css' type='text/css' />
    <script src="js/wait_indicator.js" type="text/javascript"></script>
	</head>
  <body onload="ind_off()" class="new_window">
    <div class="wait_dialog" id="wait_table" style="visibility: visible">
    </div>
		<table width="825px">
			<tr>
				<th>Device Status Table</th>
			</tr>
			<tr align="center">




			</tr>
		</table>
	</body>
</html>



