<?php
/***************************************************************************/
/*                                                                         */
/*  MAPA VSECH MOZNYCH ROUTRU								                               */
/*                                                                         */
/***************************************************************************/
	
  include ("php/head.php");
  include ("php/menu.php");


?>
            <script type="text/javascript" src="http://maps.googleapis.com/maps/api/js?sensor=false"></script>
            <script type="text/javascript" src="http://code.jquery.com/jquery-1.4.2.min.js"></script>
            <script type="text/javascript">
              var map;
              var dir_from;
              var dir_to;
              var mark_from;
              var mark_to;
              var directionsDisplay = new google.maps.DirectionsRenderer();
              var directionsService = new google.maps.DirectionsService();

              var customIcons = {
                green: {
                  icon: 'http://labs.google.com/ridefinder/images/mm_20_green.png',
                  shadow: 'http://labs.google.com/ridefinder/images/mm_20_shadow.png'
                },
                orange: {
                  icon: 'http://labs.google.com/ridefinder/images/mm_20_orange.png',
                  shadow: 'http://labs.google.com/ridefinder/images/mm_20_shadow.png'
                },
                red: {
                  icon: 'http://labs.google.com/ridefinder/images/mm_20_red.png',
                  shadow: 'http://labs.google.com/ridefinder/images/mm_20_shadow.png'
                },
                gray: {
                  icon: 'http://labs.google.com/ridefinder/images/mm_20_gray.png',
                  shadow: 'http://labs.google.com/ridefinder/images/mm_20_shadow.png'
                }
              };

              function load() {
                  map = new google.maps.Map(document.getElementById("map"), {
                  center: new google.maps.LatLng(0,0),
                    zoom: 13,
                    draggableCursor:'crosshair',
                    mapTypeId: 'roadmap'
                });

                directionsDisplay.setMap(map);
                directionsDisplay.setPanel(document.getElementById('directions-panel'));                  

                google.maps.event.addListener(map, "rightclick",    function(event){showMenu(event.latLng);});
                google.maps.event.addListener(map, "click",         function(event){closeMenu();});
                google.maps.event.addListener(map, "dragstart",     function(event){closeMenu();});
                google.maps.event.addListener(map, "zoom_changed",  function(event){closeMenu();});                

                var infoWindow = new google.maps.InfoWindow;
                var lat_min = 0;
                var lat_max = 0;
                var lng_min = 0;
                var lng_max = 0;

                downloadUrl("php/device_get_loc_xml.php", function(data) {
                  var xml = data.responseXML;
                  var markers = xml.documentElement.getElementsByTagName("marker");
                  lat_min = parseFloat(markers[0].getAttribute("lat"));
                  lat_max = parseFloat(markers[0].getAttribute("lat"));
                  lng_min = parseFloat(markers[0].getAttribute("lng"));
                  lng_max = parseFloat(markers[0].getAttribute("lng"));

                  for (var i = 0; i < markers.length; i++) {
                    var dev_id = markers[i].getAttribute("device_id");
                    var name = markers[i].getAttribute("name");
                    var desc = markers[i].getAttribute("desc");
                    var note = markers[i].getAttribute("note");
                    var device = markers[i].getAttribute("device");
                    var fw = markers[i].getAttribute("fw");
                    var level = markers[i].getAttribute("level");
                    var plmn = markers[i].getAttribute("plmn");
                    var cell = markers[i].getAttribute("cell");
                    var tech = markers[i].getAttribute("tech");
                    var avail = markers[i].getAttribute("avail");
                    var uptime = markers[i].getAttribute("uptime");
                    var stat = markers[i].getAttribute("status");
                    var updtime = markers[i].getAttribute("updtime");
                    var point = new google.maps.LatLng(
                        parseFloat(markers[i].getAttribute("lat")),
                        parseFloat(markers[i].getAttribute("lng")));
                    if( lat_min > point.lat() )
                    {
                      lat_min = point.lat();
                    }
                    if( lat_max < point.lat() )
                    {
                      lat_max = point.lat();
                    }
                    if( lng_min > point.lng() )
                    {
                      lng_min = point.lng();
                    }
                    if( lng_max < point.lng() )
                    {
                      lng_max = point.lng();
                    }

                    var html = '<div id="labelcontent"><table>' +
                      '<tr><td><b>Hostname:</b></td><td><a href="index.php?page=device_status&device_id='+ dev_id +'">' + name + '</a></td></tr>' +
                      '<tr><td><b>Description:</b></td><td>'+ desc +'</td></tr>' + 
                      '<tr><td><b>Note:</b></td><td>'+ note +'</td></tr>' +
                      '<tr><td><b>Device:</b></td><td>'+ device +'</td></tr>' + 
                      '<tr><td><b>Firmware:</b></td><td>'+ fw +'</td></tr>' + 
                      '<tr><td><b>Level:</b></td><td>'+ level +'</td></tr>' + 
                      '<tr><td><b>PLMN:</b></td><td>'+ plmn +'</td></tr>' + 
                      '<tr><td><b>Cell ID:</b></td><td>'+ cell +'</td></tr>' + 
                      '<tr><td><b>Data Service:</b></td><td>'+ tech +'</td></tr>' + 
                      '<tr><td><b>Availability:</b></td><td>'+ avail +'</td></tr>' +
                      '<tr><td><b>Uptime:</b></td><td>'+ uptime +'</td></tr>' + 
                      '<tr><td><i>Updated at</i></td><td><i>' + updtime + '</i></td></tr>' +
                      '</table></div>';

                    var icon = customIcons[stat] || {};
                    var marker = new google.maps.Marker({
                      map: map,
                      position: point,
                      icon: icon.icon,
                      shadow: icon.shadow
                    });
                    google.maps.event.addListener(marker, "rightclick",    function(event){showMenu(event.latLng);});                    
                    bindInfoWindow(marker, map, infoWindow, html);
                  }

                  var lat_center = ((lat_min + lat_max) / 2);
                  var lng_center = ((lng_min + lng_max) / 2);
                  var loc = new google.maps.LatLng(lat_center, lng_center);
                  map.setCenter(loc);
                /*  if(lat_max > lat_min)
                  {
                    map.setZoom(Math.floor(13/Math.abs(lat_max-lat_min)));
                  }
                  else
                  {*/
                    map.setZoom(8);
                 // } 

                });
              }

              function bindInfoWindow(marker, map, infoWindow, html) {
                google.maps.event.addListener(marker, 'click', function() {
                  infoWindow.setContent(html);
                  infoWindow.open(map, marker);
                });
              }

              function downloadUrl(url, callback) {
                var request = window.ActiveXObject ?
                    new ActiveXObject('Microsoft.XMLHTTP') :
                    new XMLHttpRequest;

                request.onreadystatechange = function() {
                  if (request.readyState == 4) {
                    request.onreadystatechange = doNothing;
                    callback(request, request.status);
                  }
                };

                request.open('GET', url, true);
                request.send(null);
              }

              function doNothing() {}

              function closeMenu()
              {
                $('.contextmenu').remove();              
              }

              function showMenu(click_pos)
              {
                closeMenu();
                var menuDiv = document.createElement("div");
                menuDiv.className  = 'contextmenu';
                menuDiv.innerHTML = '<div class="menuItem" onclick="javascript:setDirFrom(\''+ click_pos +'\')">Direction from here</div><div class="menuItem" onclick="javascript:setDirTo(\''+ click_pos +'\')">Direction to here</div>';
                var mapDiv = $(map.getDiv());
                mapDiv.append(menuDiv);

                var mapWidth = mapDiv.width();
                var mapHeight = mapDiv.height();
                var menuWidth = $('.contextmenu').width();
                var menuHeight = $('.contextmenu').height();

                var scale = Math.pow(2, map.getZoom());
                var nw = new google.maps.LatLng(
                  map.getBounds().getNorthEast().lat(),
                  map.getBounds().getSouthWest().lng()
                );
                var worldCoordinateNW = map.getProjection().fromLatLngToPoint(nw);
                var worldCoordinate = map.getProjection().fromLatLngToPoint(click_pos);
                var Pos = new google.maps.Point(
                  Math.floor((worldCoordinate.x - worldCoordinateNW.x) * scale),
                  Math.floor((worldCoordinate.y - worldCoordinateNW.y) * scale)
                );

                var x = Pos.x ;
                var y = Pos.y ;
                
                if((mapWidth - x ) < menuWidth)
                  x = x - menuWidth;
                if((mapHeight - y ) < menuHeight)
                  y = y - menuHeight;

                $('.contextmenu').css('left',x  );
                $('.contextmenu').css('top',y );
              
                menuDiv.style.visibility = "visible";
           
              }              

              function calcRoute()
              {
                if( mark_from )
                {
                  mark_from.setVisible(false);
                }
                if( mark_to )
                {
                  mark_to.setVisible(false);
                }

                var request = {
                  origin: dir_from,
                  destination: dir_to,
                  travelMode: google.maps.DirectionsTravelMode.DRIVING
                };
                directionsService.route(request, function(response, status) {
                  if (status == google.maps.DirectionsStatus.OK) {
                    directionsDisplay.preserveViewport = true;
                    directionsDisplay.setDirections(response);
                  }
                  else if(status == google.maps.DirectionsStatus.INVALID_REQUEST)
                  {
                    alert('spatna data');
                  }
                  else
                  {
                    alert('chyba: ' + status);
                  }
                });
              }

              function setDirFrom(pos)
              {
                closeMenu();
                if( mark_from )
                {
                  mark_from.setVisible(false);
                }
                dir_from = pos;

                var pos = pos.substring(1, pos.indexOf(')'));
                var coordinates = pos.split(",");
                var latlng = new google.maps.LatLng(coordinates[0], coordinates[1]);
                mark_from = new google.maps.Marker({
                  position: latlng, 
                  map: map,
                  icon:new google.maps.MarkerImage('http://maps.gstatic.com/mapfiles/icon_greenA.png'),
                  title:"Direction from here"
              });

                if( dir_to )
                {
                  calcRoute();                
                }
              }

              function setDirTo(pos)
              {
                closeMenu();
                if( mark_to )
                {
                  mark_to.setVisible(false);
                }
                dir_to = pos;
                var pos = pos.substring(1, pos.indexOf(')'));
                var coordinates = pos.split(",");
                var latlng = new google.maps.LatLng(coordinates[0], coordinates[1]);

                mark_to = new google.maps.Marker({
                  position: latlng, 
                  map: map,
                  icon:new google.maps.MarkerImage('http://maps.gstatic.com/mapfiles/icon_greenB.png'),
                  title:"Direction to here"
              });

                if( dir_from )
                {
                  calcRoute();                
                }
              }

            </script>
            <style type="text/css">
              .contextmenu{
                visibility:hidden;
                background:#ffffff;
                z-index: 10;  
                position: relative;
                border:1px;
                cursor:pointer;
                border-left:1px solid #cccccc;
                border-top:1px solid #cccccc;
                border-right:1px solid #676767;
                border-bottom:1px solid #676767;
                width:140px;
              }
              .menuItem {
                z-index: 20;
                padding: 5px;
                margin: 2px;
              }  

              .menuItem:hover {
                background-color:#d6e9f8 ;
              }

              .contextmenu div{
                padding-left: 5px
              }
            </style>
           <tr>    
              <th colspan="3">Map</th>  
            </tr>
            <tr>
            <tr>
              <td align="left" colspan="3">
                <table width="100%">
                  <tr>
                    <td>
                      <table>
                        <tr>
                          <td>
                            <div id="map" style="width: 1000px; height: 700px"></div>
                            <div id="directions-panel"></div>
                            <script>load()</script>
                          </td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
<?php
	// pripojeni paticky
  include ("php/bottom.php");

?>

