<?php
/***************************************************************************/
/*                                                                         */
/*  HLAVNI STRANKA - SEZNAM ZARIZENI				                               */
/*                                                                         */
/***************************************************************************/

  $not_logo = 1;  // nezobrazovat logo firmy na teto strance

  include ("php/head.php");
  include ("php/menu.php");
  flush();  
  require_once ("php/misc.php");

	if(isset($_GET['dir']))
	{	// je nastaveno razeni
		$_SESSION['dir'] = urldecode($_GET['dir']);
  }
  else
  {
    $_SESSION['dir'] = 'up';
  }  

  require_once "php/mysql.php"; 

  include ("php/js_misc.php");

  // zrusime vyber firmy
  //set_company_id(0);

  js_begin("
              function updateTableHeader() {
                var window_pos = GetScrollY();
                var head_line = document.getElementById('head_line');
                var head_div = document.getElementById('table_header');
  
                if( window_pos > GetPos(head_line) )
                {
                  head_div.style.visibility = \"visible\";
                  head_div.style.width = \"0px\";
                  head_div.style.top = document.body.scrollTop;
                }
                else
                {
                  head_div.style.visibility = \"hidden\";  
                }
              }    
  ");


  // pripojeni k DB
  $link = db_connect();
            
  // ukazatel na aktualni stranku seznamu
  if (!isset($_GET['set']))
  { // otevrit prvni stranku seznamu
    $set = 1;
  }
  else
  {	// otevrit zadanou stranku seznamu
    $set = $_GET['set'];
  }        
        
  // pocet polozek na strance seznamu
            
  if( isset($_GET['on_page']) )
  {
    if( ($_GET['on_page'] == 25) | ($_GET['on_page'] == 100) | ($_GET['on_page'] == 1000) )
    {
      $_SESSION['count_on_page'] = $_GET['on_page']; 
    }
  }
  if( !isset($_SESSION['count_on_page']) )
  {
    $_SESSION['count_on_page'] = 25;
  }
        
  // zjisteni poctu vsech zarizeni
  $sql = 'SELECT COUNT(*) FROM companies';
  // vykonani SQL prikazu
  $result = db_query($link, $sql);
            
  list($temp_set) = mysqli_fetch_row($result);
  $count_all_companies = $temp_set;
  $temp_set = ceil($temp_set / 25);
  if($set > $temp_set)
  { // neplatna hodnota $set
    $set = $temp_set;
  }

  if($set<1)
  {	// neplatna hodnota set
    $set = 1;
  }
            
  if(isset($_GET['name_filter']))
  {	// je nastaven filtr name
    $_SESSION['name_filter'] = sanitize_text($_GET['name_filter']);
  }

  if(isset($_GET['address_filter']))
  {	// je nastaven filtr address
    $_SESSION['address_filter'] = sanitize_text($_GET['address_filter']);
  }            

  if(isset($_GET['ord']))
  {	// je nastaven filtr firmware
    $_SESSION['ord'] = sanitize_identifier($_GET['ord']);
  }
  else
  {
    unset($_SESSION['ord']);
//    unset($_SESSION['dir']);
  }

?>
            <tr>
              <th colspan="3">Company List</th>
            </tr>
            <tr>
              <td align="center" colspan="3">
                <table cellspacing="0" cellpadding="1" border="1" style="border-collapse:collapse;" id="dev_list_table">
                  <tr id="head_line">
                    <td nowrap width="50px" height="25px" align="center" class="header"><a href="index.php?page=company_list&ord=comp_num&dir=<?php echo($_SESSION['dir'] == 'up' ? 'down' : 'up')?>">:.</a></td>
                    <td nowrap align="center" class="header" width="170px"><a href="index.php?page=company_list&ord=name&dir=<?php echo($_SESSION['dir'] == 'up' ? 'down' : 'up')?>">Name</a></td>
                    <td nowrap width="70px" height="25px" align="center" class="header"><a href="index.php?page=company_list&ord=devcount&dir=<?php echo($_SESSION['dir'] == 'up' ? 'down' : 'up')?>">DevCount</a></td>
                    <td nowrap align="center" class="header" width="300px"><a href="index.php?page=company_list&ord=address&dir=<?php echo($_SESSION['dir'] == 'up' ? 'down' : 'up')?>">Address</a></td>
                    <td nowrap align="center" class="header" width="170px">Email</td>
                    <td nowrap align="center" class="header" width="170px">Phone</td>
                    <td nowrap align="center" class="header" width="170px">Note</td>
                    <td nowrap align="center" class="header" width="70px" colspan="2">Operation</td>
                  </tr>
                  <tr class="tab_line1" align="center">
                  <form id="filtr" action="index.php" method="get">
                    <input id="filtr" type="hidden" name="page" value="company_list">
                    <td><input id="filtr" class="filter_button" type="submit" value="Filter"></td>
                    <td><input id="filtr" type="text" name="name_filter" value="<?php echo (isset($_SESSION['name_filter']) ? $_SESSION['name_filter'] : '')?>" size="20"></td>
                    <td></td>
                    <td><input id="filtr" type="text" name="address_filter" value="<?php echo (isset($_SESSION['address_filter']) ? $_SESSION['address_filter'] : '')?>" size="30"></td>
                    <td></td>
                    <td></td>
                    <td></td>
                    <td colspan="2"></td>
                  </form id="filtr">
                  </tr>
<?php
			
  $sql = '';
					
  if((isset($_SESSION['name_filter'])) && ($_SESSION['name_filter'] != ''))
  {
    $sql = $sql.'AND name LIKE "%'.mysqli_real_escape_string($link,$_SESSION['name_filter']).'%" ';                 
  }

  if((isset($_SESSION['address_filter'])) && ($_SESSION['address_filter'] != ''))
  {
    $sql = $sql.'AND address LIKE "%'.mysqli_real_escape_string($link,$_SESSION['address_filter']).'%" ';                 
  }            

  if((isset($_SESSION['ord'])) && ($_SESSION['ord'] != ''))
  {
    $sql = $sql.'ORDER BY "'.mysqli_real_escape_string($link,$_SESSION['ord']).'" ';          
  }

  if((isset($_SESSION['dir'])) && ($_SESSION['dir'] != ''))
  {
    if($_SESSION['dir'] == 'down')
    {
      $sql = $sql.'DESC ';
    }
  }
						
  $sql = $sql.'LIMIT '. (($set - 1) * $_SESSION['count_on_page']).','.$_SESSION['count_on_page'];    

//  $sql = 'SELECT company_id, name, address, email, phone, note FROM companies WHERE ""="" '.$sql;	 
  $sql = 'call sp_GetCompanies(\''.$sql.'\')';

  // vykonani SQL prikazu
	$result = db_query($link, $sql);

  $i = 0;
  // nacteni dat z odpovedi
  while (list($comp_num,$company_id,$name,$devcount,$address,$email, $phone, $note) = mysqli_fetch_row($result))
  {
    // kontrola hodnot
    $name           = is_null($name) ? "---" : $name;
    $address        = is_null($address) ? "---" : $address;
    $email          = is_null($email) ? "---" : $email;
    $phone          = is_null($phone) ? "---" : $phone;
    $note           = is_null($note) ? "---" : $note;

    // vytvoreni jednoho radku tabulky
    echo "                  <tr align=\"center\" class=\"tab_line".($i % 2)."\" height=\"27px\">\n";
    echo "                    <td>".$comp_num."</td>\n";
    echo "                    <td><a href=\"index.php?page=device_list&company_id=".$company_id."\">".$name."</a></td>\n";
    echo "                    <td>".$devcount."</td>\n";
    echo "                    <td>".$address."</td>\n";
//    if(filter_var($email, FILTER_VALIDATE_EMAIL))
    if( validate_email($email) )
    {
      echo "                    <td><a href=\"mailto:".$email."\">".$email."</a></td>\n";    
    }
    else
    {
      echo "                    <td>".$email."</td>\n";    
    }
    echo "                    <td>".$phone."</td>\n";
    echo "                    <td>".$note."</td>\n";
    echo "                    <td><img src=\"img/pencil.png\" border=\"0\" valign=\"center\" onclick=\"window.open('index.php?page=edit_company_form&company_id=".$company_id."','_self');\" title=\"Edit Company\"></td>\n";     
    echo "                    <td><img src=\"img/cross.png\" border=\"0\" valign=\"center\" onclick=\"do_link('index.php?page=company_change&oper=remove&company_id=".$company_id."','Are you sure?');\" title=\"Remove Company\"></td>\n";     echo "                  </tr>\n";
    $i++;
  }
 
	if(mysqli_more_results($link))
	{	//Catch 'OK'/'ERR'
		while(mysqli_next_result($link));
	}     

/*  if(isset($_SESSION['logged']) && (($_SESSION['logged'] == 1) || ($_SESSION['logged'] == 100)))
  {	
    echo "                  </form id=\"devselect\">\n";
  }*/

  // ziskani poctu vsech zarizeni vyhovujicich filtru
  $sql = 'SELECT COUNT(*) FROM companies WHERE ""="" ';
						
  if((isset($_SESSION['name_filter'])) && ($_SESSION['name_filter'] != ""))
  {	// zahrneme filtr description
    $sql = $sql.'AND name LIKE "%'.mysqli_real_escape_string($link,$_SESSION['name_filter']).'%" ';                 
  }
  if((isset($_SESSION['address_filter'])) && ($_SESSION['address_filter'] != ""))
  {	// zahrneme filtr description
    $sql = $sql.'AND address LIKE "%'.mysqli_real_escape_string($link,$_SESSION['address_filter']).'%" ';                 
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);
           
  // nacteni dat z odpovedi
  list($count_filtered) = mysqli_fetch_row($result); 
                
  // uvolneni pameti
  mysqli_free_result($result);
  // uzavreni spojeni s DB
  mysqli_close($link);  
        
?>
                </table>
              </td>
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td align="left">
                      <table>
                        <tr>
                          <td>
                          </td>
                        </tr>
<?php

  if( $cfg['user_link_target'] != '')
  {
    echo "                        <tr>\n";
    echo "                          <td><a href=\"http://".$cfg['user_link_target']."\">".($cfg['user_link_text'] == '' ? $cfg['user_link_target'] : $cfg['user_link_text'])."</a></td>\n";
    echo "                        </tr>\n";
  }

?>
                      </table>
                    </td>
                    <td align="center">
                      <table>
                        <tr>
                          <td align="center" colspan="4">
                          </td>
                        </tr>
                        <tr height="20px">
                        </tr>
                      </table>
                    </td>
                    <td align="right">
<?php
      
// generovani tlacitek strankovani
						
  // funkce pro vytvoreni odkazu
  function getPageLink($i, $page)
  {
    if($i == $page)
    {	// aktualni stranka nebude odkazem
      return "                        <td class=\"aktivni\">". $i ."</td>\n";
    }
    // odkaz na stranku
    return "                        <td><a href=\"".($i != 1 ? '?set='.$i : '.')."\">".$i."</a></td>\n";
  }
          
  // celkovy pocet stranek
  $maxset = ceil($count_filtered/$_SESSION['count_on_page']);           
                      
  // pocet okolnich stranek				
  $neighbours = 9;
           
  echo "                      <table class=\"navlist\">\n";
  echo "                        <tr>\n";
								
  // odkaz na prvni stranku bude vzdy	
  echo(getPageLink(1, $set));
							
  if($set > $neighbours)
  {	// stranka po prvni strance je dale nez $neighbours
    echo "                        <td>...</td>\n";
  }
							
  // pocet stranek mezi
  $to = min($maxset, $set + $neighbours);
  for($i = max(2, $set - $neighbours + 1); $i < $to; $i++)
  {	// generovani prostrednich stranek
    echo(getPageLink($i, $set));
  }
           
  if($set + $neighbours < $maxset)
  {	// stranka pred posledni strankou je dale nez $neighbours
    echo "                        <td>...</td>\n";
  }
           
  if($maxset > 1)
  {	// odkaz na posledni stranku bude vzdy
    echo(getPageLink($maxset, $set));           
  }
  echo "                        </tr>\n";
  echo "                      </table>\n";
?>
                      <a href=index.php?page=company_list&on_page=25>25</a> | <a href=index.php?page=company_list&on_page=100>100</a> records per page
                      <form style="margin-bottom: 0px" action="index.php" method="get">
                        <label for="gotopage">Go to page</label>                
                        <input type="text" name="set" id="gotopage" size="3">
                      </form>
                    </td>
                  </tr>
                </table>
                <style>
                  #table_header{
                    position: absolute;
                    visibility: hidden;
                  }
                </style>
                <div id="table_header">
                  <table cellspacing="0" cellpadding="1" border="1" style="border-collapse:collapse;" width="100%">
                    <tr>
                      <td nowrap width="50px" height="25px" align="center" class="header"><a href="index.php?page=company_list&ord=comp_num&dir=<?php echo($_SESSION['dir'] == 'up' ? 'down' : 'up')?>">:.</a></td>
                      <td nowrap align="center" class="header" width="170px"><a href="index.php?page=company_list&ord=name&dir=<?php echo($_SESSION['dir'] == 'up' ? 'down' : 'up')?>">Name</a></td>
                      <td nowrap width="70px" height="25px" align="center" class="header"><a href="index.php?page=company_list&ord=devcount&dir=<?php echo($_SESSION['dir'] == 'up' ? 'down' : 'up')?>">DevCount</a></td>
                      <td nowrap align="center" class="header" width="300px"><a href="index.php?page=company_list&ord=address&dir=<?php echo($_SESSION['dir'] == 'up' ? 'down' : 'up')?>">Address</a></td>
                      <td nowrap align="center" class="header" width="170px">Email</td>
                      <td nowrap align="center" class="header" width="170px">Phone</td>
                      <td nowrap align="center" class="header" width="170px">Note</td>
                      <td nowrap align="center" class="header" width="70px" colspan="2">Operation</td>
                    </tr>
                  </table>
                </div>
              </td>
            </tr>
<?php

  js_end("
            window.onscroll = function () {
              updateTableHeader();
            }    
    ");

	// pripojeni paticky
  include ("php/bottom.php");

?>
