<?php
/***************************************************************************/
/*                                                                         */
/*  FORMULAR PRO OBECNA NASTAVENI   				                               */
/*                                                                         */
/***************************************************************************/
  if( get_company_id() == 0 )
  { // neni zvolena firma -> nevime, u koho nastavovat, presmerujeme na vyber firmy
    header('Location: index.php?page=company_list');    
    exit;
  }

	// pripojeni hlavicky
  include ("php/head.php");
	
	// pripojeni menu
  include ("php/menu.php");

	require_once "config.inc.php";	

  include ("php/js_misc.php");

  $_SESSION['last'] = $_SERVER['REQUEST_URI'];

  if(isset($_GET['sub_opt']) && ($_GET['sub_opt'] != ''))
  {
    $sub_opt = $_GET['sub_opt'];
  }
  else
  {
    $sub_opt = "general_opt";
  }


  if (is_admin())
  {
    $whitelist_opt = array( 
    "general_opt",
    "appearance_opt",
    "snmp_opt",
    "email_sms_opt",
    "warnings_opt",
    "report_opt");
  }
  else
  {
    $whitelist_opt = array( 
    "general_opt",
    "appearance_opt",
    "report_opt");
  }

  if(!in_array($sub_opt,$whitelist_opt)) $sub_opt = "general_opt";

//echo $sub_opt;

  js_begin("
                  var sel_list;
                  var disp_list;
                  var col_list_hidden;

                  function init()
                  {
                    sel_list = document.getElementById('sel_list');
                    disp_list = document.getElementById('disp_list');
                    col_list_hidden = document.getElementById('col_list_sub');
                  }

                  function button_select()
                  {
                    if(disp_list.selectedIndex >= 0)
                    {
                      var new_column = document.createElement('option');
                      new_column.text = disp_list.options[disp_list.selectedIndex].text;
                      new_column.value = disp_list.options[disp_list.selectedIndex].value;

                      if(sel_list.selectedIndex >= 0)
                      {
                        var old_column = sel_list.options[sel_list.selectedIndex];
  
                        try
                        {
                          sel_list.add(new_column, old_column);
                        }
                        catch(ex)
                        {
                          sel_list.add(new_column, sel_list.selectedIndex);
                        }  
                      }
                      else
                      {
                        try
                        {
                          sel_list.add(new_column, null);
                        }
                        catch(ex)
                        {
                          sel_list.add(new_column);
                        }        
                      }

                      disp_list.remove(disp_list.selectedIndex);

                    }
                  }

                  function button_drop()
                  {
                    if((sel_list.selectedIndex >= 0) && (sel_list.length > 1))
                    {
                      var new_column = document.createElement('option');
                      new_column.text = sel_list.options[sel_list.selectedIndex].text;
                      new_column.value = sel_list.options[sel_list.selectedIndex].value;

                      try
                      {
                        disp_list.add(new_column, null);
                      }
                      catch(ex)
                      {
                        disp_list.add(new_column);
                      }        

                      sel_list.remove(sel_list.selectedIndex);
                    }
                  }

                  function button_up()
                  {
                    if((sel_list.selectedIndex > 0) && (sel_list.length > 1))
                    {
                      var new_column = document.createElement('option');
                      var sel_index = sel_list.selectedIndex;
                      new_column.text = sel_list.options[sel_index].text;
                      new_column.value = sel_list.options[sel_index].value;

                      var old_column = sel_list.options[sel_index - 1];

                      sel_list.remove(sel_index);        

                      try
                      {
                        sel_list.add(new_column, old_column);
                      }
                      catch(ex)
                      {
                        sel_list.add(new_column, sel_index - 1);
                      }  

                      sel_list.options[sel_index - 1].selected = true;
                    }      
                  }

                  function button_down()
                  {
                    if((sel_list.selectedIndex >= 0) && (sel_list.selectedIndex < (sel_list.length - 1)) && (sel_list.length > 1))
                    {
                      var new_column = document.createElement('option');
                      var sel_index = sel_list.selectedIndex;
                      new_column.text = sel_list.options[sel_index].text;
                      new_column.value = sel_list.options[sel_index].value;

                      var old_column = sel_list.options[sel_index + 2];
    
                      sel_list.remove(sel_index);        

                      try
                      {
                        sel_list.add(new_column, old_column);
                      }
                      catch(ex)
                      {
                        sel_list.add(new_column, sel_index + 1);
                      }  

                      sel_list.options[sel_index + 1].selected = true;
                    }    
                  }

                  function col_list_update()
                  {
                    col_list_hidden.value = '';
                    for(i = 0;i < sel_list.length;i++)
                    {
                      if(i > 0)
                      {
                        col_list_hidden.value = col_list_hidden.value + ',';
                      }
                      col_list_hidden.value = col_list_hidden.value + sel_list.options[i].value;                    
                    } 
                  }

                  function daily_disable_hours()
                  {
                    var daily_from_hour = document.getElementById('daily_from_hour');
                    var daily_to_hour = document.getElementById('daily_to_hour');
                    var from_hour = parseInt(daily_from_hour.value);
              
                    for(i = 0;i < daily_to_hour.length;i++)
                    {
                      daily_to_hour.options[i].disabled = i <= from_hour ? true : false;
                    }
              
                    if(daily_to_hour.selectedIndex <= from_hour)
                    {
                      daily_to_hour.selectedIndex = from_hour + 1;
                    }
                    return;
                  } 
  ");

?>
            <tr>    
              <th colspan="3">Options</th>  
            </tr>
            <tr>    
              <td colspan="3">
                <table>
                  <tr>
                    <td>
                      <a href="index.php?page=options&sub_opt=general_opt">General</a> | 
                      <a href="index.php?page=options&sub_opt=appearance_opt">Appearance</a> |
<?php

  if( is_admin() )
  {
    echo "                      <a href=\"index.php?page=options&sub_opt=snmp_opt\">Snmp</a> |\n";
    echo "                      <a href=\"index.php?page=options&sub_opt=email_sms_opt\">Email & Sms</a> |\n";  
    echo "                      <a href=\"index.php?page=options&sub_opt=warnings_opt\">Warnings</a> |\n";  
  }


?>
                      <a href="index.php?page=options&sub_opt=report_opt">Report</a>
                    </td>
                  </tr>
                </table>
              </td>  
            </tr>
<?php
  include($sub_opt.".php");

	// pripojeni paticky
  include ("php/bottom.php");

?>
