<?php

/***************************************************************************/
/*                                                                         */
/*  FORMULAR PRO GENEROVANI REPORTU					                               */
/*                                                                         */
/***************************************************************************/

  if( get_company_id() == 0 )
  { // neni zvolena firma -> nevime, u koho nastavovat, presmerujeme na vyber firmy
    header('Location: index.php?page=company_list');    
    exit;
  }


  include ("php/head.php");
  include ("php/menu.php");
  include ("php/js_misc.php");

  include ("php/report_columns.php");

  $header = Array();

  foreach($report_list_selected as $id => $par_name)
  {
    $header[$id] = $report_list_cols[$par_name];
  }

  flush();  

	// pripojeni k DB
  $link = db_connect();  

  $data_src = URI_get_string("data_src");
  if( is_null($data_src) )
  {
    $data_src = "all";
  }

  $group_id = URI_get_int("group_id");
  
  $host = URI_get_string("host");
  if( is_null($host) && $data_src == "host" )
  {
    echo "Missing hostname!!!";
    exit;
  }

  $latency_limit = is_null(URI_get_int("latency_limit")) ? 400 : URI_get_int("latency_limit");
  $ploss_limit = is_null(URI_get_int("ploss_limit")) ? 4 : URI_get_int("ploss_limit");
  $avail_limit = is_null(URI_get_int("avail_limit")) ? 99 : URI_get_int("avail_limit");
  $signal_limit = is_null(URI_get_int("signal_strength_limit")) ? -85 : URI_get_int("signal_strength_limit");

  $sub_opt = URI_get_string("sub_opt");
  if( is_null($sub_opt) )
  {
    $sub_opt = "latency";
  }

  $list_err = URI_get_int("list_err");
  if( is_null($list_err) )
  {
    $list_err = 0;
  }

  // rozsireni kalendare
  ob_start();
  echo "              var filt_cnt  = 0;\n";
  echo "              var filt_head = new Array();\n";
  echo "              var filt_body = new Array();\n";
  echo "              var filt_style = new Array();\n";        

  echo "              filt_head[filt_cnt] = \"Data Source:\";\n";
  echo "              filt_body[filt_cnt] = \"\";\n";
  echo "              filt_style[filt_cnt++] = \"calendar_header\";\n";

  echo "              filt_head[filt_cnt] = \"<input type=\\\"radio\\\" name=\\\"data_src\\\" value=\\\"all\\\"".($data_src == "all" ? " checked" : "").">All Devices\";\n";
  echo "              filt_body[filt_cnt] = \"\";\n";
  echo "              filt_style[filt_cnt++] = \"\";\n";

  echo "              filt_head[filt_cnt] = \"<input type=\\\"radio\\\" name=\\\"data_src\\\" value=\\\"group\\\"".($data_src == "group" ? " checked" : "").">Group\";\n";

  // ziskani seznamu group

  $temp = "";

  if( is_superadmin() && ($company_id == 0) )
  {
    $sql = 'SELECT DISTINCT group_id, description
          FROM groups
          WHERE company_id = "'.get_company_id().'"
          ORDER BY description';
  }
  else  if( is_admin() )
  {
    $sql = 'SELECT DISTINCT group_id, description
          FROM groups
          WHERE company_id = "'.get_company_id().'"
          ORDER BY description';
  }
  else
  {
    $sql = 'SELECT DISTINCT group_id, description
          FROM groups
          WHERE company_id = "'.get_company_id().'"
          AND groups.group_id
          IN (SELECT group_id
             FROM user_group
             WHERE user_id ='.get_user_id( ).'
              )
          ORDER BY description';
  }
  

  $result = db_query($link, $sql);

  while(list($id, $desc) = mysqli_fetch_row( $result ))
  {
    if( $id == $group_id )
    {
      $group_name = $desc;
    }
    $temp = $temp."<option value=\\\"".$id."\\\"".($id == $group_id ? " selected" : "").">".$desc."</option>";
  }

  echo "              filt_body[filt_cnt] = \"<select name=\\\"group_id\\\">".$temp."</select>\";\n";
  echo "              filt_style[filt_cnt++] = \"\";\n";

  echo "              filt_head[filt_cnt] = \"<input type=\\\"radio\\\" name=\\\"data_src\\\" value=\\\"host\\\"".($data_src == "host" ? " checked" : "").">Hostname\";\n";
  echo "              filt_body[filt_cnt] = \"<input type=\\\"text\\\" name=\\\"host\\\" value=\\\"".$host."\\\" size=\\\"10\\\">\";\n";
  echo "              filt_style[filt_cnt++] = \"\";\n";

  if( $sub_opt != "daily" )
  {

    echo "              filt_head[filt_cnt] = \"<input type=\\\"checkbox\\\" name=\\\"list_err\\\" value=\\\"1\\\"".($list_err == "1" ? " checked" : "").">List err\";\n";
    echo "              filt_body[filt_cnt] = \"\";\n";
    echo "              filt_style[filt_cnt++] = \"\";\n";

    echo "              filt_head[filt_cnt] = \"Limits:\";\n";
    echo "              filt_body[filt_cnt] = \"\";\n";
    echo "              filt_style[filt_cnt++] = \"calendar_header\";\n";

  }

  if( $sub_opt == "all" || $sub_opt == "latency" )
  {  
    echo "              filt_head[filt_cnt] = \"Latency\";\n";
    echo "              filt_body[filt_cnt] = \"<input type=\\\"text\\\" name=\\\"latency_limit\\\" value=\\\"".$latency_limit."\\\" size=\\\"5\\\"> ms\";\n";
    echo "              filt_style[filt_cnt++] = \"\";\n";
  }

  if( $sub_opt == "all" || $sub_opt == "ploss" )
  {  
    echo "              filt_head[filt_cnt] = \"Packet Loss\";\n";
    echo "              filt_body[filt_cnt] = \"<input type=\\\"text\\\" name=\\\"ploss_limit\\\" value=\\\"".$ploss_limit."\\\" size=\\\"5\\\"> %\";\n";
    echo "              filt_style[filt_cnt++] = \"\";\n";
  }

  if( $sub_opt == "all" || $sub_opt == "avail" )
  {  
    echo "              filt_head[filt_cnt] = \"Availability\";\n";
    echo "              filt_body[filt_cnt] = \"<input type=\\\"text\\\" name=\\\"avail_limit\\\" value=\\\"".$avail_limit."\\\" size=\\\"5\\\"> %\";\n";
    echo "              filt_style[filt_cnt++] = \"\";\n";
  }

  if( $sub_opt == "all" || $sub_opt == "signal" )
  {  
    echo "              filt_head[filt_cnt] = \"Signal Strength\";\n";
    echo "              filt_body[filt_cnt] = \"<input type=\\\"text\\\" name=\\\"signal_strength_limit\\\" value=\\\"".$signal_limit."\\\" size=\\\"5\\\"> dBm\";\n";
    echo "              filt_style[filt_cnt++] = \"\";\n";
  }

  $calendar_appendix = ob_get_contents();
  ob_end_clean();

  js_begin( $calendar_appendix );



  $from = is_null(URI_get_int("from")) ? strtotime(date("Y-m-d", time())) : intval(URI_get_int("from"));

  $day_count = URI_get_int("day_count");
  $to = is_null($day_count) ? $from + 86400 : $from + ($day_count * 86400);
	if($to > time())
	{
		$to = time();
	}

  $sel_mode = URI_get_int("sel_mode");
  $sel_index = URI_get_int("sel_index");
  $current = URI_get_string("current");


  $link_add = "&from=".$from."&day_count=".$day_count."&sel_mode=".$sel_mode."&sel_index=".$sel_index."&data_src=".$data_src."&group_id=".$group_id."&host=".$host."&list_err=".$list_err;

  if( !is_null($current) )
  {
    $link_add=$link_add."&current=".$current;  
  }

  if( $sub_opt == "daily" )
  { // daily report nezacina o pulnoci a zabira pouze jeden den
    $tmp_from = $from;
    $from = mktime($cfg['daily_report_from'],0,0,date("n",$tmp_from),date("j",$tmp_from),date("Y",$tmp_from));
    $to   = mktime($cfg['daily_report_to'],0,0,date("n",$tmp_from),date("j",$tmp_from),date("Y",$tmp_from));  
  }

?>
            <tr>    
              <th colspan="3">Report</th>  
            </tr>
            <tr>
            <tr>    
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td nowrap>
<?php
  echo "                      <a href=\"index.php?page=report_form&sub_opt=latency".$link_add."\">Latency</a> | \n";
  echo "                      <a href=\"index.php?page=report_form&sub_opt=ploss".$link_add."\">Packet Loss</a> | \n";
  echo "                      <a href=\"index.php?page=report_form&sub_opt=avail".$link_add."\">Availability</a> | \n";
  echo "                      <a href=\"index.php?page=report_form&sub_opt=signal".$link_add."\">Signal Strength</a> | \n";
  echo "                      <a href=\"index.php?page=report_form&sub_opt=ronline".$link_add."\">Routers Online</a> | \n";
  echo "                      <a href=\"index.php?page=report_form&sub_opt=all".$link_add."\">All</a> \n";
?>
                    </td>
                    <td nowrap width="100%" align="right">
<?php
  echo "                      <a href=\"index.php?page=report_form&sub_opt=daily".$link_add."\">Daily Report</a>\n";
?>
                    </td>
                  </tr>
                </table>
              </td>  
            </tr>
              <td align="center" colspan="3">
                <table width="100%">
                  <tr>
                    <td valign="top">
                      <div id='CalendarControl'></div>
                      <script src="js/calendar.js" type="text/javascript"></script>
                      <script>
                        showCalendarControl();
                      </script>
                    </td>
                    <td valign="top" align="center" width="100%">
                      <table width="100%">
<?php

  echo "                        <tr align=\"center\">\n";
  echo "                          <td align=\"center\">\n";

  echo "                            <b>Export report:</b>\n";

  if ( file_exists( "mpdf/mpdf.php" ) )
  {
    echo "                            <a href=\"index.php?page=pdf_export&name=R_SeeNet_Report_".date("d_m_Y_H_i", time()).".pdf\">PDF</a>\n";
  }

  if( $list_err == "1" )
  {
    echo "                            | <a href=\"index.php?page=csv_export&name=R_SeeNet_Report_".date("d_m_Y_H_i", time()).".csv\">CSV</a>\n";
  }

  echo "                          </td>\n";
  echo "                        </tr>\n";

  // odchyceni stranky
  ob_start();
?>
                        <tr align="center">
                          <td align="center"><?php echo '<b>From: </b>'.date("d-m-Y H:i",$from).' <b>To: </b>'.date("d-m-Y H:i",$to); ?></td>
                        </tr>
<?php

  echo "                        <tr align=\"center\">\n";
  echo "                          <td align=\"center\"><b>\n";

  switch( $data_src )
  {
    case "all":
      echo "                          All Devices\n";
      break;

    case "group":
      echo "                          Group: ".$group_name."\n";
      break;      

    case "host":
      echo "                          Hostname: ".$host."\n";
      break;      
    default:
      echo "                          Unknown\n";
  }

  echo "                          </b></td>\n";
  echo "                        </tr>\n";

  // otevreni docasneho csv souboru
  $csv = fopen($temp_path."/temp.csv",'w');

  if( $sub_opt == "all" || $sub_opt == "latency" )
  {
    include "php/report_latency.php";
    fwrite($csv,"\n\n");
  }

  if( $sub_opt == "all" || $sub_opt == "ploss" )
  {
    include "php/report_ploss.php";
    fwrite($csv,"\n\n");
  }  

  if( $sub_opt == "all" || $sub_opt == "avail" )
  {
    include "php/report_avail.php";
    fwrite($csv,"\n\n");
  }

  if( $sub_opt == "all" || $sub_opt == "signal" )
  {
    include "php/report_signal.php";
  }

  if( $sub_opt == "all" || $sub_opt == "ronline" )
  {
    include "php/report_ronline.php";
  }

  if( $sub_opt == "daily" )
  {
    include "php/report_daily.php";
  }

  fclose($csv);

?>
                        <tr align="left">
                          <td nowrap class="header"><i>Notes</i></td>
                        </tr>
                        <tr>
                          <td align="center">  
                            <table>
                              <tr>
                                <th colspan="2">Router status</th>
                              </tr>
                              <tr>
                                <td>0</td><td align="left"> - Online</td>
                              </tr>
                              <tr>
                                <td>1</td><td align="left"> - Problem in reading</td>
                              </tr>
                              <tr>
                                <td>2</td><td align="left"> - Offline</td>
                              </tr>
                            </table>
                          </td>
                        </tr>
<?php   
  // konec odchyceni stranky
  $page = ob_get_clean();
  echo $page;

  $page = "<h1 align=\"center\">R-SeeNet Report</h1><table width=\"100%\">".$page."</table>";


  $fd = fopen($temp_path."/temp.html",'w');
  fwrite($fd, $page);
  fclose($fd);
?>
                      </table>
              </td>
            </tr>
<?php
	// pripojeni paticky
  include ("php/bottom.php");

?>