<?php

/***************************************************************************/
/*                                                                         */
/*  SCRIPT PRO VYTVARENI GRAFU							                               */
/*                                                                         */
/***************************************************************************/
  
  require_once("pGraph/pData.class");
  require_once("pGraph/pChart.class");	

	if(count($y_data) < 2)
	{
		$file = "img/graph_no_data.png";
		if (file_exists($file)) {
      copy($file,$filename); 
		}	
		return;
	}
	
  // zjisteni nejmensiho intervalu mezi body na X-ove ose
	$x_diff = 40000000;
	for($i = 0;$i < (sizeof($x_data) - 2);$i++)
	{
		if((($x_data[$i + 1] - $x_data[$i]) < $x_diff) && (($x_data[$i + 1] - $x_data[$i]) > 500))
		{
			$x_diff = $x_data[$i + 1] - $x_data[$i];
		}
	}  
    
	$x_corr = array();
	$y_corr = array();
	$y_shadow = array();
	$i_corr = 0;
	
  // tam kde je velka mezera doplnime bodu aby byla X-ova osa +- linearni
  
	for($i = 0;$i < (sizeof($x_data) - 1);$i++)
	{
		if(($x_data[$i + 1] - $x_data[$i]) > (2 * $x_diff))
		{ // bude se doplnovat
      // pocet - kolik bodu se bude doplnovat
			$miss_count = floor(($x_data[$i + 1] - $x_data[$i]) / $x_diff);
			for($j = 0;$j < $miss_count;$j++)
			{
				$x_corr[$i_corr] = $x_data[$i] + ($j * $x_diff);
				$y_corr[$i_corr] = '';
        $y_shadow[$i_corr] = $y_top;
				$i_corr++;				
			}
    }
		else
		{ // bude se pouze kopirovat
			$x_corr[$i_corr] = $x_data[$i];
			$y_corr[$i_corr] = is_null($y_data[$i]) ? '' : $y_data[$i];
      
      
      if(is_null($y_data[$i]))
      {
        $y_shadow[$i_corr] = $y_top;
      }
      
      $y_shadow[$i_corr] = is_null($y_data[ $i ]) ? $y_top : '';
     
			$i_corr++;
		}
	}

	$x_skip = ceil(count($x_corr) / 20);  

	if( ($to - $from) <= 86400 )
	{
		$date_format = "H:i";
	}
	else
	{
		$date_format = "d/m";	
	}

  $DataSet = new pData;
  $DataSet->AddPoint($y_corr,"Serie1");
  $DataSet->AddPoint($y_shadow,"Serie3");
  $DataSet->AddPoint($x_corr,"Serie2");
  $DataSet->SetAbsciseLabelSerie("Serie2");
  $DataSet->SetSerieName("Sample data","Serie1");
  $DataSet->SetYAxisName($YAxisName);
  $DataSet->SetYAxisUnit($YAxisUnit);
  $DataSet->SetXAxisName("Time");
  $DataSet->SetXAxisFormat("date");

  // Initialise the graph
  $Graph = new pChart(672,330);
  $Graph->loadColorPalette('pGraph/palette.txt');
  $Graph->setFontProperties("Fonts/tahoma.ttf",10);
  $Graph->setDateFormat($date_format);
  $Graph->setGraphArea(76,30,670,250);
  $Graph->drawGraphArea(252,252,252,TRUE);
  $Graph->setFixedScale($y_bottom,$y_top,5,0,0,5);
  $Graph->drawScale($DataSet->GetData(),$DataSet->GetDataDescription(),SCALE_NORMAL,0,0,0,TRUE,45,0,FALSE,$x_skip);
  $Graph->drawGrid(4,TRUE,230,230,230,70);

  // Draw the graph  
  $DataSet->AddSerie("Serie1");	

  $Graph->drawLineGraph($DataSet->GetData(),$DataSet->GetDataDescription());
  $Graph->drawPlotGraph($DataSet->GetData(),$DataSet->GetDataDescription(),1,0,255,255,255);

  //$DataSet->RemoveSerie("Serie1");
  $DataSet->AddSerie("Serie3");
  $Graph->drawFilledLineGraph($DataSet->GetData(),$DataSet->GetDataDescription(),20,FALSE);

  // Finish the graph
  $Graph->setFontProperties("Fonts/tahoma.ttf",13);
  $Graph->drawTitle(130,20,$title,0,0,0,585);
  $Graph->Render($filename);

?>
