<?php

  // graf Latency    

  $x_data = array();
  $y_data = array();	

  
	$title = 'Average Availability';
	$YAxisName = 'Availability';
	$YAxisUnit = '%';

  switch( $data_src )
  {
    case "all":

      $sql = 'SELECT DATE_FORMAT(time,"%d-%m-%Y %H:00") as hour, AVG(availability)
              FROM summary
              WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
              GROUP BY DATE_FORMAT(time,"%d-%m-%Y %H")
              ORDER BY hour';

      break;

    case "group":
      $sql = 'SELECT DATE_FORMAT(time,"%Y-%m-%d %H:%i"), availability 
              FROM summary 
              WHERE group_id = "'.$group_id.'"
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
              ORDER BY time';
        
      break;          
        
    default:
      $sql = 'SELECT time, availability
              FROM stats
              WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
              ORDER BY time';
  }

  $result = db_query($link, $sql);
   
  $i = 0;
	
  $i_max = mysqli_num_rows($result);
	
  for($i = 0;$i < $i_max;$i++)
  {
    list($x_data[$i], $y_data[$i]) = mysqli_fetch_row($result);
    $x_data[$i] = strtotime($x_data[$i]);
  }      
	
	$y_bottom = 0;
	$y_top = 100;


  include "php/report_graph.php";

?>
