<?php

/***************************************************************************/
/*                                                                         */
/*  SCRIPT PRO ZPRACOVANI VYBERU  					                               */
/*                                                                         */
/***************************************************************************/


	if (isset($_SESSION['last']) && !isset($_GET['drop_selection']) && ($_GET['action'] != 'remove'))
	{	// nacti predchozi stranku
		header('Refresh: 2; URL = '.urldecode($_SESSION['last']));
	}
	else
	{	// nacti vychozi stranku
		header('Refresh: 2; URL = index.php');
  }


  include ("php/head.php");
  include ("php/menu.php");

  $oper = URI_get_string("action");

?>
            <tr>
              <th colspan="3">Selection</th>
            </tr>
            <tr>
              <td align="left" colspan="3">
	<?php

	// pripojeni k databazi
	$link = db_connect();

  $sql = 'UPDATE devices
          SET new = "0"
          WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

	// vykonani SQL prikazu
	$result = db_query($link, $sql);

	switch($oper)
	{
		case "change_desc":
		{

      $desc = URI_get_string("description");

      $sql = 'UPDATE devices
              SET description = '.Str4Sql($desc).'
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "change_comm":
		{

			$comm = URI_get_string("community");

      $sql = 'UPDATE devices
              SET community = '.Str4Sql($comm).'
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "change_loc":
		{

			$loc = URI_get_string("location");

      $sql = 'UPDATE devices
              SET location = '.Str4Sql($loc).'
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "change_note":
		{

      $note = URI_get_string("note");

      $sql = 'UPDATE devices
              SET note = '.Str4Sql($note).'
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "change_period":
		{

      $period = URI_get_int("period");

      if( is_null($period) || ( $period < 1 ) )
      {
        $period = 15;
      }

      $sql = 'UPDATE devices
              SET period = '.$period.'
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "set_enabled":
		{

      $sql = 'UPDATE devices
              SET enabled = "1"
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "reset_enabled":
		{

      $sql = 'UPDATE devices
              SET enabled = "0"
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "set_autoupdate":
		{

      $sql = 'UPDATE devices
              SET autoupdate = "1"
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "reset_autoupdate":
		{

      $sql = 'UPDATE devices
              SET autoupdate = "0"
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "set_readgps":
		{

      $sql = 'UPDATE devices
              SET read_gps = "1"
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "reset_readgps":
		{

      $sql = 'UPDATE devices
              SET read_gps = "0"
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "set_readtempvolt":
		{

      $sql = 'UPDATE devices
              SET read_temp_volt = "1"
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "reset_readtempvolt":
		{

      $sql = 'UPDATE devices
              SET read_temp_volt = "0"
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "set_snmp":
		{

			$snmp_username = URI_get_string("snmp_username");
			$snmp_auth = URI_get_int("snmp_auth");
			$snmp_auth_password = URI_get_string("snmp_auth_password");
			$snmp_privacy = URI_get_int("snmp_privacy");
			$snmp_privacy_password = URI_get_string("snmp_privacy_password");

			$sql = 'UPDATE devices
              SET snmp_prot = "1",
				v3_username = '.Str4Sql($snmp_username).',
				v3_authentication = '.$snmp_auth.',
				v3_authpsw = '.Str4Sql($snmp_auth_password).',
				v3_privacy = '.$snmp_privacy.',
				v3_privpsw = '.Str4Sql($snmp_privacy_password).'
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "reset_snmp":
		{

			$sql = 'UPDATE devices
              SET snmp_prot = "0"
              WHERE device_id IN (SELECT device_id FROM selection WHERE session_id = "'.session_id().'")';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		case "remove":
		{

      $sql = 'SELECT device_id FROM selection
              WHERE session_id = "'.session_id().'"';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

      while( list($device_id) = mysqli_fetch_row( $result ) )
      {
        if( !is_null($device_id) )
        {
          $sql = 'DELETE FROM devices
                  WHERE device_id = "'.$device_id.'"';

    			// vykonani SQL prikazu
    			$result1 = db_query($link, $sql);

          $sql = 'DELETE FROM device_notes
                  WHERE device_id = "'.$device_id.'"';

    			// vykonani SQL prikazu
    			$result1 = db_query($link, $sql);

          $sql = 'DELETE FROM day
                  WHERE device_id = "'.$device_id.'"';

    			// vykonani SQL prikazu
    			$result1 = db_query($link, $sql);

          $sql = 'DELETE FROM fails
                  WHERE device_id = "'.$device_id.'"';

    			// vykonani SQL prikazu
    			$result1 = db_query($link, $sql);

          $sql = 'DELETE FROM stats
                  WHERE device_id = "'.$device_id.'"';

    			// vykonani SQL prikazu
    			$result1 = db_query($link, $sql);

        }
      }

			// vykonani SQL prikazu
      $result = db_query($link, $sql);

			$sql = 'DELETE FROM selection WHERE session_id = "'.session_id().'"';

			// vykonani SQL prikazu
			$result = db_query($link, $sql);

			break;
		}

		default : break;
	}


	if(isset($_GET['drop_selection']) && $_GET['drop_selection'] == 'clear')
	{	// ma se zrusit vyber
		$sql = 'DELETE FROM selection WHERE session_id = "'.session_id().'"';

		// vykonani SQL prikazu
		$result = db_query($link, $sql);
	}

	?>
	Done.
              </td>
            </tr>
<?php
  // uvolneni pameti
//  mysqli_free_result($result);
  // uzavreni spojeni
  mysqli_close($link);

	// pripojeni paticky
  include ("php/bottom.php");

?>
