<?php

function service_message($get, &$reply)
{
  // otevreni spojeni
  $socket = fsockopen(READ_SERVICE_IP, READ_SERVICE_PORT, $errno, $errstr, 5);

  if(!$socket)
  { // spojeni selhalo
    $reply = 'Error: Connection to reading service failed.';
    return 1;
  }
  
  stream_set_timeout($socket, 5);
  $reply = fread($socket, 200); 
  // pozdrav zahodime
  $reply = '';
            
  // odeslani dotazu
  fwrite($socket, $get);
            
  // prijem odpovedi
  stream_set_timeout($socket, 5);
  $reply = fread($socket, 600);
            
  $info = stream_get_meta_data($socket);
  fclose($socket);  

  if ($info['timed_out'])
  {
    $reply = 'Connection with the service timed out!';
    return 2;
  }
  
  return 0;
}


?>