<?php
/***************************************************************************/
/*                                                                         */
/*  HLAVNI STRANKA - SEZNAM SKUPIN  				                               */
/*                                                                         */
/***************************************************************************/

  include ("php/head.php");
  include ("php/menu.php");
  flush();  
  require_once ("php/misc.php");

	if(isset($_GET['dir']))
	{	// je nastaveno razeni
		$_SESSION['dir'] = urldecode($_GET['dir']);
  }
  else
  {
    $_SESSION['dir'] = 'up';
  }  

  require_once "php/mysql.php"; 

  include ("php/js_misc.php");

  js_begin("
              function updateTableHeader() {
                var window_pos = GetScrollY();
                var head_line = document.getElementById('head_line');
                var head_div = document.getElementById('table_header');
  
                if( window_pos > GetPos(head_line) )
                {
                  head_div.style.visibility = \"visible\";
                  head_div.style.width = \"0px\";
                  head_div.style.top = document.body.scrollTop;
                }
                else
                {
                  head_div.style.visibility = \"hidden\";  
                }
              }    
  ");


  // pripojeni k DB
  $link = db_connect();
            
  // ukazatel na aktualni stranku seznamu
  if (!isset($_GET['set']))
  { // otevrit prvni stranku seznamu
    $set = 1;
  }
  else
  {	// otevrit zadanou stranku seznamu
    $set = $_GET['set'];
  }        
        
  // pocet polozek na strance seznamu
            
  if( isset($_GET['on_page']) )
  {
    if( ($_GET['on_page'] == 25) | ($_GET['on_page'] == 100) | ($_GET['on_page'] == 1000) )
    {
      $_SESSION['count_on_page'] = $_GET['on_page']; 
    }
  }
  if( !isset($_SESSION['count_on_page']) )
  {
    $_SESSION['count_on_page'] = 25;
  }
        
  // zjisteni poctu vsech zarizeni
  if( is_superadmin() )
  {
    $sql = 'SELECT COUNT(*) FROM users';
  }
  else
  {
    $sql = 'SELECT COUNT(*) FROM users WHERE company_id = "'.get_company_id().'" AND rights != "0"';  
  }
  // vykonani SQL prikazu
  $result = db_query($link, $sql);
            
  list($temp_set) = mysqli_fetch_row($result);
  $count_all_users = $temp_set;
  $temp_set = ceil($temp_set / 25);
  if($set > $temp_set)
  { // neplatna hodnota $set
    $set = $temp_set;
  }

  if($set<1)
  {	// neplatna hodnota set
    $set = 1;
  }
            
  if(isset($_GET['username_filter']))
  {	// je nastaven filtr username
    $_SESSION['username_filter'] = sanitize_text($_GET['username_filter']);
  }

  if(isset($_GET['name_filter']))
  {	// je nastaven filtr name
    $_SESSION['name_filter'] = sanitize_text($_GET['name_filter']);
  }

  if(isset($_GET['surname_filter']))
  {	// je nastaven filtr surname
    $_SESSION['surname_filter'] = sanitize_text($_GET['surname_filter']);
  }
  if(isset($_GET['company_filter']))
  {	// je nastaven filtr surname
    $_SESSION['company_filter'] = sanitize_number($_GET['company_filter']);
  }


  if(isset($_GET['ord']))
  {	// je nastaven filtr firmware
    $_SESSION['ord'] = sanitize_identifier($_GET['ord']);
  }
  else
  {
    unset($_SESSION['ord']);
//    unset($_SESSION['dir']);
  }

?>
            <tr>
              <th colspan="3">Users List</th>
            </tr>
            <tr>
              <td align="center" colspan="3">
                <table cellspacing="0" cellpadding="1" border="1" style="border-collapse:collapse;" id="dev_list_table">
                  <tr id="head_line">
<?php
  $cell = array();

  $cell[] = "<td nowrap width=\"50px\" height=\"25px\" align=\"center\" class=\"header\"><a href=\"index.php?page=user_list&ord=user_num&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">:.</a></td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"170px\"><a href=\"index.php?page=user_list&ord=username&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">Username</a></td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"170px\">Role</td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"170px\"><a href=\"index.php?page=user_list&ord=name&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">Name</a></td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"170px\"><a href=\"index.php?page=user_list&ord=surname&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">Surname</a></td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"170px\"><a href=\"index.php?page=user_list&ord=email&dir=".($_SESSION['dir'] == 'up' ? 'down' : 'up')."\">Email</a></td>\n";
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"170px\">Phone</td>\n";
  if( is_superadmin() )
  {
    $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"170px\">Company</td>\n";
  }
  $cell[] = "<td nowrap align=\"center\" class=\"header\" width=\"70px\" colspan=\"2\">Operation</td>\n";

  foreach($cell as $i => $val)
  {
    echo "                    ".$val;
  }

?>
                  </tr>
                  <tr class="tab_line1" align="center">
                  <form id="filtr" action="index.php" method="get">
                    <input id="filtr" type="hidden" name="page" value="user_list">
<?php

  $filter = array();

  $filter[] = "<td><input id=\"filtr\" class=\"filter_button\" type=\"submit\" value=\"Filter\"></td>\n";
  $filter[] = "<td><input id=\"filtr\" type=\"text\" name=\"username_filter\" value=\"".(isset($_SESSION['username_filter']) ? $_SESSION['username_filter'] : '')."\" size=\"20\"></td>\n";
  $filter[] = "<td></td>\n";  
  $filter[] = "<td><input id=\"filtr\" type=\"text\" name=\"name_filter\" value=\"".(isset($_SESSION['name_filter']) ? $_SESSION['name_filter'] : '')."\" size=\"20\"></td>\n";
  $filter[] = "<td><input id=\"filtr\" type=\"text\" name=\"surname_filter\" value=\"".(isset($_SESSION['surname_filter']) ? $_SESSION['surname_filter'] : '')."\" size=\"20\"></td>\n";
  $filter[] = "<td></td>\n";
  $filter[] = "<td></td>\n";
  if( is_superadmin() )
  {
    $sql = 'SELECT DISTINCT company_id, name
            FROM companies ORDER BY name';

    // vykonani SQL prikazu 
    $result = db_query($link, $sql);

    $temp = "<td><select id=\"filtr\" name=\"company_filter\">";    
    $temp = $temp."<option value=\"\">";

    while(list( $company_id, $company_name ) = mysqli_fetch_row( $result ))
    {
      $temp = $temp."<option value=\"".$company_id."\"".($_SESSION['company_filter'] == $company_id ? ' selected' : '').">".$company_name;     
    }

    $temp = $temp."</select></td>";

    $filter[] = $temp;
  }
  $filter[] = "<td colspan=\"2\"></td>\n";

  foreach($filter as $i => $val)
  {
    echo "                    ".$val;
  }
?>
                  </form id="filtr">
                  </tr>
<?php

  $sql = '';
					
  if((isset($_SESSION['username_filter'])) && ($_SESSION['username_filter'] != ''))
  {
    $sql = $sql.'AND username LIKE "%'.mysqli_real_escape_string($link,$_SESSION['username_filter']).'%" ';                 
  }

  if((isset($_SESSION['name_filter'])) && ($_SESSION['name_filter'] != ''))
  {
    $sql = $sql.'AND name LIKE "%'.mysqli_real_escape_string($link,$_SESSION['name_filter']).'%" ';                 
  }

  if((isset($_SESSION['surname_filter'])) && ($_SESSION['surname_filter'] != ''))
  {
    $sql = $sql.'AND surname LIKE "%'.mysqli_real_escape_string($link,$_SESSION['surname_filter']).'%" ';                 
  }

  if((isset($_SESSION['company_filter'])) && ($_SESSION['company_filter'] != ''))
  {
    $sql = $sql.'AND company_id = "'.mysqli_real_escape_string($link,$_SESSION['company_filter']).'" ';                 
  }

  if((isset($_SESSION['ord'])) && ($_SESSION['ord'] != ''))
  {
    $sql = $sql.'ORDER BY '.mysqli_real_escape_string($link,$_SESSION['ord']).' ';          
  }

  if((isset($_SESSION['dir'])) && ($_SESSION['dir'] != ''))
  {
    if($_SESSION['dir'] == 'down')
    {
      $sql = $sql.'DESC ';
    }
  }
						
  $sql = $sql.'LIMIT '. (($set - 1) * $_SESSION['count_on_page']).','.$_SESSION['count_on_page'];    

  if( is_superadmin() )
  { // jsme superadmin  
    $sql = 'call sp_GetUsersAll(\''.$sql.'\')';
  }
  else
  {
    $sql = 'call sp_GetUsers(\''.$sql.'\',\''.get_company_id().'\')';  
  }

  // vykonani SQL prikazu
	$result = db_query($link, $sql);

  $i = 0;
  // nacteni dat z odpovedi
  while (list($user_num, $comp_name, $user_id, $username, $name, $surname, $email, $phone, $rights, $edit_device) = mysqli_fetch_row($result))
  {
    // kontrola hodnot
    $name     = is_null($name) ? "---" : $name;
    $surname  = is_null($surname) ? "---" : $surname;
    $email    = is_null($email) ? "---" : $email;
    $phone    = is_null($phone) ? "---" : $phone;
    $comp_name = is_null($comp_name) ? "---" : $comp_name;
    $edit_device = is_null($edit_device) ? 0 : $edit_device;

    switch( $rights )
    {
      case "0":
        $role = "SuperAdmin";
        break;
      case "1":
        $role = "Admin";
        break;
      default:    
        $role = "Guest";
        if( $edit_device == "1" )
        {
          $role = $role." with device editing";
        }
    }

    // vytvoreni jednoho radku tabulky
    echo "                  <tr align=\"center\" class=\"tab_line".($i % 2)."\" height=\"27px\">\n";
    echo "                    <td>".$user_num."</td>\n";
    echo "                    <td>".$username."</td>\n";
    echo "                    <td>".$role."</td>\n";
    echo "                    <td>".$name."</td>\n";
    echo "                    <td>".$surname."</td>\n";
    echo "                    <td>";
//    if(filter_var($email, FILTER_VALIDATE_EMAIL))
    if( validate_email($email) )
    {
      echo "<a href=\"mailto:".$email."\">".$email."</a>";
    }
    else
    {
      echo $email;
    }
    echo "                    </td>\n";
    echo "                    <td>".$phone."</td>\n";
    if( is_superadmin() )
    {
      echo "                    <td>".$comp_name."</td>\n";    
    }
    echo "                    <td><img src=\"img/pencil.png\" border=\"0\" valign=\"center\" onclick=\"window.open('index.php?page=edit_user_form&user_id=".$user_id."','_self');\" title=\"Edit User\"></td>\n";     
    echo "                    <td><img src=\"img/cross.png\" border=\"0\" valign=\"center\" onclick=\"do_link('index.php?page=user_change&oper=remove&user_id=".$user_id."','Are you sure?');\" title=\"Remove User\"></td>\n";     
    echo "                  </tr>\n";
    $i++;
  }
 
	if(mysqli_more_results($link))
	{	//Catch 'OK'/'ERR'
		while(mysqli_next_result($link));
	}     

  // ziskani poctu vsech zarizeni vyhovujicich filtru
  $sql = 'SELECT COUNT(*) FROM groups WHERE ""="" ';

  // zjisteni poctu vsech zarizeni
  if( is_superadmin() )
  {
    $sql = 'SELECT COUNT(*) FROM users WHERE ""="" ';
  }
  else
  {
    $sql = 'SELECT COUNT(*) FROM users WHERE company_id = "'.get_company_id().'" AND rights != "0" ';  
  }

  if((isset($_SESSION['username_filter'])) && ($_SESSION['username_filter'] != ""))
  {	// zahrneme filtr description
    $sql = $sql.'AND username LIKE "%'.mysqli_real_escape_string($link,$_SESSION['username_filter']).'%" ';           
  }

  if((isset($_SESSION['name_filter'])) && ($_SESSION['name_filter'] != ""))
  {	// zahrneme filtr description
    $sql = $sql.'AND name LIKE "%'.mysqli_real_escape_string($link,$_SESSION['name_filter']).'%" ';                 
  }

  if((isset($_SESSION['surname_filter'])) && ($_SESSION['surname_filter'] != ""))
  {	// zahrneme filtr description
    $sql = $sql.'AND surname LIKE "%'.mysqli_real_escape_string($link,$_SESSION['surname_filter']).'%" ';            
  }

  if((isset($_SESSION['company_filter'])) && ($_SESSION['company_filter'] != ''))
  {
    $sql = $sql.'AND company_id = "'.mysqli_real_escape_string($link,$_SESSION['company_filter']).'" ';                 
  }

  // vykonani SQL prikazu
  $result = db_query($link, $sql);
           
  // nacteni dat z odpovedi
  list($count_filtered) = mysqli_fetch_row($result); 
                
  // uvolneni pameti
  mysqli_free_result($result);
  // uzavreni spojeni s DB
  mysqli_close($link);  
        
?>
                </table>
              </td>
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td align="left">
                      <table>
                        <tr>
                          <td>
                          </td>
                        </tr>
<?php

  if( $cfg['user_link_target'] != '')
  {
    echo "                        <tr>\n";
    echo "                          <td><a href=\"http://".$cfg['user_link_target']."\">".($cfg['user_link_text'] == '' ? $cfg['user_link_target'] : $cfg['user_link_text'])."</a></td>\n";
    echo "                        </tr>\n";
  } 

?>
                      </table>
                    </td>
                    <td align="center">
                      <table>
                        <tr>
                          <td align="center" colspan="4">
                          </td>
                        </tr>
                        <tr height="20px">
                        </tr>
                      </table>
                    </td>
                    <td align="right">
<?php
      
// generovani tlacitek strankovani
						
  // funkce pro vytvoreni odkazu
  function getPageLink($i, $page)
  {
    if($i == $page)
    {	// aktualni stranka nebude odkazem
      return "                        <td class=\"aktivni\">". $i ."</td>\n";
    }
    // odkaz na stranku
    return "                        <td><a href=\"".($i != 1 ? '?set='.$i : '.')."\">".$i."</a></td>\n";
  }
          
  // celkovy pocet stranek
  $maxset = ceil($count_filtered/$_SESSION['count_on_page']);           
                      
  // pocet okolnich stranek				
  $neighbours = 9;
           
  echo "                      <table class=\"navlist\">\n";
  echo "                        <tr>\n";
								
  // odkaz na prvni stranku bude vzdy	
  echo(getPageLink(1, $set));
							
  if($set > $neighbours)
  {	// stranka po prvni strance je dale nez $neighbours
    echo "                        <td>...</td>\n";
  }
							
  // pocet stranek mezi
  $to = min($maxset, $set + $neighbours);
  for($i = max(2, $set - $neighbours + 1); $i < $to; $i++)
  {	// generovani prostrednich stranek
    echo(getPageLink($i, $set));
  }
           
  if($set + $neighbours < $maxset)
  {	// stranka pred posledni strankou je dale nez $neighbours
    echo "                        <td>...</td>\n";
  }
           
  if($maxset > 1)
  {	// odkaz na posledni stranku bude vzdy
    echo(getPageLink($maxset, $set));           
  }
  echo "                        </tr>\n";
  echo "                      </table>\n";
?>
                      <a href=index.php?page=user_list&on_page=25>25</a> | <a href=index.php?page=user_list&on_page=100>100</a> records per page
                      <form style="margin-bottom: 0px" action="index.php" method="get">
                        <label for="gotopage">Go to page</label>                
                        <input type="text" name="set" id="gotopage" size="3">
                      </form>
                    </td>
                  </tr>
                </table>
                <style>
                  #table_header{
                    position: absolute;
                    visibility: hidden;
                  }
                </style>
                <div id="table_header">
                  <table cellspacing="0" cellpadding="1" border="1" style="border-collapse:collapse;" width="100%">
                    <tr>
<?php
  foreach($cell as $i => $val)
  {
    echo "                    ".$val;
  }
?>
                    </tr>
                    <tr class="tab_line1" align="center">
                    <form id="filtr" action="index.php" method="get">
                      <input id="filtr" type="hidden" name="page" value="user_list">
<?php
  foreach($filter as $i => $val)
  {
    echo "                    ".$val;
  }
?>
                    </form id="filtr">
                  </tr>
                  </table>
                </div>
              </td>
            </tr>
<?php

  js_end("
            window.onscroll = function () {
              updateTableHeader();
            }    
    ");

	// pripojeni paticky
  include ("php/bottom.php");

?>
