<?php
/***************************************************************************/
/*                                                                         */
/*  SCRIPT PRIDANI/ODEBRANI UZIVATELE, ZMENA HESLA                         */
/*                                                                         */
/***************************************************************************/

  if(isset($_POST['action']))
  {	// je zadana operace pres POST
    $action = $_POST['action'];
  }
  elseif(isset($_GET['action']))
  {	// operace pres GET
    $action = $_GET['action'];
  }

  if (isset($_SESSION['last']))
  {	// nacteni predchozi stranky
    header('Refresh: 1; URL = '.urldecode($_SESSION['last']));
  }
  else
  {	// nacteni uvodni stranky
    header('Refresh: 1; URL = index.php');  
  }

  include ("php/head.php");
  include ("php/menu.php");
  require_once "php/mysql.php";

?>
            <tr>    
              <th colspan="3">User Change</th>  
            </tr>
            <tr>
              <td colspan="3">
<?php

  // kontrola prihlaseni
  if(!isset($_SESSION['logged']) || $_SESSION['logged'] != 100)
  {	// uzivatel neni prihlasen, nemuze nic menit
    echo('Error: You must be logged as user admin !!!');
    exit;  
  }

	// pripojeni k DB
	$link = db_connect();
 
  if(strstr($action, "Add"))
  { // pridani uzivatele

    if( isset($_POST['add_username']) && ($_POST['add_username'] != '') )
    {
      $add_username = $_POST['add_username'];
    }
    else
    { // chybi username
      echo('You must specify username !!!');
      exit;    
    }
  
    if( isset($_POST['add_password']) && ($_POST['add_password'] != '') )
    {
      $add_password = $_POST['add_password'];
    }
    else
    { // chybi username
      echo('You must specify password !!!');
      exit;    
    }

    $sql = 'SELECT username FROM users WHERE username = "'.$add_username.'"';

    // vykonani SQL prikazu
		$result = db_query($link, $sql);

    if(mysqli_num_rows($result) > 0)
    {
      echo('Error: Username is exists !!!');
      exit;      
    }

    if(isset($_POST['admin_rights']))    
    {
      $sql = 'INSERT INTO users (username, password, rights) VALUES ("'.mysqli_real_escape_string($link, $add_username).'", PASSWORD("'.mysqli_real_escape_string($link, $add_password).'"),"1")';
    }
    else
    {
      $sql = 'INSERT INTO users (username, password, rights) VALUES ("'.mysqli_real_escape_string($link, $add_username).'", PASSWORD("'.mysqli_real_escape_string($link, $add_password).'"),"2")';    
    }
    // vykonani SQL prikazu
		$result = db_query($link, $sql);


    echo "User succesfully added";
  }
  else if(strstr($action, "Delete"))
  { // odebrani uzivatele

    if( isset($_GET['username']) && ($_GET['username'] != '') )
    {
      $username = $_GET['username'];
    }
    else
    { // chybi username
      echo('You must specify username !!!');
      exit;    
    }

    $sql = 'SELECT username FROM users WHERE username = "'.$username.'"';

    // vykonani SQL prikazu
		$result = db_query($link, $sql);

    if(mysqli_num_rows($result) != 1)
    {
      echo('Error: Username is not exists !!!');
      exit;      
    }    

    $sql = 'DELETE FROM users WHERE username = "'.mysqli_real_escape_string($link, $username).'"';
    // vykonani SQL prikazu
		$result = db_query($link, $sql);

    echo "User succesfully removed";
  
  }
  else if(strstr($action, "Change"))
  { // zmena hesla  

    if( isset($_POST['username']) && ($_POST['username'] != '') )
    {
      $username = $_POST['username'];
    }
    else
    { // chybi username
      echo('You must specify username !!!');
      exit;    
    }
  
    if( isset($_POST['new_password']) && ($_POST['new_password'] != '') )
    {
      $new_password = $_POST['new_password'];
    }
    else
    { // chybi username
      echo('You must specify new password !!!');
      exit;    
    }    

    if( $_POST['rights'] == 1 )
    { // zkontrolovat stare heslo

      if( isset($_POST['old_password']) && ($_POST['old_password'] != '') )
      {
        $old_password = $_POST['old_password'];
      }
      else
      { // chybi username
        echo('You must specify old password !!!');
        exit;    
      }

      $sql = 'SELECT * 
              FROM users 
              WHERE username = "'.mysqli_real_escape_string($link, $username).'"
              AND password = PASSWORD("'.mysqli_real_escape_string($link, $old_password).'")';

      // vykonani SQL prikazu
		  $result = db_query($link, $sql);

      if(mysqli_num_rows($result) == 0)
      {
        echo('Error: Bad old password !!!');
        exit;      
      }
    
    }

    $sql = 'UPDATE users SET password = PASSWORD("'.mysqli_real_escape_string($link, $new_password).'")
            WHERE username = "'.mysqli_real_escape_string($link, $username).'"';
    // vykonani SQL prikazu
    $result = db_query($link, $sql);

    echo "Password succesfully changed";  
  }

?>
              </td>  
            </tr>
<?php
	// pripojeni paticky
  include ("php/bottom.php");

?>

