<?php
/***************************************************************************/
/*                                                                         */
/*  FORMULAR PRO PRIDAVANI FIREM  					                               */
/*                                                                         */
/***************************************************************************/

	// pripojeni hlavicky
  include ("php/head.php");
	
	// pripojeni menu
  include ("php/menu.php");
	require_once "config.inc.php";	

  include ("php/js_misc.php");

  js_begin( " 
              function CheckForm()
              {
                if( IsEmpty(document.f.add_name) ){
                  return Error( 'Missing company name.', document.f.add_name );
                }
                if( !IsInRange(document.f.add_devcount, 1, 65535, 0) ){
                  return Error( 'Missing or invalid number of devices.', document.f.add_devcount );
                }
                return true;
              }
    " );

  $link = db_connect();

  $sql = 'SELECT SUM(devcount)
          FROM companies';

  $result = db_query($link, $sql);

  list($all_devcount) = mysqli_fetch_row( $result );

?>
            <tr>    
              <th  colspan="3">Add Company</td>  
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td>
                      <form name="f" action="index.php" method="get">
                      <input type="hidden" name="page" value="company_change">
                      <input type="hidden" name="oper" value="add">
                      <table>
                        <tr>
                          <td width="150px">Name</td><td><input type="text" name="add_name" value=""></td>
                        </tr>
                        <tr>
                          <td>Address *</td><td><input type="text" name="add_address" value=""></td>
                        </tr>
                        <tr>
                          <td>Email *</td><td><input type="text" name="add_email" value=""></td>
                        </tr>
                        <tr> 
                          <td>Phone *</td><td><input type="text" name="add_phone" value=""></td>
                        </tr>
                        <tr>
                          <td>Note *</td><td><input type="text" name="add_note" value=""></td>
                        </tr>
                        <tr>
                          <td>DevCount</td><td><input type="text" name="add_devcount" value=""></td><td><?php echo( $_SESSION['Web.max_station'] == 65535 ? "" : ($_SESSION['Web.max_station'] - $all_devcount)." devices left")?></td>
                        </tr>
                        <tr>
                          <td>* <i>can be blank</i></td><td></td> 
                        </tr>
                        <tr>
                          <td><input type="submit" value="Add Company"></td><td></td>
                        </tr>
                      </table>
                      </form>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
<?php
  js_end( "
              document.f.onsubmit = CheckForm;
              document.f.add_name.focus();
    " );

	// pripojeni paticky
  include ("php/bottom.php");

?>
