<?php
/***************************************************************************/
/*                                                                         */
/*  FUNKCE PRO UPRAVU FIRMY   							                               */
/*                                                                         */
/***************************************************************************/
	
  $oper = URI_get_string("oper");
  if( is_null( $oper ) )
  {
    echo('Missing operation !!!');
    exit;  
  }

  header('Refresh: 2; URL = index.php?page=company_list');

  include ("php/head.php");
  include ("php/menu.php");
  require_once "config.inc.php";
  require_once "mysql.php";


?>
            <tr>
              <th colspan="3">Company Change</th>  
            </tr>
            <tr>
	            <td colspan="3">
<?php

	// pripojeni k databazi
	$link = db_connect();

  // rozliseni typu operace
  switch($oper)
  {
    case "add":     // Pridat firmu
      {

        $add_name = URI_get_string("add_name");
        if( is_null( $add_name ) )
        {	// chybi name
          echo('You must specify company name !!!');
          exit;
        }

        $add_address = URI_get_string("add_address");
        $add_email = URI_get_string("add_email");
        $add_phone = URI_get_string("add_phone");
        $add_note = URI_get_string("add_note");

        $add_devcount = URI_get_int("add_devcount");
        if( is_null($add_devcount) || ($add_devcount <= 0) ) 
        {	// chybi pocet zarizeni
          echo('Missing or incorrect number of devices !!!');
          exit;
        }

        $sql = 'SELECT SUM(devcount)
                FROM companies';

        $result = db_query($link, $sql);

        list($all_devcount) = mysqli_fetch_row( $result );
        if( ($add_devcount + $all_devcount) > $_SESSION['Web.max_station'] )
        { // zakaznik se snazi pridat firme vice routru nez umoznuje jeho licence - to mu zatrhneme
          echo('To many devices, you licence enable to use only '.($_SESSION['Web.max_station'] - $all_devcount).' devices !!!');
          exit;
        }


        $sql = 'INSERT INTO companies ( name, devcount, address, email, phone, note  ) 
          VALUES ("'.$add_name.'",
            "'.$add_devcount.'",
            '.Str4Sql($add_address).',
            '.Str4Sql($add_email).',
            '.Str4Sql($add_phone).',
            '.Str4Sql($add_note).')';

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        $sql = 'SELECT LAST_INSERT_ID()';
        $result = db_query($link, $sql);
        list($last_id) = mysqli_fetch_row($result);

        echo('Company was added succesfully.');
        log_event($last_id,'Company '.$add_name.' was created.');
        break;
      }

      case "edit":  // upravit firmu
      {
        $company_id = URI_get_int("company_id");
        if( is_null($company_id) )
        { // spatne company_id
          echo('Missing or incorrect company id !!!');
          exit;          
        }

        $add_name = URI_get_string("add_name");
        if( is_null( $add_name ) )
        {	// chybi name
          echo('You must specify company name !!!');
          exit;
        }

        $add_address = URI_get_string("add_address");
        $add_email = URI_get_string("add_email");
        $add_phone = URI_get_string("add_phone");
        $add_note = URI_get_string("add_note");

        $add_devcount = URI_get_int("add_devcount");
        if( is_null($add_devcount) || ($add_devcount <= 0) ) 
        {	// chybi pocet zarizeni
          echo('Missing or incorrect number of devices !!!');
          exit;
        }

        $sql = 'SELECT SUM(devcount)
          FROM companies
          WHERE company_id != "'.$company_id.'"';

        $result = db_query($link, $sql);

        list($all_devcount) = mysqli_fetch_row( $result );
        if( ($add_devcount + $all_devcount) > $_SESSION['Web.max_station'] )
        { // zakaznik se snazi pridat firme vice routru nez umoznuje jeho licence - to mu zatrhneme
          echo('To many devices, you licence enable to use only '.($_SESSION['Web.max_station'] - $all_devcount).' devices !!!');
          exit;
        }

        $sql = 'UPDATE companies
                SET
                name = "'.$add_name.'",
                devcount =  "'.$add_devcount.'",
                address = '.Str4Sql($add_address).',
                email = '.Str4Sql($add_email).',
                phone = '.Str4Sql($add_phone).',
                note = '.Str4Sql($add_note).'
                WHERE company_id = "'.$company_id.'"';
                
				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        echo('Company was changed succesfully.');
        log_event($company_id,'Company '.$add_name.' was changed.');        
        break;  
      }

      case "remove":  // odstranit firmu
      {

        $company_id = URI_get_int("company_id");
        if( is_null($company_id) )
        { // spatne company_id
          echo('Missing or incorrect company id !!!');
          exit;          
        }

        // zkontrolujeme jestli firma neobsahuje jeste nejake routry

        $sql = 'SELECT device_id
                FROM devices
                WHERE group_id IN
                (SELECT group_id
                 FROM groups
                 WHERE company_id = "'.$company_id.'")';

				// vykonani SQL prikazu
        $result = db_query($link, $sql);

        if( mysqli_num_rows( $result ) )
        {
          echo( 'This company contains some devices. Remove these devices first!!!' );
          exit;
        }

        $sql = 'SELECT name 
                FROM companies
                WHERE company_id = "'.$company_id.'"';
                
				// vykonani SQL prikazu
				$result = db_query($link, $sql);
        list($comp_name) = mysqli_fetch_row($result);

        $sql = 'DELETE FROM companies
                WHERE company_id = "'.$company_id.'"';
                
				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        echo('Company was removed succesfully.');
        log_event($company_id,'Company '.$comp_name.' was removed.');
        break;  
      }

    default:{   // neznama akce
      echo('Company Change Error: Unknow operation');
      break;
    }      
        
  }

?>
	            </td>
            </tr>
<?php
	// pripojeni paticky
  include ("php/bottom.php");

?>
