<?php
/***************************************************************************/
/*                                                                         */
/*  FUNKCE PRO UPRAVU ZARIZENI							                               */
/*                                                                         */
/***************************************************************************/


  $oper = URI_get_string("oper");
  if( is_null( $oper ) )
  {
    echo('Missing operation !!!');
    exit;
  }

  header('Refresh: 2; URL = index.php?page=device_list');

  include ("php/head.php");
  include ("php/menu.php");
  require_once "config.inc.php";
  require_once "mysql.php";


?>
            <tr>
              <th colspan="3">Device Change</th>
            </tr>
            <tr>
	            <td colspan="3">
<?php

	function add_device($db_link, $hostname, $hostname_alt, $hostname_alt2, $description, $community, $location, $note, $phone, $phone_alt, $group_id, $accounting_start, $accounting_start_alt, $accounting_start_alt2, $period, $mac, $access_mode, $snmp_enabled, $snmp_username, $snmp_auth, $snmp_auth_password, $snmp_privacy, $snmp_privacy_password)
  {
    // normalizace mac
    if( !is_null( $mac ) )
    {
      $mac = normalize_mac( $mac );
    }

    // kontrola poctu stanic

    $sql = 'SELECT groups.company_id, companies.devcount
            FROM groups
            LEFT JOIN companies ON groups.company_id = companies.company_id
            WHERE group_id = "'.$group_id.'"';

    // vykonani SQL prikazu
		$result = db_query($db_link, $sql);
    list($temp_company_id, $maxcount) = mysqli_fetch_row( $result );

    $sql = 'SELECT COUNT(*)
            FROM devices
            WHERE group_id IN
            (SELECT group_id
             FROM groups
             WHERE company_id = "'.$temp_company_id.'")';

		// vykonani SQL prikazu
		$result = db_query($db_link, $sql);

    list($devcount) = mysqli_fetch_row($result);

    if($devcount >= $maxcount)
    {
      echo('Error: Maximum number of devices is '.$maxcount);
      exit;
    }

		// kontrola existence hostname a mac
    $sql  = 'SELECT device_id
             FROM devices
             WHERE hostname = "'.$hostname.'"
             OR mac = "'.$mac.'"';

		// vykonani SQL prikazu
		$result = db_query($db_link, $sql);

    if(mysqli_num_rows($result) > 0)
    {	// hostname uz existuje, provede se aktualizace, ale jen kdyz se neshoduje hostname
    
      list($device_id) = mysqli_fetch_row( $result );
      
      		// kontrola existence hostname
         $sql  = 'SELECT device_id
                  FROM devices
                  WHERE hostname = "'.$hostname.'"';
              // vykonani SQL prikazu
		  $result = db_query($db_link, $sql);
		   if(mysqli_num_rows($result) > 0)
		   {
		    echo('Error: hostname '.$hostname. ' exists !!!');
		    // 
            //<script>
            //alert("Error: hostname ".$hostname. " exists !!!");
            //</script>
            //
            exit;
		   }
		   else
		   {

      
      
      $sql = 'UPDATE devices
        SET
        hostname = '.Str4Sql($hostname).',
        hostname_alt = '.Str4Sql($hostname_alt).',
        hostname_alt2 = '.Str4Sql($hostname_alt2).',
        description = '.Str4Sql($description).',
        community = '.Str4Sql($community).',
        location = '.Str4Sql($location).',
        note = '.Str4Sql($note).',
        phone = '.Str4Sql($phone).',
        phone_alt = '.Str4Sql($phone_alt).',
		snmp_prot = '.$snmp_enabled.',
		v3_username = '.Str4Sql($snmp_username).',
		v3_authentication = '.$snmp_auth.',
		v3_authpsw = '.Str4Sql($snmp_auth_password).',
		v3_privacy = '.$snmp_privacy.',
		v3_privpsw = '.Str4Sql($snmp_privacy_password).'
        WHERE device_id = "'.$device_id.'"';

      $temp = 1;
      }
    }
    else
    {
      // vlozeni zarizeni do tabulky
      $sql =  'INSERT INTO devices
              (enabled, hostname, hostname_alt, hostname_alt2, description, community, location, note, phone, phone_alt, group_id, accounting_start,
			  accounting_start_alt, accounting_start_alt2, period, mac, trap, snmp_prot, v3_username, v3_authentication, v3_authpsw, v3_privacy, v3_privpsw)
              VALUES
              ("1",
              '.Str4Sql($hostname).',
              '.Str4Sql($hostname_alt).',
              '.Str4Sql($hostname_alt2).',
              '.Str4Sql($description).',
              '.Str4Sql($community).',
              '.Str4Sql($location).',
              '.Str4Sql($note).',
              '.Str4Sql($phone).',
              '.Str4Sql($phone_alt).',
              '.$group_id.',
              '.$accounting_start.',
              '.$accounting_start_alt.',
              '.$accounting_start_alt2.',
              '.$period.',
              '.Str4Sql($mac).',
              '.$access_mode.',
			  '.$snmp_enabled.',
			  '.Str4Sql($snmp_username).',
			  '.$snmp_auth.',
			  '.Str4Sql($snmp_auth_password).',
			  '.$snmp_privacy.',
			  '.Str4Sql($snmp_privacy_password) . ')';

      $temp = 0;
    }

		// vykonani SQL prikazu
		$result = db_query($db_link, $sql);

    return $temp;
	}

  // kontrola prihlaseni
  if(!can_user_edit_device( ))
  {	// uzivatel neni prihlasen, nemuze nic menit
    echo('Error: You are not allowed edit device parameters !!!');
    exit;
  }

	// pripojeni k databazi
	$link = db_connect();

  // rozliseni typu operace
  switch($oper)
  {
    case "add":     // 0 - Pridat zarizeni
      {

        $access_mode = URI_get_int("access_mode");
        if( is_null($access_mode) )
        {	// chybi community
          echo('Access Mode !!!');
          exit;
        }

        $add_hostname = URI_get_string("add_hostname");

        if( $access_mode == 0 && is_null( $add_hostname ) )
        {
          echo('In Polling mode you must specify hostname !!!');
          exit;
        }

        $add_accounting_start = URI_get_int("add_accounting_start");
        if( is_null( $add_accounting_start ) )
        {	// chybi accounting start
          $add_accounting_start = 1;
        }


        $add_hostname_alt = URI_get_string("add_hostname_alt");
        $add_accounting_start_alt = URI_get_int("add_accounting_start_alt");
        if( is_null( $add_accounting_start_alt ) )
        {	// chybi accounting start alt
          $add_accounting_start_alt = 1;
        }

        $add_hostname_alt2 = URI_get_string("add_hostname_alt2");
        $add_accounting_start_alt2 = URI_get_int("add_accounting_start_alt2");
        if( is_null( $add_accounting_start_alt2 ) )
        {	// chybi accounting start alt
          $add_accounting_start_alt2 = 1;
        }

        $add_description = URI_get_string("add_description");
        $add_community = URI_get_string("add_community");
        if( is_null( $add_community ) )
        {	// chybi community
          echo('Missing community !!!');
          exit;
        }

        $add_location = URI_get_string("add_location");
        $add_note = URI_get_string("add_note");
        $add_phone = URI_get_string("add_phone");
        $add_phone_alt = URI_get_string("add_phone_alt");

        $group_id = URI_get_int("group_id");
        if( is_null($group_id) )
        {
				  echo('Missing or invalid group ID !!!');
				  exit;
        }

        $period = URI_get_int("add_period");
        if( is_null($period) || ($period < 1) )
        {
				  echo('Missing or invalid period !!!');
				  exit;
        }

        $add_mac = URI_get_string("add_mac");

        if( $access_mode == 1 && is_null( $add_mac ) )
        {
          echo('In Trap mode you must specify MAC address !!!');
          exit;
        }

        if( !is_null( $add_mac ) )
        { // byla zadana MAC adresa
          if( !is_valid_mac( $add_mac ) )
          { // neplatna adresa
  				  echo('Invalid MAC format !!!');
  				  exit;
          }
        }

		$snmp_enabled = is_null(URI_get_int("snmp_enabled")) ? 0 : 1;
		$snmp_username = URI_get_string("snmp_username");
		$snmp_auth = URI_get_int("snmp_auth");
		$snmp_auth_password = URI_get_string("snmp_auth_password");
		$snmp_privacy = URI_get_int("snmp_privacy");
		$snmp_privacy_password = URI_get_string("snmp_privacy_password");


        // kontrola vlastnika groupy
        if( !is_superadmin() )
        { // neni prihlasen superadmin
          $sql = 'SELECT *
                  FROM groups
                  WHERE group_id = "'.$group_id.'" AND company_id = "'.get_company_id().'"';

    		  // vykonani SQL prikazu
          $result = db_query($link, $sql);
          if( !mysqli_num_rows( $result ))
          {
            echo "You are not allowed add device to this group !!!";
            exit;
          }
        }


				if(add_device($link, $add_hostname, $add_hostname_alt, $add_hostname_alt2, $add_description, $add_community, $add_location, $add_note,
						$add_phone, $add_phone_alt, $group_id, $add_accounting_start, $add_accounting_start_alt, $add_accounting_start_alt2,
						$period, $add_mac, $access_mode, $snmp_enabled, $snmp_username, $snmp_auth, $snmp_auth_password, $snmp_privacy, $snmp_privacy_password))
				{
					echo('Hostname is exists !!!');
					exit;
				}

        $device_name = $add_hostname;

        echo('Device was added succesfully.');
        log_event(get_company_id(),'Device '.$device_name.' was added.');
        break;
      }
    case "remove":     // 1 - Odebrat zarizeni
    {
        $remove_devID = URI_get_string("remove_devID");
        if( is_null($remove_devID) )
        {	// chybi device ID
          echo('You must specify device ID !!!');
          exit;
        }

				// kontrola existence device ID
        $sql    = 'SELECT device_id FROM devices WHERE device_id = "'.$remove_devID.'"';

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        if(mysqli_num_rows($result) == 0)
        {	// device ID neexistuje
          echo('Device ID is not exists !!!');
          exit;
        }

        if( !is_superadmin() )
        { // neni prihlasen superadmin
          // kontrola vlastnika
          $sql = 'SELECT groups.description
                  FROM devices
                  LEFT JOIN groups ON devices.group_id = groups.group_id
                  WHERE devices.device_id = "'.$remove_devID.'" AND groups.company_id = "'.get_company_id().'"';

          // vykonani SQL prikazu
          $result = db_query($link, $sql);

          if( !mysqli_num_rows( $result ) )
          {
            echo "You are not allowed remove this device !!!";
            exit;
          }
        }
        $sql = 'SELECT mac from devices
                WHERE device_id = "'.$remove_devID.'"';
        $result = db_query($link, $sql);
        list($device_name) = mysqli_fetch_row( $result );

				// odstraneni device ID z tabulky devices
        $sql = 'DELETE FROM devices WHERE device_id = "'.$remove_devID.'"';

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        // neco se resi pomoci triggeru

/*				// odstraneni device ID z tabulky day
        $sql = 'DELETE FROM day WHERE device_id = "'.$remove_devID.'"';

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

				// odstraneni device ID z tabulky fails
        $sql = 'DELETE FROM fails WHERE device_id = "'.$remove_devID.'"';

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

				// odstraneni device ID z tabulky stats
        $sql = 'DELETE FROM stats WHERE device_id = "'.$remove_devID.'"';

				// vykonani SQL prikazu
        $result = db_query($link, $sql);    */

        echo('Device was succesfully removed.');
        log_event(get_company_id(),'Device '.$device_name.' was removed.');
        break;
      }

		case "import":			// import zarizeni ze souboru
			{

				if(isset($_POST['submit']))
        {

          switch( URI_get_string("delim") )
          {
            case "comma": $delim = ","; break;
            case "semicolon": $delim = ";"; break;
            default: $delim = ","; break;
          }

					if($_FILES["file"]['error'] > 0)
					{	// chyba pri prenosu
						echo('Error: '.$_FILES["file"]['error']);
						exit;
					}

					if(!is_file($_FILES['import_file']['tmp_name']))
					{	// neni zadan soubor
						echo('File not specified.');
						exit;
					}

					if(!strstr($_FILES['import_file']['name'], '.csv'))
					{	// neni CSV soubor
						echo('Bad file type!!! CSV file is expected.');
						exit;
					}

					$local_file = $_FILES['import_file']['tmp_name'];

					$file = fopen($local_file,"r");

					if(!$file)
					{	// chyba pri otevirani souboru
						echo("Error openning file!!!");
						exit;
					}

          $access_mode = URI_get_int("access_mode");
          if( is_null($access_mode) )
          {	// chybi Access mode
            echo('Access Mode !!!');
            exit;
          }

          $add_accounting_start = URI_get_int("add_accounting_start");
          if( is_null( $add_accounting_start ) )
          {	// chybi accounting start
            $add_accounting_start = 1;
          }

          $add_accounting_start_alt = URI_get_int("add_accounting_start_alt");
          if( is_null( $add_accounting_start_alt ) )
          {	// chybi accounting start alt
            $add_accounting_start_alt = 1;
          }

          $add_accounting_start_alt2 = URI_get_int("add_accounting_start_alt2");
          if( is_null( $add_accounting_start_alt ) )
          {	// chybi accounting start alt
            $add_accounting_start_alt2 = 1;
          }

          $community = URI_get_string("add_community");
          if( is_null($community) )
          {
            echo('Missing community!');
            exit;
          }

          $group_id = URI_get_int("group_id");
          if( is_null($group_id) )
          {
            echo('Missing group ID!');
            exit;
          }

          $period = URI_get_int("add_period");
          if( is_null($period) || ($period < 1) )
          {
				    echo('Missing or invalid period !!!');
				    exit;
          }

          $line = fread($file,500);

          error_log("line: ".$line, 0);
          error_log("delim: ".$delim, 0);

          if(!strstr($line,$delim))
          { // kontrola pritomnosti spravneho oddelovace
            echo('Bad delimiter selected!');
            exit;
          }

          // skok na zacatek souboru
          fseek($file, SEEK_SET);

          $values = array(9);

          $hostname_col       = is_null(URI_get_int("hostname_col")) ? 9      : URI_get_int("hostname_col");
          $hostname_alt_col   = is_null(URI_get_int("hostname_alt_col")) ? 9  : URI_get_int("hostname_alt_col");
          $hostname_alt_col2  = is_null(URI_get_int("hostname_alt_col2")) ? 9 : URI_get_int("hostname_alt_col2");
          $mac_col            = is_null(URI_get_int("mac_col")) ? 9           : URI_get_int("mac_col");
          $description_col    = is_null(URI_get_int("description_col")) ? 9   : URI_get_int("description_col");
          $location_col       = is_null(URI_get_int("location_col")) ? 9      : URI_get_int("location_col");
          $note_col           = is_null(URI_get_int("note_col")) ? 9          : URI_get_int("note_col");
          $phone_col          = is_null(URI_get_int("phone_col")) ? 9         : URI_get_int("phone_col");
          $phone_alt_col      = is_null(URI_get_int("phone_alt_col")) ? 9     : URI_get_int("phone_alt_col");

		  $snmp_enabled = is_null(URI_get_int("snmp_enabled")) ? 0 : 1;
		  $snmp_username = URI_get_string("snmp_username");
		  $snmp_auth =     URI_get_int("snmp_auth");
		  $snmp_auth_password = URI_get_string("snmp_auth_password");
		  $snmp_privacy =   URI_get_int("snmp_privacy");
		  $snmp_privacy_password = URI_get_string("snmp_privacy_password");


          if( ($access_mode == 0) && ($hostname_col == 9) )
          {
            echo('In Polling mode you must specify hostname');
            exit;
          }

          if( ($access_mode == 1) && ($mac_col == 9) )
          {
            echo('In Trap mode you must specify MAC address');
            exit;
          }

//          echo $hostname_col.",".$hostname_alt_col.",".$description_col.",".$location_col.",".$note_col.",".$phone_col.",".$phone_alt_col."<br><br>";


					while($values = fgetcsv($file, 1000, $delim))
          {	// nacten a rozparsovan radek s parametry

            $hostname =     ($hostname_col < 9) ? $values[$hostname_col] : NULL;
            $hostname_alt = ($hostname_alt_col < 9) ? $values[$hostname_alt_col] : NULL;
            $hostname_alt2 = ($hostname_alt_col2 < 9) ? $values[$hostname_alt_col2] : NULL;
            $mac = ($mac_col < 9) ? $values[$mac_col] : NULL;
            $description =  ($description_col < 9) ? $values[$description_col] : NULL;
            $location =     ($location_col < 9) ? $values[$location_col] : NULL;
            $note =         ($note_col < 9) ? $values[$note_col] : NULL;
            $phone =        ($phone_col < 9) ? $values[$phone_col] : NULL;
            $phone_alt =    ($phone_alt_col < 9) ? $values[$phone_alt_col] : NULL;


//            echo $hostname.",".$hostname_alt.",".$description.",".$location.",".$note.",".$phone.",".$phone_alt."<br>";

            if(add_device($link, $hostname, $hostname_alt, $hostname_alt2, $description, $community, $location, $note, $phone, $phone_alt, $group_id, $add_accounting_start, $add_accounting_start_alt, $add_accounting_start_alt2, $period, $mac, $access_mode, $snmp_enabled, $snmp_username, $snmp_auth, $snmp_auth_password, $snmp_privacy, $snmp_privacy_password))
            {	// zarizeni uz existuje
  						$device_exists = $device_exists.($hostname_col == 9 ? $mac : $hostname).'<br>';
            }
					}

					if(isset($device_exists))
					{	// vypsat aktualizovana zarizeni
						echo('Devices were added, some devices have been updated: <br><br>');
						echo($device_exists);
					}
					else
					{
						echo('Devices were added. ');
					}
          log_event(get_company_id(),'Some devices were imported from file');

					fclose($file);

				}

				break;
			}

    case "refresh":     // smazat product -> zpusobi refresh productu v nejblizsim kolecku
      {

        // zmena hodnoty product
        $sql = 'UPDATE devices SET product = NULL
                WHERE device_id = '.URI_get_int("device_id");

				// vykonani SQL prikazu
				$result = db_query($link, $sql);
        echo('Device will be refresh as soon as possible.');

        break;
      }

    case "change":
    {
      $device_id = URI_get_int("device_id");
      if( is_null( $device_id ) )
      { // spatne device_id
        echo('Missing or incorrect device id !!!');
        exit;
      }

      $access_mode = URI_get_int("access_mode");
      $hostname = URI_get_string("hostname");
      if( ($access_mode == "0") && is_null( $hostname ) )
      { // v modu pollingu musi existovat hostname
        echo('Missing hostname !!!');
        exit;
      }

      $add_accounting_start = URI_get_int("add_accounting_start");
      if( is_null( $add_accounting_start ) )
      {	// chybi accounting start
        $add_accounting_start = 1;
      }

      $hostname_alt = URI_get_string("hostname_alt");
      $add_accounting_start_alt = URI_get_int("add_accounting_start_alt");
      if( is_null( $add_accounting_start_alt ) )
      {	// chybi accounting start alt
        $add_accounting_start_alt = 1;
      }

      $hostname_alt2 = URI_get_string("hostname_alt2");
      $add_accounting_start_alt2 = URI_get_int("add_accounting_start_alt2");
      if( is_null( $add_accounting_start_alt2 ) )
      {	// chybi accounting start alt
        $add_accounting_start_alt2 = 1;
      }

      $description = URI_get_string("description");
      $location = URI_get_string("location");
      $note = URI_get_string("note");
      $community = URI_get_string("community");
      $group_id = URI_get_int("group_id");
      $enabled = is_null(URI_get_int("enabled")) ? 0 : 1;
      $read_location = is_null(URI_get_int("read_location")) ? 0 : 1;
      $read_gps = is_null(URI_get_int("read_gps")) ? 0 : 1;
      $autoupdate = is_null(URI_get_int("autoupdate")) ? 0 : 1;
      $read_temp_volt = is_null(URI_get_int("read_temp_volt")) ? 0 : 1;
      $phone = URI_get_string("phone");
      $phone_alt = URI_get_string("phone_alt");
      $coordinates = URI_get_string("coordinates");

	  $snmp_enabled = is_null(URI_get_int("snmp_enabled")) ? 0 : 1;
	  $snmp_username = URI_get_string("snmp_username");
	  $snmp_auth = URI_get_int("snmp_auth");
	  $snmp_auth_password = URI_get_string("snmp_auth_password");
	  $snmp_privacy = URI_get_int("snmp_privacy");
	  $snmp_privacy_password = URI_get_string("snmp_privacy_password");

      $period = URI_get_int("add_period");
      if( is_null($period) || ( $period < 1 ) )
      {
        echo('Missing or invalid read period !!!');
        exit;
      }

      $sql = 'UPDATE devices
        SET
        hostname = '.Str4Sql($hostname).',
        hostname_alt = '.Str4Sql($hostname_alt).',
        hostname_alt2 = '.Str4Sql($hostname_alt2).',
        description = '.Str4Sql($description).',
        location = '.Str4Sql($location).',
        note = '.Str4Sql($note).',
        community = '.Str4Sql($community).',
        group_id = '.Str4Sql($group_id).',
        enabled = '.Str4Sql($enabled).',
        autoupdate = '.Str4Sql($autoupdate).',
        phone = '.Str4Sql($phone).',
        phone_alt = '.Str4Sql($phone_alt).',
        coordinates = '.Str4Sql($coordinates).',
        trap = '.Str4Sql($access_mode).',
        accounting_start = "'.$add_accounting_start.'",
        accounting_start_alt = "'.$add_accounting_start_alt.'",
        accounting_start_alt2 = "'.$add_accounting_start_alt2.'",
        read_location = "'.$read_location.'",
        read_gps = "'.$read_gps.'",
        read_temp_volt = "'.$read_temp_volt.'",
        period = "'.$period.'",
		snmp_prot = "'.$snmp_enabled.'",
		v3_username = "'.$snmp_username.'",
		v3_authentication = "'.$snmp_auth.'",
		v3_authpsw = "'.$snmp_auth_password.'",
		v3_privacy = "'.$snmp_privacy.'",
		v3_privpsw = "'.$snmp_privacy_password.'",
        new = "0"
        WHERE device_id = "'.$device_id.'"';

  		// vykonani SQL prikazu
      $result = db_query($link, $sql);

      $device_name = $hostname;

      echo "Parameters were changed.";
      log_event(get_company_id(),'Device '.$device_name.' was changed');
      break;
    }
    case "change_autoupdate":
    {
      $device_id = URI_get_int("device_id");
      if( is_null( $device_id ) )
      { // spatne device_id
        echo('Missing or incorrect device id !!!');
        exit;
      }
        $autoupdate = URI_get_int("autoupdate");

      $sql = 'UPDATE devices
        SET
        autoupdate = '.Str4Sql($autoupdate).',
        new = "0"
        WHERE device_id = "'.$device_id.'"';

  		// vykonani SQL prikazu
      $result = db_query($link, $sql);

      $sql = 'SELECT hostname
              FROM devices
              WHERE device_id = "'.$device_id.'"';
  		// vykonani SQL prikazu
      $result = db_query($link, $sql);

      list($hostname) = mysqli_fetch_row( $result );

      echo "Autoupdate was changed.";
      log_event(get_company_id(),$hostname.'\'s autoupdate was changed');

      break;
    }

    case "change_enabled":
    {
      $device_id = URI_get_int("device_id");
      if( is_null( $device_id ) )
      { // spatne device_id
        echo('Missing or incorrect device id !!!');
        exit;
      }

      $enabled = URI_get_int("enabled");

      $sql = 'UPDATE devices
        SET
        enabled = '.Str4Sql($enabled).',
        new = "0"
        WHERE device_id = "'.$device_id.'"';

  		// vykonani SQL prikazu
      $result = db_query($link, $sql);

      $sql = 'SELECT hostname
              FROM devices
              WHERE device_id = "'.$device_id.'"';
  		// vykonani SQL prikazu
      $result = db_query($link, $sql);

      list($hostname) = mysqli_fetch_row( $result );

      echo "Enabled was changed.";
      log_event(get_company_id(),$hostname.'\'s enabled was changed');

      break;
    }

    default:{   // neznama akce
      echo('Device Change Error: Unknow operation');
      break;
    }

  }

?>
	            </td>
            </tr>
<?php
	// pripojeni paticky
  include ("php/bottom.php");

?>
