<?php

//  require_once "../config.inc.php";	
//  require_once "mysql.php";
//  require_once "misc.php";

  if( isset($_GET['device_id']) && ($_GET['device_id'] != ''))
  {
    $device_id = $_GET['device_id'];
  }  
  else
  {
    echo "Error: Device ID is not specify !!!";
    exit;
  }

	$link = db_connect();

  $sql = 'SELECT hostname, hostname_alt, description, note, coordinates, product, firmware, last_level, health, health_alt, enabled, last_time_act
          FROM devices
          WHERE device_id = "'.mysqli_real_escape_string($link,$device_id).'"';
         //WHERE device_id = '.mysqli_real_escape_string($link, $device_id);   

	$result = db_query($link, $sql);

  list($hostname, $hostname_alt, $description, $note, $coordinates, $device, $firmware, $level, $health, $health_alt, $enabled, $update_time) = mysqli_fetch_row($result);

	// nacteni informaci o stavu zarizeni
  $sql = 'SELECT plmn, cell, status, uptime FROM stats 
          WHERE device_id = "'.mysqli_real_escape_string($link,$device_id).'"
          ORDER BY stat_id DESC LIMIT 1';

	// vykonani SQL prikazu
	$result = db_query($link, $sql);

  list($plmn, $cell, $tech, $uptime) = mysqli_fetch_row($result);

	// nacteni informaci o stavu zarizeni
  $sql = 'SELECT availability FROM day 
          WHERE device_id = "'.mysqli_real_escape_string($link,$device_id).'"
          ORDER BY day_id DESC LIMIT 1';

	// vykonani SQL prikazu
	$result = db_query($link, $sql);

  list($avail) = mysqli_fetch_row($result);

  $coordinates = explode(",",$coordinates);

  $lat = trim($coordinates[0]);
  $lng = trim($coordinates[1]);

  if(is_null($health_alt))
  {
    $health_state = $health;
  }
  else
  {
    $health_state = ($health < $health_alt) ? $health : $health_alt;
  }  

  if($enabled == 1)
  {
    switch($health_state)
    {
      case "0": $icon = "'http://labs.google.com/ridefinder/images/mm_20_green.png'"; break;
      case "1": $icon = "'http://labs.google.com/ridefinder/images/mm_20_orange.png'"; break;
      case "2": $icon = "'http://labs.google.com/ridefinder/images/mm_20_red.png'"; break;      
      default: $icon = "'http://labs.google.com/ridefinder/images/mm_20_red.png'"; break;                
    }
  }
  else
  {
    $icon = "'http://labs.google.com/ridefinder/images/mm_20_gray.png'";
  }
  
  $shadow = "'http://labs.google.com/ridefinder/images/mm_20_shadow.png'";


?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
  <head>
    <meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
    <meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
    <title>Device location</title>
    <script type="text/javascript" src="http://maps.googleapis.com/maps/api/js?sensor=false"></script>
    <script type="text/javascript">
    function load() {
      var map = new google.maps.Map(document.getElementById("map"), {
        center: new google.maps.LatLng(<?php echo $lat.",".$lng;?>),
        zoom: 14,
        mapTypeId: 'roadmap'
      });
      var infoWindow = new google.maps.InfoWindow;

<?php
  $label = "'<div id=\"labelcontent\"><table>' +\n";

  if(is_null($hostname) || ($hostname == ''))
  {
    $name = "---";
  }
  else
  {
    if($hostname == '0.0.0.0')
    {
      $name = "Behind NAT";      
    }
    else
    {
      $name = $hostname;
    }
  }

  if(is_null($hostname_alt) || ($hostname_alt == ''))
  {
    $name = $name.", ---";
  }
  else
  {
    if($hostname_alt == '0.0.0.0')
    {
      $name = $name.", Behind NAT";      
    }
    else
    {
      $name = $name.", ".$hostname_alt;
    }
  }

  $label = $label."'<tr><td><b>Hostname:</b></td><td><a href=\"javascript:void(0)\" onclick=\"openDeviceStatus(".$device_id.")\" title=\"Open Device Status\">".$name."</a></td></tr>' +\n";

  if(is_null($description) || ($description == ''))
  {
    $label = $label."'<tr><td><b>Description:</b></td><td>---</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>Description:</b></td><td>".$description."</td></tr>' +\n";    
  }

  if(is_null($note) || ($note == ''))
  {
    $label = $label."'<tr><td><b>Note:</b></td><td>---</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>Note:</b></td><td>".$note."</td></tr>' +\n";    
  }

  if(is_null($device) || ($device == ''))
  {
    $label = $label."'<tr><td><b>Device:</b></td><td>---</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>Device:</b></td><td>".$device."</td></tr>' +\n";    
  }  

  if(is_null($firmware) || ($firmware == ''))
  {
    $label = $label."'<tr><td><b>Firmware:</b></td><td>---</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>Firmware:</b></td><td>".$firmware."</td></tr>' +\n";    
  }

  if(is_null($level) || ($level == ''))
  {
    $label = $label."'<tr><td><b>Level:</b></td><td>--- dBm</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>Level:</b></td><td>".$level." dBm</td></tr>' +\n";    
  }

  if(is_null($plmn) || ($plmn == ''))
  {
    $label = $label."'<tr><td><b>PLMN:</b></td><td>---</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>PLMN:</b></td><td>".$plmn."</td></tr>' +\n";    
  }

  if(is_null($cell) || ($cell == ''))
  {
    $label = $label."'<tr><td><b>Cell ID:</b></td><td>---</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>Cell ID:</b></td><td>".dechex($cell)."</td></tr>' +\n";    
  }

  if(is_null($tech) || ($tech == ''))
  {
    $label = $label."'<tr><td><b>Data Service:</b></td><td>---</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>Data Service:</b></td><td>".decoding_network_status($tech)."</td></tr>' +\n";    
  }

  if(is_null($avail) || ($avail == ''))
  {
    $label = $label."'<tr><td><b>Availability:</b></td><td>---</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>Availability:</b></td><td>".$avail." %</td></tr>' +\n";    
  }

  if(is_null($uptime) || ($uptime == ''))
  {
    $label = $label."'<tr><td><b>Uptime:</b></td><td>---</td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><b>Uptime:</b></td><td>".UptimeToStr($uptime)."</td></tr>' +\n";    
  }  

  if(is_null($update_time) || ($update_time == ''))
  {
    $label = $label."'<tr><td><i>Updated at:</i></td><td><i>---</i></td></tr>' +\n";
  }
  else
  {
    $label = $label."'<tr><td><i>Updated at:</i></td><td><i>".$update_time."</i></td></tr>' +\n";    
  }

  $label = $label."'</table></div>'";  

?>
      var point = new google.maps.LatLng(
        parseFloat(<?php echo $lat;?>),
        parseFloat(<?php echo $lng;?>));
      var html = <?php echo $label?>;

      var marker = new google.maps.Marker({
        map: map,
        position: point,
        icon: <?php echo $icon;?>,
        shadow: <?php echo $shadow;?>
      });
      bindInfoWindow(marker, map, infoWindow, html);
    }

    function bindInfoWindow(marker, map, infoWindow, html) {
      google.maps.event.addListener(marker, 'click', function() {
        infoWindow.setContent(html);
        infoWindow.open(map, marker);
      });
    }
    
    function openDeviceStatus(device_id)
    {
      window.opener.document.location.href = '../index.php?page=device_status&device_id='+ device_id;
      self.close();
      return false;
    }

  </script>
  </head>
  <body onload="load()">
    <div id="map" style="width: 784px; height: 584px"></div>
  </body>
</html>
