<?php

/***************************************************************************/
/*                                                                         */
/*  STRANKA GRAFU ZARIZENI     	  					                               */
/*                                                                         */
/***************************************************************************/

  require_once "../config.inc.php";	
  require_once "mysql.php";


	if(isset($_GET['device_id']) && ($_GET['device_id'] != ''))
	{	// byl zadan kod operace
		$device_id = $_GET['device_id'];
	}	

  if(isset($_GET['color_scheme']))
  {
     $color_scheme = $_GET['color_scheme'];
  }	
  else
  {
     $color_scheme = "default";  
  }

  switch($color_scheme)
  {
    case "green":
      $scheme_file="style_green.css";
      break;
    case "blue":
      $scheme_file="style_blue.css";
      break;
    case "default":
    default:
      $scheme_file="style.css";
  }


	$link = db_connect();

  $sql = 'SELECT coordinates
          FROM devices
          WHERE device_id = "'.mysqli_real_escape_string($link,$device_id).'"';
         // WHERE device_id = '.mysqli_real_escape_string($link, $device_id);


	$result = db_query($link, $sql);

  list($coordinates) = mysqli_fetch_row($result);

  if(preg_match('/(-?[0-9]?[0-9]?[0-9].[0-9]{6},?){2}/', $coordinates))
  {
    $coordinates = explode(",",$coordinates);

    $lat = trim($coordinates[0]);
    $lng = trim($coordinates[1]);

    $know_position = 1;    
  }
  else
  {
    $know_position = 0;  
  }



?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/plain; charset=utf-8" />
		<meta name="description" content="TODO - info" />
    <meta http-equiv="pragma" content="no-cache">
    <meta http-equiv="cache-control" content="no-cache">    
		<title>Device position</title>
    <link rel='stylesheet' href='../css/<?php echo $scheme_file;?>' type='text/css' />
    <script type="text/javascript" src="http://maps.googleapis.com/maps/api/js?sensor=false"></script>
    <script type="text/javascript">
      var geocoder;
      var map;
      var marker;

      function initialize()
      {
        geocoder = new google.maps.Geocoder();
        map = new google.maps.Map(document.getElementById("map"), {
<?php
  if( $know_position )
  {
    echo "          center: new google.maps.LatLng(".$lat.", ".$lng."),\n";  
    echo "          zoom: 13,\n";
  }
  else
  {
    echo "          center: new google.maps.LatLng(50.092393,14.414063),\n";  
    echo "          zoom: 5,\n";  
  }
?>
          draggableCursor:'crosshair',
          mapTypeId: 'roadmap'
        });

        google.maps.event.addDomListener(map, 'rightclick', function(e){
          add_marker(e.latLng, map);
        });
<?php
  if( $know_position )
  {
    echo "        var point = new google.maps.LatLng(".$lat.", ".$lng.");\n";
    echo "        add_marker(point, map);\n";
  }
?>
      }

      function codeAddress() {
        var address = document.getElementById("address").value;
        geocoder.geocode( { 'address': address}, function(results, status) {
          if (status == google.maps.GeocoderStatus.OK) {
            map.setCenter(results[0].geometry.location);
            map.setZoom(13);
            if (! marker )
            {
              marker = new google.maps.Marker({
                  map: map,
                  draggable:true,
                  position: results[0].geometry.location
              });
            }
            else
            {
              marker.setPosition(results[0].geometry.location);
            }
            google.maps.event.addListener(marker, 'dragend', marker_move);
          } else {
            alert("Not found");
          }
        });
      }

      function marker_move()
      {
        map.panTo(marker.getPosition());
      }

      function add_marker(position, map)
      {
        if (! marker )
        {
          marker = new google.maps.Marker({
            map: map,
            draggable:true,
            position: position
          });
        }
        else
        {
          marker.setPosition(position);
        }      
      }

      function updateParent() {
        if ( marker )
        {
          var position = marker.getPosition();
          opener.document.f.coordinates.value = position.lat() + ', ' + position.lng();;
          self.close();
          return false;
        }
        else
        {
          alert("Position not specified");
          return true;
        }  
      }
      

    </script>
	</head>
  <body onload="initialize()" class="new_window">
		<table width="780px">
			<tr>
				<th>Device Position</th>
			</tr>
      <tr>
        <td>
          Address: <input id="address" type="text" value="" onkeydown="if (event.keyCode == 13) document.getElementById('search').click()"> <input type="button" id="search" value="Search" onclick="codeAddress()">
        </td>
      </tr>
      <tr align="center">
				<td>
          <div id="map" style="width: 784px; height: 584px"></div>
				</td>
      </tr>
      <tr>
        <td>
          <form onsubmit="return updateParent();">
            <input type="submit" value="Save Position">
          </form>
				</td>
			</tr>
		</table>
	</body>
</html>

