<?php

/***************************************************************************/
/*                                                                         */
/*  SCRIPT PRO PRIDAVANI ZARIZENI DO VYBERU	                               */
/*                                                                         */
/***************************************************************************/


	if (isset($_SESSION['last']))
	{	// nacti predchozi stranku
		header('Refresh: 3; URL = '.urldecode($_SESSION['last']));
	}
	else
	{	// nacti vychozi stranku
		header('Refresh: 3; URL = index.php');  
	}


  include ("php/head.php");
  include ("php/menu.php");

?>
            <tr>
              <th colspan="3">Select Device</th>  
            </tr>
            <tr>
              <td colspan="3">
<?php
  flush();	
  // pripojeni k DB
  $link = db_connect();	
		
  $sql = 'DELETE FROM selection WHERE time < (DATE_SUB(NOW(), INTERVAL 5 HOUR))';
		
  // vykonani SQL prikazu
  $result = db_query($link, $sql);
		
  if($_GET['sel'] == "Checked")
  { // vyber zaskrtnutych
    for($i = 0;$i < 25;$i++)
    {	// pres vsechny checkboxy
      if(isset($_GET['checkbox'.$i]))
      {	// nalezen zaskrtnuty checkbox
        $sql = 'SELECT * FROM selection WHERE device_id = "'.mysqli_real_escape_string($link,$_GET['checkbox'.$i]).'" AND session_id = "'.session_id().'"';

        // vykonani SQL prikazu
        $result = db_query($link, $sql);
				
        if(mysqli_num_rows($result) == 0)
        {
          // vlozeni zarizeni do vyberu
          $sql = 'INSERT INTO selection (device_id, time, session_id) VALUES("'.mysqli_real_escape_string($link,$_GET['checkbox'.$i]).'",NOW(),"'.session_id().'")';
					
          // vykonani SQL prikazu
          $result = db_query($link, $sql);					
        }
      }
    }
  }
  else
  { // vyber vsech zarizeni vyhovujicich filtru

    $sql = '';
					
    if((isset($_SESSION['desc_filter'])) && ($_SESSION['desc_filter'] != ''))
    {
      $sql = $sql.'AND description LIKE "%'.mysqli_real_escape_string($link,$_SESSION['desc_filter']).'%" ';                 
    }

    if((isset($_SESSION['host_filter'])) && ($_SESSION['host_filter'] != ''))
    {
      $sql = $sql.'AND hostname LIKE "%'.mysqli_real_escape_string($link,$_SESSION['host_filter']).'%" ';                 
    }            

    if((isset($_SESSION['host_alt_filter'])) && ($_SESSION['host_alt_filter'] != ''))
    {
      $sql = $sql.'AND hostname_alt LIKE "%'.mysqli_real_escape_string($link,$_SESSION['host_alt_filter']).'%" ';                 
    }
      
    if((isset($_SESSION['prod_filter'])) && ($_SESSION['prod_filter'] != ''))
    {
      $sql = $sql.'AND product="'.mysqli_real_escape_string($link,$_SESSION['prod_filter']).'" ';                 
    }

    if((isset($_SESSION['loc_filter'])) && ($_SESSION['loc_filter'] != ''))
    {
      $sql = $sql.'AND location LIKE "%'.mysqli_real_escape_string($link,$_SESSION['loc_filter']).'%" ';          
    }

    if((isset($_SESSION['note_filter'])) && ($_SESSION['note_filter'] != ''))
    {
      $sql = $sql.'AND note LIKE "%'.mysqli_real_escape_string($link,$_SESSION['note_filter']).'%" ';          
    }      
      
    if((isset($_SESSION['stat_filter'])) && ($_SESSION['stat_filter'] != ''))
    {
      $sql = $sql.'AND last_status="'.mysqli_real_escape_string($link,$_SESSION['stat_filter']).'" ';          
    }						
						
    if((isset($_SESSION['firm_filter'])) && ($_SESSION['firm_filter'] != ''))
    {
      $sql = $sql.'AND firmware="'.mysqli_real_escape_string($link,$_SESSION['firm_filter']).'" ';          
    }    

    if((isset($_SESSION['sn_filter'])) && ($_SESSION['sn_filter'] != ''))
    {
      $sql = $sql.'AND sn LIKE "%'.mysqli_real_escape_string($link,$_SESSION['sn_filter']).'%" ';          
    }

    if((isset($_SESSION['imei_filter'])) && ($_SESSION['imei_filter'] != ''))
    {
      $sql = $sql.'AND imei LIKE "%'.mysqli_real_escape_string($link,$_SESSION['imei_filter']).'%" ';          
    }

    if((isset($_SESSION['esn_filter'])) && ($_SESSION['esn_filter'] != ''))
    {
      $sql = $sql.'AND esn LIKE "%'.mysqli_real_escape_string($link,$_SESSION['esn_filter']).'%" ';          
    }

    if((isset($_SESSION['mac_filter'])) && ($_SESSION['mac_filter'] != ''))
    {
      $sql = $sql.'AND mac LIKE "%'.mysqli_real_escape_string($link,$_SESSION['mac_filter']).'%" ';          
    }

    if((isset($_SESSION['group_filter'])) && ($_SESSION['group_filter'] != ''))
    {
      $sql = $sql.'AND group_id="'.mysqli_real_escape_string($link,$_SESSION['group_filter']).'" ';          
    }

    if((isset($_SESSION['health_filter'])) && ($_SESSION['health_filter'] != ''))
    {
      if( $_SESSION['health_filter'] != 3 )
      {
        $sql = $sql.'AND health = "'.mysqli_real_escape_string($link,$_SESSION['health_filter']).'" ';                 
      }
      else
      {
        $sql = $sql.'AND new = "1" ';                       
      }
    }

    if((isset($_SESSION['health_alt_filter'])) && ($_SESSION['health_alt_filter'] != ''))
    {
      if( $_SESSION['health_alt_filter'] != 3 )
      {
        $sql = $sql.'AND health_alt = "'.mysqli_real_escape_string($link,$_SESSION['health_alt_filter']).'" ';
      }
      else
      {
        $sql = $sql.'AND new = "1" ';      
      }
    }

    if((isset($_SESSION['name_filter'])) && ($_SESSION['name_filter'] != ''))
    {
      $sql = $sql.'AND name LIKE "%'.mysqli_real_escape_string($link,$_SESSION['name_filter']).'%" ';                 
    }

    $sql = 'CALL sp_MakeSelection(\''.$sql.'\',"'.session_id().'","'.get_company_id().'")';
      
    // vykonani SQL prikazu
    $result = db_multi_query($link, $sql);
      
    if(mysqli_more_results($link))
    {	//Catch 'OK'/'ERR'
      while(mysqli_next_result($link));
    }      
  }
    
?>
                Devices were added to selection.
              </td>
            </tr>
<?php
	
	// pripojeni paticky
  include ("php/bottom.php");

?>
