<?php

// funkce pro vygenerovani pocatecniho data podle zvoleneho obdobi pro stats
function get_start($period, $num_sim, $dev_id)
{
  switch($period)
   {
     case 0 : // today
         return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , date("d"), date("Y")))."\"";
         break;
     case 1 : // Yesterday
         return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , date("d")-1, date("Y")))."\"";
         break;
     case 2 : // Current Week
         return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , date("d") - date("N") + 1, date("Y")))."\"";
         break;
     case 3 : // Current Period
           /**
          return " (SELECT IF (DAY(NOW())>=accounting_start,
          CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\",   accounting_start, \" 00:00:00\"),
          IF(MONTH(NOW())>1,
          CONCAT(YEAR(NOW()), \"-\", MONTH(NOW())-1, \"-\",   accounting_start, \" 00:00:00\"),
          CONCAT(YEAR(NOW())-1, \"-\", \"12\", \"-\",   accounting_start, \" 00:00:00\"))
          )
          FROM devices d  WHERE d.device_id=".$dev_id.")";
           */

          switch ($num_sim)
          {
           case 0:
           return "(SELECT IF (DAY(NOW())>=accounting_start,
            CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH))
             FROM devices d WHERE d.device_id=".$dev_id.")";
           break;
           case 1:
           return "(SELECT IF (DAY(NOW())>=accounting_start_alt,
            CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH))
             FROM devices d WHERE d.device_id=".$dev_id.")";
           break;
           case 2:
           return "(SELECT IF (DAY(NOW())>=accounting_start_alt2,
            CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH))
             FROM devices d WHERE d.device_id=".$dev_id.")";
           break;

           default:break;

          }



        // return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , 1, date("Y")))."\"";
        // return date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , 1, date("Y")));
         break;
     case 4 : // Last Period
         //return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")-1  , 1, date("Y")))."\"";
         switch ($num_sim)
         {
          case 0:
           return "(SELECT IF (DAY(NOW())>=accounting_start,
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH),
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 2 MONTH))
             FROM devices d WHERE d.device_id=".$dev_id.")";
             break;
          case 1:
           return "(SELECT IF (DAY(NOW())>=accounting_start_alt,
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH),
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 2 MONTH))
             FROM devices d WHERE d.device_id=".$dev_id.")";
             break;
           case 2:
           return "(SELECT IF (DAY(NOW())>=accounting_start_alt2,
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH),
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 2 MONTH))
             FROM devices d WHERE d.device_id=".$dev_id.")";
             break;

         default: break;
         }
     default : echo "Error number of sim";
              return 1;
     break;
   }

}


// funkce pro vygenerovani koncoveho data podle zvoleneho obdobi pro stats
function get_end($period, $num_sim, $dev_id)
{
  switch($period)
   {
     case 0 : // today
          //return "\"" .date("Y-m-d H:i:s",time())."\"";
          return "(select CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", DAY(NOW()), \" 23:59:59\"))";
          break;
     case 1 : // Yesterday
          return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , date("d"), date("Y")) - 1)."\"";
          break;
     case 2 : // Current Week
          //return "\"" .date("Y-m-d H:i:s",time())."\"";
          return "(select CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", DAY(NOW()), \" 23:59:59\"))";
          break;
     case 3 : // Current Period
          //return "\"" .date("Y-m-d H:i:s",time())."\"";
          return "(select CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", DAY(NOW()), \" 23:59:59\"))";
          break;
     case 4 : // Last Period
          //return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , 1, date("Y")))."\"";

          switch ($num_sim)
          {
          case 0:
          return "(SELECT IF (DAY(NOW())>=accounting_start,
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 SECOND),
          DATE_SUB(
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 MONTH ), INTERVAL 1 SECOND)
          )
          FROM devices d WHERE d.device_id=".$dev_id.")";
          break;

          case 1:
          return "(SELECT IF (DAY(NOW())>=accounting_start_alt,
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 SECOND),
          DATE_SUB(
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 MONTH ), INTERVAL 1 SECOND)
          )
          FROM devices d WHERE d.device_id=".$dev_id.")";
          break;

          case 2:
          return "(SELECT IF (DAY(NOW())>=accounting_start_alt2,
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 SECOND),
          DATE_SUB(
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 MONTH ), INTERVAL 1 SECOND)
          )
          FROM devices d WHERE d.device_id=".$dev_id.")";
          break;
          default:break;
          }

          break;
     default : echo "Error number of sim";
              return 1;
     break;
   }
}


// funkce pro vygenerovani pocatecniho data podle zvoleneho obdobi pro day
function get_start_day($period, $num_sim, $dev_id)
{
  switch($period)
   {
     case 0 : // today
         return "\"" .date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d"), date("Y")))."\"";
         break;
     case 1 : // Yesterday
         return "\"" .date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")-1, date("Y")))."\"";
         break;
     case 2 : // Current Week
         return "\"" .date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d") - date("N") + 1, date("Y")))."\"";
         break;
     case 3 : // Current Period
           /**
          return " (SELECT IF (DAY(NOW())>=accounting_start,
          CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\",   accounting_start, \" 00:00:00\"),
          IF(MONTH(NOW())>1,
          CONCAT(YEAR(NOW()), \"-\", MONTH(NOW())-1, \"-\",   accounting_start, \" 00:00:00\"),
          CONCAT(YEAR(NOW())-1, \"-\", \"12\", \"-\",   accounting_start, \" 00:00:00\"))
          )
          FROM devices d  WHERE d.device_id=".$dev_id.")";
           */
          switch ($num_sim)
          {
           case 0:
           return "(SELECT IF (DAY(NOW())>=accounting_start,
            CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start),
            DATE(
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH)))
             FROM devices d WHERE d.device_id=".$dev_id.")";
             break;
            case 1:
           return "(SELECT IF (DAY(NOW())>=accounting_start_alt,
            CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt),
            DATE(
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH)))
             FROM devices d WHERE d.device_id=".$dev_id.")";
             break;
             case 2:
           return "(SELECT IF (DAY(NOW())>=accounting_start_alt2,
            CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2),
            DATE(
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH)))
             FROM devices d WHERE d.device_id=".$dev_id.")";
             break;

           default:break;
          }


        // return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , 1, date("Y")))."\"";
        // return date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , 1, date("Y")));
         break;
     case 4 : // Last Period
         //return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")-1  , 1, date("Y")))."\"";
         switch ($num_sim)
         {
         case 0:
            return "(SELECT IF (DAY(NOW())>=accounting_start,
            DATE(DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH)),
            DATE(
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 2 MONTH)))
             FROM devices d WHERE d.device_id=".$dev_id.")";
           break;
         case 1:
            return "(SELECT IF (DAY(NOW())>=accounting_start_alt,
            DATE(DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH)),
            DATE(
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 2 MONTH)))
             FROM devices d WHERE d.device_id=".$dev_id.")";
           break;
         case 2:
            return "(SELECT IF (DAY(NOW())>=accounting_start_alt2,
            DATE(DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 1 MONTH)),
            DATE(
            DATE_SUB(
            STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
            INTERVAL 2 MONTH)))
             FROM devices d WHERE d.device_id=".$dev_id.")";
           break;
          default:break;
         }
         break;

     default : echo "Error number of sim";
              return 1;
     break;
   }

}


// funkce pro vygenerovani koncoveho data podle zvoleneho obdobi pro day
function get_end_day($period, $num_sim, $dev_id)
{
  switch($period)
   {
     case 0 : // today
          //return "\"" .date("Y-m-d H:i:s",time())."\"";
          return "(select CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", DAY(NOW())))";
          break;
     case 1 : // Yesterday
          return "\"" .date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d"), date("Y")) - 1)."\"";
          break;
     case 2 : // Current Week
          //return "\"" .date("Y-m-d H:i:s",time())."\"";
          return "(select CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", DAY(NOW())))";
          break;
     case 3 : // Current Period
          //return "\"" .date("Y-m-d H:i:s",time())."\"";
          return "(select CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", DAY(NOW())))";
          break;
     case 4 : // Last Period
          //return "\"" .date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , 1, date("Y")))."\"";

          switch ($num_sim)
          {
          case 0:
          return "(SELECT IF (DAY(NOW())>=accounting_start,
          DATE(
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 SECOND)),
          DATE(
          DATE_SUB(
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 MONTH ), INTERVAL 1 SECOND))
          )
          FROM devices d WHERE d.device_id=".$dev_id.")";
          break;
          case 1:
          return "(SELECT IF (DAY(NOW())>=accounting_start_alt,
          DATE(
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 SECOND)),
          DATE(
          DATE_SUB(
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 MONTH ), INTERVAL 1 SECOND))
          )
          FROM devices d WHERE d.device_id=".$dev_id.")";
          break;
          case 2:
          return "(SELECT IF (DAY(NOW())>=accounting_start_alt2,
          DATE(
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 SECOND)),
          DATE(
          DATE_SUB(
          DATE_SUB(
          STR_TO_DATE(CONCAT(YEAR(NOW()), \"-\", MONTH(NOW()), \"-\", accounting_start_alt2, \" 00:00:00\"),'%Y-%m-%d %H:%i:%s'),
          INTERVAL 1 MONTH ), INTERVAL 1 SECOND))
          )
          FROM devices d WHERE d.device_id=".$dev_id.")";
          break;
          default:break;
          }

          break;
     default : echo "Error number of sim";
              return 1;
     break;
   }
}



	// pripojeni k DB
	$link = db_connect();

  $sql = 'SELECT hostname_alt
          FROM devices
				  WHERE device_id="'.mysqli_real_escape_string($link,$device_id).'"';

	// vykonani SQL prikazu
	$result = db_query($link, $sql);

	// nacteni dat z odpovedi
	list($hostname_alt) = mysqli_fetch_row($result);

  $is2sim = 1;
	if(is_null($hostname_alt) || (strlen($hostname_alt) < 3))
  {
    $is2sim = 0;
	}

  $sim_id = URI_get_int( "sim_id" );
  if( is_null( $sim_id ) )
  {
    $sim_id = 0;
  }
/** Puvodni kod:

	$start = array();
	$end = array();

	// vytvoreni intervalu pro tabulky - today, yesterday, week, month, last month
	$start[0] = date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , date("d"), date("Y")));
	$end[0] = date("Y-m-d H:i:s",time());
          
	$start[1] = date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , date("d")-1, date("Y")));
	$end[1] = date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , date("d"), date("Y")) - 1);
          
	$start[2] = date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , date("d") - date("N") + 1, date("Y")));
	$end[2] = date("Y-m-d H:i:s",time());
          
	$start[3] = date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , 1, date("Y")));
	$end[3] = date("Y-m-d H:i:s",time()); 

	$start[4] = date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")-1  , 1, date("Y")));
	$end[4] = date("Y-m-d H:i:s",mktime(0, 0, 0, date("m")  , 1, date("Y")));
*/        

  $intervals = array ("Today", "Yesterday", "Current Week", "Current Period", "Last Period");

?>
            <tr>
              <td colspan="3">      
                <table width="100%">
<?php
  // odchyceni stranky
  ob_start();
?>
                <tr>
<?php

  echo "                  <td class=\"header\" colspan=\"2\">Traffic</td>\n";
  echo "                </tr>\n";

  echo "                <tr>\n";
  echo "                  <td valign=\"top\">\n";
  echo "                    <table cellspacing=\"2\" cellpadding=\"2\" border=\"1\" width=\"100%\" style=\"border-collapse: collapse;\">\n";
  echo "                      <tr>\n";
  echo "                        <th>Traffic</th><th>Total Data</th><th>Received</th><th>Sent</th><th>Connections</th>\n";
  echo "                      </tr>\n";


  for($i = 0;$i < 5;$i++)
  {

    $sql = 'SELECT SUM(rx_diff), SUM(tx_diff)
	    		  FROM stats
			  	  WHERE device_id="'.$device_id.'"
				    AND time BETWEEN ' .get_start($i,$sim_id,$device_id) . ' AND ' . get_end($i,$sim_id,$device_id) . ' AND alt = "'.$sim_id.'"';

   // echo $sql; ###
		// vykonani SQL prikazu
		$result = db_query($link, $sql);

		// nacteni dat z odpovedi
		list($rx_sum, $tx_sum) = mysqli_fetch_row($result);     

    switch( $sim_id )
    {
      case 0:
        $sql = 'SELECT SUM(numconn)
	    					FROM day
		    				WHERE date BETWEEN ' .get_start_day($i,$sim_id,$device_id). ' AND ' .get_end_day($i,$sim_id,$device_id).
                            ' AND device_id = "'.$device_id.'"';
        break;

      case 1:
    		$sql = 'SELECT SUM(numconn2)
    						FROM day
    						WHERE date BETWEEN ' .get_start_day($i,$sim_id,$device_id). ' AND ' .get_end_day($i,$sim_id,$device_id).
                            ' AND device_id = "'.$device_id.'"';
        break;

      case 2:
    		$sql = 'SELECT SUM(numconn3)
    						FROM day
    						WHERE date BETWEEN ' .get_start_day($i,$sim_id,$device_id). ' AND ' .get_end_day($i,$sim_id,$device_id).
                            ' AND device_id = "'.$device_id.'"';
        break;
    }

    //echo $sql; //###JP

	  // vykonani SQL prikazu
	  $result = db_query($link, $sql);

    list($connect) = mysqli_fetch_row($result);

		if(is_null($connect)){
			$connect = '---';
		}

    $total_sum = (is_null($rx_sum) || is_null($tx_sum)) ? "---" : ConvertNumBytes($rx_sum + $tx_sum);
    $rx_sum = is_null($rx_sum) ? "---" : ConvertNumBytes($rx_sum);
    $tx_sum = is_null($tx_sum) ? "---" : ConvertNumBytes($tx_sum);

    echo "                      <tr align=\"center\">\n";
    echo "                        <td align=\"left\">".$intervals[$i]."</td>\n";
    echo "                        <td nowrap>".$total_sum."</td>\n";
    echo "                        <td nowrap>".$rx_sum."</td>\n";
    echo "                        <td nowrap>".$tx_sum."</td>\n";
    echo "                        <td nowrap>".$connect."</td>\n";
    echo "                      </tr>\n";
  }
  echo "                    </table>\n";
  echo "                  </td>\n";  
  echo "                  <td valign=\"top\">\n";
  echo "                  </td>\n";  
  echo "                </tr>\n";
  // prazdny radek
  echo "                <tr>\n";
  echo "                  <td>\n";
  echo "                  </td>\n";
  echo "                  <td>\n";
  echo "                  </td>\n";
  echo "                </tr>\n";

  echo "                <tr>\n";
  echo "                  <td class=\"header\" colspan=\"2\" nowrap>Signal Strength</td>\n";  
  echo "                </tr>\n";

  $signal_graphs = array ("signal_tod", "signal_yes", "signal_week", "signal_cur", "signal_last");

 	// nacteni informaci o stavu zarizeni
 	$sql = 'SELECT level, latency, status '.
         'FROM stats '.
         'WHERE device_id = "'.$device_id.'" '.
         'ORDER BY stat_id DESC LIMIT 1';

 	// vykonani SQL prikazu
 	$result = db_query($link, $sql);

 	// nacteni hodnot z odpovedi
 	list( $level, $latency, $act_status ) = mysqli_fetch_row($result);

 	$level = is_null($level) ? '---' : $level;
 	$latency = is_null($latency) ? '---' : $latency;

  $sql = 'SELECT DISTINCT status
          FROM stats
          WHERE device_id = "'.$device_id.'" AND time BETWEEN '.get_start(4,$sim_id,$device_id) .' AND '. get_end(3,$sim_id,$device_id) .' AND status IS NOT NULL AND alt = "'.$sim_id.'" ORDER BY status';

	// vykonani SQL prikazu
  $result = db_query($link, $sql);

  while( list($status) = mysqli_fetch_row( $result ) )
  {
    echo "                <tr>\n";
    echo "                  <td valign=\"top\">\n";
    echo "                    <table cellspacing=\"2\" cellpadding=\"2\" border=\"1\" nowrap width=\"100%\" style=\"border-collapse: collapse;\">\n";
    echo "                      <tr>\n";
    echo "                        <th nowrap>".decoding_network_status($status)."</th><th>Average</th><th>Minimum</th><th>Maximum</th><th>Cells</th><th>Services</th>\n";
    echo "                      </tr>\n";

    for($i = 0;$i < 5;$i++)
    {

      $sql = 'SELECT AVG(level), MIN(level), MAX(level) 
		  			  FROM stats
			  		  WHERE device_id="'.$device_id.'"
				  	  AND time BETWEEN ' .get_start($i,$sim_id,$device_id) . ' AND ' . get_end($i,$sim_id,$device_id) . ' AND alt = "'.$sim_id.'" AND status = "'.$status.'"';

      //echo $sql;
	  	// vykonani SQL prikazu
  		$result1 = db_query($link, $sql);

		  // nacteni dat z odpovedi
	  	list($level_avg, $level_min, $level_max) = mysqli_fetch_row($result1);

  		if($level_avg == 0){
  			$level_avg = '---'; 
      }
      else
      {
  			$level_avg = intval($level_avg);    
      }

   		if(is_null($level_min)){
  			$level_min = '---'; 
  		}

  		if(is_null($level_max)){
  			$level_max = '---'; 
  		}   

      switch( $sim_id )
      {
        case 0:
          $sql = 'SELECT SUM(numswitch)
	      	  			FROM day
		  	      		WHERE date BETWEEN ' .get_start_day($i,$sim_id,$device_id). ' AND ' .get_end_day($i,$sim_id,$device_id).
                        ' AND device_id = "'.$device_id.'"';
          break;

        case 1:
      		$sql = 'SELECT SUM(numswitch2)
      					FROM day
      					WHERE date BETWEEN ' .get_start_day($i,$sim_id,$device_id). ' AND ' .get_end_day($i,$sim_id,$device_id).
                         ' AND device_id = "'.$device_id.'"';
          break;

        case 2:
      		$sql = 'SELECT SUM(numswitch3)
      					FROM day
      					WHERE date BETWEEN ' .get_start_day($i,$sim_id,$device_id). ' AND ' .get_end_day($i,$sim_id,$device_id).
                         ' AND device_id = "'.$device_id.'"';
          break;
      }

    	// vykonani SQL prikazu
   		$result1 = db_query($link, $sql);

 		  list($cell_id) = mysqli_fetch_row($result1);

      $cell_id = is_null($cell_id) ? "---" : $cell_id;

      $sql = 'SELECT DISTINCT cell
              FROM stats
              WHERE device_id = "'.$device_id.'" AND cell is not null
              AND time BETWEEN ' .get_start($i,$sim_id,$device_id) . ' AND ' . get_end($i,$sim_id,$device_id) . ' AND alt = "'.$sim_id.'" AND status = "'.$status.'"';
      // vykonani SQL prikazu
      $result1 = db_query($link, $sql);

      $cell_list = '';
    
      if(mysqli_num_rows($result1))
      {
        while( list($temp_cell) = mysqli_fetch_row($result1) )
        {
          $cell_list = $cell_list.' '.dechex($temp_cell).' &#13';
        }
      }
      else
      {
        $cell_list = '---';
      }

      // volani funkce pro zjisteni poctu zmen service (EGDE, UMTS, ...)
      $sql = 'CALL sp_GetServiceChange("'.$device_id.'",' .get_start($i,$sim_id,$device_id) . ',' . get_end($i,$sim_id,$device_id) . ', "'.$sim_id.'", "'.$status.'")';

      // vykonani SQL prikazu
      $result1 = db_multi_query($link, $sql);		
		
      list($service_changes) = mysqli_fetch_row($result1);
	
      if($service_changes == 0)
      {
        $service_changes = '---';
      }
  
      if(mysqli_more_results($link))
      {	//Catch 'OK'/'ERR'
        while(mysqli_next_result($link));
      }      

      echo "                      <tr align=\"center\">\n";
      echo "                        <td align=\"left\" width=\"120px\" nowrap>".$intervals[$i]." <a href=\"javascript:void(0);\" onClick=\"window.open('index.php?page=device_graph_page&graph=".$signal_graphs[$i]."&device_id=".$device_id."','_blank','height=400,width=845,left=100, top=100,resizable=no,scrollbars=no,');\"><img src=\"img/chart.png\" border=\"0\" align=\"right\"></a></td>\n";
      echo "                        <td nowrap>".$level_avg." dBm</td>\n";
      echo "                        <td nowrap>".$level_min." dBm</td>\n";
      echo "                        <td nowrap>".$level_max." dBm</td>\n";
      echo "                        <td title=\"Cells:&#13".$cell_list."\"><span class=\"alt_window\">".$cell_id."</span></td>\n";
      echo "                        <td nowrap>".$service_changes."</td>\n";
        echo "                      </tr>\n";
    }  

    echo "                    </table>\n";
    echo "                  </td>\n";  

	  // prumerna hodnota sily signalu a odezvy	
    $sql = 'SELECT AVG(level) FROM stats
            WHERE device_id="'.$device_id.'" AND status = "'.$status.'"';

	  // vykonani SQL prikazu
  	$result1 = db_query($link, $sql);
        
  	// nacteni dat z odpovedi
  	list($level_avg_all) = mysqli_fetch_row($result1);
          				
  	// maximalni sila signalu a cas vyskytu
    $sql = 'SELECT level, time FROM stats
            WHERE device_id = "'.$device_id.'" AND level = (SELECT MAX(level) FROM stats WHERE device_id = "'.$device_id.'" AND status = "'.$status.'")';

  	// vykonani SQL prikazu
  	$result1 = db_query($link, $sql);
        
  	// vykonani SQL prikazu
  	list($level_max_all,$level_max_time) = mysqli_fetch_row($result1);           

    // minimalni sila signalu a cas vyskytu        
    $sql = 'SELECT level, time FROM stats
            WHERE device_id = "'.$device_id.'" AND level = (SELECT MIN(level) FROM stats WHERE device_id = "'.$device_id.'" AND status = "'.$status.'")';

  	// vykonani SQL prikazu
  	$result1 = db_query($link, $sql);
  
  	// nacteni dat z odpovedi
  	list($level_min_all,$level_min_time) = mysqli_fetch_row($result1);    

    echo "                  <td valign=\"top\">\n";
    echo "                    <table cellspacing=\"2\" cellpadding=\"2\" border=\"1\" width=\"100%\" style=\"border-collapse:collapse;\">\n";
    echo "                      <tr>\n";
    echo "                        <th>Current</th><th>Average</th><th>Minimum</th><th>Maximum</th>\n";
    echo "                      </tr>\n";
    echo "                      <tr align=\"center\">\n";
    if( $status == $act_status )
    {
      echo "                        <td nowrap>".$level." dBm</td>\n";    
    }
    else
    {
      echo "                        <td nowrap>--- dBm</td>\n";    
    }
    echo "                        <td nowrap>".intval($level_avg_all)." dBm</td>\n";
    echo "                        <td nowrap>".$level_min_all." dBm</td>\n";
    echo "                        <td nowrap>".$level_max_all." dBm</td>\n";
    echo "                      </tr>\n";        
    echo "                      <tr align=\"center\">\n";
    echo "                        <td colspan=\"2\"></td>\n";
    echo "                        <td nowrap>".date("d.m.Y H:i",strtotime($level_min_time))."</td>\n";
    echo "                        <td nowrap>".date("d.m.Y H:i",strtotime($level_max_time))."</td>\n";
    echo "                      </tr>\n";        
    echo "                    </table>\n";
    echo "                  </td>\n";
    echo "                </tr>\n";
  }

  // prazdny radek
  echo "                <tr>\n";
  echo "                  <td>\n";
  echo "                  </td>\n";
  echo "                  <td>\n";
  echo "                  </td>\n";
  echo "                </tr>\n";  

  echo "                <tr>\n";
  echo "                  <td class=\"header\" colspan=\"2\" nowrap>Signal Quality</td>\n";  
  echo "                </tr>\n";

  $quality_graphs = array ("quality_tod", "quality_yes", "quality_week", "quality_cur", "quality_last");

 	// nacteni informaci o stavu zarizeni
 	$sql = 'SELECT signal_quality, status '.
         'FROM stats '.
         'WHERE device_id = "'.$device_id.'" '.
         'ORDER BY stat_id DESC LIMIT 1'; 

 	// vykonani SQL prikazu
 	$result = db_query($link, $sql);

 	// nacteni hodnot z odpovedi
 	list( $quality, $act_status ) = mysqli_fetch_row($result);

 	$quality = is_null($quality) ? '---' : $quality;

  $sql = 'SELECT DISTINCT status
          FROM stats
          WHERE device_id = "'.$device_id.'" AND time BETWEEN '.get_start(4,$sim_id,$device_id) .' AND '. get_end(3,$sim_id,$device_id) .' AND status > 4 AND alt = "'.$sim_id.'" ORDER BY status';

	// vykonani SQL prikazu
  $result = db_query($link, $sql);

  while( list($status) = mysqli_fetch_row( $result ) )
  {
    echo "                <tr>\n";
    echo "                  <td valign=\"top\">\n";
    echo "                    <table cellspacing=\"2\" cellpadding=\"2\" border=\"1\" nowrap width=\"100%\" style=\"border-collapse: collapse;\">\n";
    echo "                      <tr>\n";
    echo "                        <th nowrap>".decoding_network_status($status)."</th><th>Average</th><th>Minimum</th><th>Maximum</th>\n";
    echo "                      </tr>\n";

    for($i = 0;$i < 5;$i++)
    {

      $sql = 'SELECT AVG(signal_quality), MIN(signal_quality), MAX(signal_quality) 
		  			  FROM stats
			  		  WHERE device_id="'.$device_id.'" 
				  	  AND time BETWEEN ' .get_start($i,$sim_id,$device_id) . ' AND ' . get_end($i,$sim_id,$device_id) . ' AND alt = "'.$sim_id.'" AND status = "'.$status.'"';

      //echo $sql;
	  	// vykonani SQL prikazu
  		$result1 = db_query($link, $sql);

		  // nacteni dat z odpovedi
	  	list($quality_avg, $quality_min, $quality_max) = mysqli_fetch_row($result1);

  		if($quality_avg == 0){
  			$quality_avg = '---'; 
      }
      else
      {
  			$quality_avg = intval($quality_avg);    
      }

   		if(is_null($quality_min)){
  			$quality_min = '---'; 
  		}

  		if(is_null($quality_max)){
  			$quality_max = '---'; 
  		}   

      echo "                      <tr align=\"center\">\n";
      echo "                        <td align=\"left\" width=\"120px\" nowrap>".$intervals[$i]." <a href=\"javascript:void(0);\" onClick=\"window.open('index.php?page=device_graph_page&graph=".$quality_graphs[$i]."&device_id=".$device_id."','_blank','height=400,width=845,left=100, top=100,resizable=no,scrollbars=no,');\"><img src=\"img/chart.png\" border=\"0\" align=\"right\"></a></td>\n";
      echo "                        <td nowrap>".$quality_avg." dB</td>\n";
      echo "                        <td nowrap>".$quality_min." dB</td>\n";
      echo "                        <td nowrap>".$quality_max." dB</td>\n";
      echo "                      </tr>\n";
    }  

    echo "                    </table>\n";
    echo "                  </td>\n";  

	  // prumerna hodnota sily signalu	
    $sql = 'SELECT AVG(signal_quality) FROM stats
            WHERE device_id="'.$device_id.'" AND status = "'.$status.'"';

	  // vykonani SQL prikazu
  	$result1 = db_query($link, $sql);
        
  	// nacteni dat z odpovedi
  	list($quality_avg_all) = mysqli_fetch_row($result1);
          				
  	// maximalni kvalita signalu
    $sql = 'SELECT signal_quality, time FROM stats
            WHERE device_id = "'.$device_id.'" AND signal_quality = (SELECT MAX(signal_quality) FROM stats WHERE device_id = "'.$device_id.'" AND status = "'.$status.'")';

  	// vykonani SQL prikazu
  	$result1 = db_query($link, $sql);
        
  	// vykonani SQL prikazu
  	list($quality_max_all,$quality_max_time) = mysqli_fetch_row($result1);           

    // minimalni kvalita signalu
    $sql = 'SELECT signal_quality, time FROM stats
            WHERE device_id = "'.$device_id.'" AND signal_quality = (SELECT MIN(signal_quality) FROM stats WHERE device_id = "'.$device_id.'" AND status = "'.$status.'")';

  	// vykonani SQL prikazu
  	$result1 = db_query($link, $sql);
  
  	// nacteni dat z odpovedi
  	list($quality_min_all,$quality_min_time) = mysqli_fetch_row($result1);    

    echo "                  <td valign=\"top\">\n";
    echo "                    <table cellspacing=\"2\" cellpadding=\"2\" border=\"1\" width=\"100%\" style=\"border-collapse:collapse;\">\n";
    echo "                      <tr>\n";
    echo "                        <th>Current</th><th>Average</th><th>Minimum</th><th>Maximum</th>\n";
    echo "                      </tr>\n";
    echo "                      <tr align=\"center\">\n";
    if( $status == $act_status )
    {
      echo "                        <td nowrap>".$quality." dB</td>\n";    
    }
    else
    {
      echo "                        <td nowrap>--- dB</td>\n";    
    }
    echo "                        <td nowrap>".intval($quality_avg_all)." dB</td>\n";
    echo "                        <td nowrap>".$quality_min_all." dB</td>\n";
    echo "                        <td nowrap>".$quality_max_all." dB</td>\n";
    echo "                      </tr>\n";        
    echo "                      <tr align=\"center\">\n";
    echo "                        <td colspan=\"2\"></td>\n";
    echo "                        <td nowrap>".date("d.m.Y H:i",strtotime($quality_min_time))."</td>\n";
    echo "                        <td nowrap>".date("d.m.Y H:i",strtotime($quality_max_time))."</td>\n";
    echo "                      </tr>\n";        
    echo "                    </table>\n";
    echo "                  </td>\n";
    echo "                </tr>\n";
  }

  // prazdny radek
  echo "                <tr>\n";
  echo "                  <td>\n";
  echo "                  </td>\n";
  echo "                  <td>\n";
  echo "                  </td>\n";
  echo "                </tr>\n";

  echo "                <tr>\n";
  echo "                  <td class=\"header\" colspan=\"2\" nowrap>Latency</td>\n";  
  echo "                </tr>\n";

  $latency_graphs = array ("latency_tod", "latency_yes", "latency_week", "latency_cur", "latency_last");

  $sql = 'SELECT DISTINCT status
          FROM stats
          WHERE device_id = "'.$device_id.'" AND time BETWEEN '.get_start(4,$sim_id,$device_id) .' AND '. get_end(3,$sim_id,$device_id) .' AND status IS NOT NULL AND alt = "'.$sim_id.'" ORDER BY status';

	// vykonani SQL prikazu
  $result = db_query($link, $sql);

  while( list($status) = mysqli_fetch_row( $result ) )
  {
    echo "                <tr>\n";
    echo "                  <td valign=\"top\">\n";
    echo "                    <table cellspacing=\"2\" cellpadding=\"2\" border=\"1\" nowrap width=\"100%\" style=\"border-collapse: collapse;\">\n";
    echo "                      <tr>\n";
    echo "                        <th nowrap>".decoding_network_status($status)."</th><th>Average</th><th>Minimum</th><th>Maximum</th>\n";
    echo "                      </tr>\n";

    for($i = 0;$i < 5;$i++)
    {

      $sql = 'SELECT AVG(latency), MIN(latency), MAX(latency) 
		  			  FROM stats
			  		  WHERE device_id="'.$device_id.'" 
				  	  AND time BETWEEN ' .get_start($i,$sim_id,$device_id) . ' AND ' . get_end($i,$sim_id,$device_id) . ' AND alt = "'.$sim_id.'" AND status = "'.$status.'"';

      //echo $sql;
	  	// vykonani SQL prikazu
  		$result1 = db_query($link, $sql);

		  // nacteni dat z odpovedi
	  	list($latency_avg, $latency_min, $latency_max) = mysqli_fetch_row($result1);

  		if($latency_avg == 0){
  			$latency_avg = '---'; 
      }
      else
      {
  			$latency_avg = intval($latency_avg);    
      }

   		if(is_null($latency_min)){
  			$latency_min = '---'; 
  		}

  		if(is_null($latency_max)){
  			$latency_max = '---'; 
  		}   

      echo "                      <tr align=\"center\">\n";
      echo "                        <td align=\"left\" width=\"120px\" nowrap>".$intervals[$i]." <a href=\"javascript:void(0);\" onClick=\"window.open('index.php?page=device_graph_page&graph=".$latency_graphs[$i]."&device_id=".$device_id."','_blank','height=400,width=845,left=100, top=100,resizable=no,scrollbars=no,');\"><img src=\"img/chart.png\" border=\"0\" align=\"right\"></a></td>\n";
      echo "                        <td nowrap>".$latency_avg." ms</td>\n";
      echo "                        <td nowrap>".$latency_min." ms</td>\n";
      echo "                        <td nowrap>".$latency_max." ms</td>\n";
      echo "                      </tr>\n";
    }  

    echo "                    </table>\n";
    echo "                  </td>\n";  

	  // prumerna hodnota sily signalu a odezvy	
    $sql = 'SELECT AVG(latency) FROM stats
            WHERE device_id="'.$device_id.'" AND status = "'.$status.'"';

	  // vykonani SQL prikazu
  	$result1 = db_query($link, $sql);
        
  	// nacteni dat z odpovedi
  	list($latency_avg_all) = mysqli_fetch_row($result1);
          				
  	// maximalni sila signalu a cas vyskytu
    $sql = 'SELECT latency, time FROM stats
            WHERE device_id = "'.$device_id.'" AND latency = (SELECT MAX(latency) FROM stats WHERE device_id = "'.$device_id.'" AND status = "'.$status.'")';

  	// vykonani SQL prikazu
  	$result1 = db_query($link, $sql);
        
  	// vykonani SQL prikazu
  	list($latency_max_all,$latency_max_time) = mysqli_fetch_row($result1);           

    // minimalni sila signalu a cas vyskytu        
    $sql = 'SELECT latency, time FROM stats
            WHERE device_id = "'.$device_id.'" AND latency = (SELECT MIN(latency) FROM stats WHERE device_id = "'.$device_id.'" AND status = "'.$status.'")';

  	// vykonani SQL prikazu
  	$result1 = db_query($link, $sql);
  
  	// nacteni dat z odpovedi
  	list($latency_min_all,$latency_min_time) = mysqli_fetch_row($result1);    

    echo "                  <td valign=\"top\">\n";
    echo "                    <table cellspacing=\"2\" cellpadding=\"2\" border=\"1\" width=\"100%\" style=\"border-collapse:collapse;\">\n";
    echo "                      <tr>\n";
    echo "                        <th>Current</th><th>Average</th><th>Minimum</th><th>Maximum</th>\n";
    echo "                      </tr>\n";
    echo "                      <tr align=\"center\">\n";
    if( $status == $act_status )
    {
      echo "                        <td nowrap>".$latency." ms</td>\n";    
    }
    else
    {
      echo "                        <td nowrap>--- ms</td>\n";    
    }
    echo "                        <td nowrap>".intval($latency_avg_all)." ms</td>\n";
    echo "                        <td nowrap>".$latency_min_all." ms</td>\n";
    echo "                        <td nowrap>".$latency_max_all." ms</td>\n";
    echo "                      </tr>\n";        
    echo "                      <tr align=\"center\">\n";
    echo "                        <td colspan=\"2\"></td>\n";
    echo "                        <td nowrap>".date("d.m.Y H:i",strtotime($latency_min_time))."</td>\n";
    echo "                        <td nowrap>".date("d.m.Y H:i",strtotime($latency_max_time))."</td>\n";
    echo "                      </tr>\n";        
    echo "                    </table>\n";
    echo "                  </td>\n";
    echo "                </tr>\n";
  }

  // prazdny radek
  echo "                <tr>\n";
  echo "                  <td>\n";
  echo "                  </td>\n";
  echo "                  <td>\n";
  echo "                  </td>\n";
  echo "                </tr>\n";

  echo "                <tr>\n";          
  echo "                  <td class=\"header\">Tested Packet Loss</td>\n"; 
  echo "                  <td class=\"header\">Router Availability</td>\n";
  echo "                </tr>\n";
  echo "                <tr>\n";
  echo "                  <td valign=\"top\">\n";
  echo "                    <table cellspacing=\"2\" cellpadding=\"2\" border=\"1\" width=\"100%\" style=\"border-collapse: collapse;\">\n";
  echo "                      <tr>\n";
  echo "                        <th colspan=\"2\">Tested Packet Loss</th>\n";
  echo "                      </tr>\n";
  echo "                      <tr>\n";

  $ploss_graphs = array ("ploss_tod", "ploss_yes", "ploss_week", "ploss_cur", "ploss_last");

  for($i = 0;$i < 5;$i++)
  {

		// volani funkce pro zjisteni packet loss
		$sql = 'SELECT sp_GetDevPLoss("'.$device_id.'",' .get_start($i,$sim_id,$device_id) . ',' . get_end($i,$sim_id,$device_id) . ')';

		// vykonani SQL prikazu
		$result = db_multi_query($link, $sql);		
		
		list($packet_loss[$i]) = mysqli_fetch_row($result);
		
		if(mysqli_more_results($link))
		{	//Catch 'OK'/'ERR'
			while(mysqli_next_result($link));
		}

		if(is_null($packet_loss[$i]))
		{
			$packet_loss[$i] = '---';
		}	
		else
		{
			$packet_loss[$i] = round($packet_loss[$i],1);
		}

    echo "                      <tr>\n";
   // echo "                        <td>".$intervals[$i]."<a href=\"javascript:void(0);\" onClick=\"window.open('index.php?page=device_graph_page&graph=".$ploss_graphs[$i]."&device_id=".$device_id."','_blank','height=400,width=845,left=100, top=100,resizable=no,scrollbars=no,');\"><img src=\"img/chart.png\" border=\"0\" align=\"right\"></a><a href=\"javascript:void(0);\" onClick=\"window.open('index.php?page=device_tab_page','_blank','height=400,width=845,left=100, top=100,resizable=no,scrollbars=no,');\"><img src=\"img/tabtext.png\" border=\"0\" align=\"right\"></a></td>\n";
     echo "                        <td>".$intervals[$i]."<a href=\"javascript:void(0);\" onClick=\"window.open('index.php?page=device_graph_page&graph=".$ploss_graphs[$i]."&device_id=".$device_id."','_blank','height=400,width=845,left=100, top=100,resizable=no,scrollbars=no,');\"><img src=\"img/chart.png\" border=\"0\" align=\"right\"></a><a href=\"javascript:void(0);\" onClick=\"window.open('index.php?page=device_tab_page&graph_tab=".$ploss_graphs[$i]."&device_id=".$device_id."&hostname=".$hostname."','_blank','height=400,width=845,left=100, top=100,resizable=no,scrollbars=no,');\"><img src=\"img/tabtext.png\" border=\"0\" align=\"right\"></a></td>\n";
    echo "                        <td align=\"center\">".$packet_loss[$i]." %</td>\n";
    echo "                      </tr>\n";    
  }

  echo "                    </table>\n";
  echo "                  </td>\n";
  echo "                  <td valign=\"top\">\n";
  echo "                    <table cellspacing=\"2\" cellpadding=\"2\" border=\"1\" width=\"100%\" style=\"border-collapse: collapse;\">\n"; 
  echo "                      <tr>\n";
  echo "                        <th colspan=\"2\">Router Availability</th>\n";
  echo "                      </tr>\n";

  $avail_graphs = array ("avail_tod", "avail_yes", "avail_week", "avail_cur", "avail_last");

  for($i = 0;$i < 5;$i++)
  {

    $sql = 'SELECT avg(availability)
            FROM day
            WHERE device_id = "'.$device_id.'"
            AND date BETWEEN ' .get_start_day($i,$sim_id,$device_id). ' AND ' .get_end_day($i,$sim_id,$device_id);

		// vykonani SQL prikazu
		$result = db_query($link, $sql);		
		
		list($availability[$i]) = mysqli_fetch_row($result);

		if(is_null($availability[$i]))
		{
			$availability[$i] = '---';
		}	
		else
		{
			$availability[$i] = round($availability[$i],1);
		}

    echo "                      <tr>\n";
    echo "                        <td>".$intervals[$i]."<a href=\"javascript:void(0);\" onClick=\"window.open('index.php?page=device_graph_page&graph=".$avail_graphs[$i]."&device_id=".$device_id."','_blank','height=400,width=845,left=100, top=100,resizable=no,scrollbars=no,');\"><img src=\"img/chart.png\" border=\"0\" align=\"right\"></a></td>\n";
    echo "                        <td align=\"center\">".$availability[$i]." %</td>\n";
    echo "                      </tr>\n";
  }

  echo "                    </table>\n";
  echo "                  </td>\n";
  echo "                </tr>\n";

  // konec odchyceni stranky
  $page = ob_get_clean();
  echo $page;

  $page = "<h1 align=\"center\">Device Status</h1><table width=\"100%\">".$page."</table>";


  $fd = fopen($temp_path."/temp.html",'w');
  fwrite($fd, $page);
  fclose($fd);
?>
              </table>
            </td>  
          </tr>
