<?php
/***************************************************************************/
/*                                                                         */
/*  FORMULAR PRO PRIDAVANI FIREM  					                               */
/*                                                                         */
/***************************************************************************/

	// pripojeni hlavicky
  include ("php/head.php");
	
	// pripojeni menu
  include ("php/menu.php");
	require_once "config.inc.php";	

  include ("php/js_misc.php");

  js_begin( " 
              function CheckForm()
              {
                if( IsEmpty(document.f.add_name) ){
                  return Error( 'Missing company name.', document.f.add_name );
                }
                if( !IsInRange(document.f.add_devcount, 1, 65535, 0) ){
                  return Error( 'Missing or invalid number of devices.', document.f.add_devcount );
                }
                return true;
              }
    " );

  if(isset( $_GET['company_id']) && is_numeric( $_GET['company_id'] ) )
  {
    $company_id = $_GET['company_id'];
  }
  else
  {
    echo "Invalid company ID";
    exit;
  }

  $link = db_connect();

  $sql = 'SELECT name, devcount, address, email, phone, note
          FROM companies
          WHERE company_id = "'.$company_id.'"';

  $result = db_query($link, $sql);

  list($name, $devcount, $address, $email, $phone, $note) = mysqli_fetch_row( $result );

  $name           = is_null($name) ? "" : $name;
  $address        = is_null($address) ? "" : $address;
  $email          = is_null($email) ? "" : $email;
  $phone          = is_null($phone) ? "" : $phone;
  $note           = is_null($note) ? "" : $note;

  $sql = 'SELECT SUM(devcount)
          FROM companies';

  $result = db_query($link, $sql);

  list($all_devcount) = mysqli_fetch_row( $result );

?>
            <tr>    
              <th  colspan="3">Edit Company</td>  
            </tr>
            <tr>
              <td colspan="3">
                <table width="100%">
                  <tr>
                    <td>
                      <form name="f" action="index.php" method="get">
                      <input type="hidden" name="page" value="company_change">
                      <input type="hidden" name="oper" value="edit">
                      <input type="hidden" name="company_id" value="<?php echo $company_id;?>">
                      <table>
                        <tr>
                        <td width="150px">Name</td><td><input type="text" name="add_name" value="<?php echo $name;?>"></td>
                        </tr>
                        <tr>
                          <td>Address *</td><td><input type="text" name="add_address" value="<?php echo $address;?>"></td>
                        </tr>
                        <tr>
                          <td>Email *</td><td><input type="text" name="add_email" value="<?php echo $email;?>"></td>
                        </tr>
                        <tr> 
                          <td>Phone *</td><td><input type="text" name="add_phone" value="<?php echo $phone;?>"></td>
                        </tr>
                        <tr>
                          <td>Note *</td><td><input type="text" name="add_note" value="<?php echo $note;?>"></td>
                        </tr>
                        <tr>
                        <td>DevCount</td><td><input type="text" name="add_devcount" value="<?php echo $devcount;?>"></td><td><?php echo( $_SESSION['Web.max_station'] == 65535 ? "" : ($_SESSION['Web.max_station'] - $all_devcount)." devices left")?></td>
                        </tr>
                        <tr>
                          <td>* <i>can be blank</i></td><td></td> 
                        </tr>
                        <tr>
                          <td><input type="submit" value="Save"></td><td></td>
                        </tr>
                      </table>
                      </form>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
<?php
  js_end( "
              document.f.onsubmit = CheckForm;
              document.f.add_name.focus();
    " );

	// pripojeni paticky
  include ("php/bottom.php");

?>
