<?php
/***************************************************************************/
/*                                                                         */
/*  FUNKCE PRO UPRAVU SKUPIN  							                               */
/*                                                                         */
/***************************************************************************/

	
  $oper = URI_get_string("oper");
  if( is_null( $oper ) )
  {
    echo('Missing operation !!!');
    exit;  
  }

  header('Refresh: 2; URL = index.php?page=group_list');


  include ("php/head.php");
  include ("php/menu.php");
  require_once "config.inc.php";
  require_once "mysql.php";


?>
            <tr>
              <th colspan="3">Group Change</th>  
            </tr>
            <tr>
	            <td colspan="3">
<?php

	// pripojeni k databazi
	$link = db_connect();

  // rozliseni typu operace
  switch($oper)
  {
    case "add":     // Pridat skupinu
      {

        $add_name = URI_get_string("add_name");
        if( is_null($add_name) )
        {	// chybi name
          echo('You must specify group name !!!');
          exit;
        }

        $level_limit        = URI_get_int("add_level_limit");
        $qual_limit_lo      = URI_get_int("add_qual_limit_lo");
        $traffic_limit      = URI_get_int("add_traffic_limit");
        $traffic_limit_alt  = URI_get_int("add_traffic_limit_alt");        
        $traffic_limit_alt2 = URI_get_int("add_traffic_limit_alt2");
        $temp_limit_lo      = URI_get_int("add_temp_limit_lo");
        $temp_limit_hi      = URI_get_int("add_temp_limit_hi");
        $volt_limit_lo      = URI_get_int("add_volt_limit_lo");
        $volt_limit_hi      = URI_get_int("add_volt_limit_hi");

        $add_group_window = URI_get_int("add_group_window");
        if( is_null($add_group_window) )
        {	// chybi group window
          echo('You must specify group window !!!');
          exit;
        }

        $add_max_fails = URI_get_int("add_max_fails");
        if( is_null($add_max_fails) )
        {	// chybi max fails
          echo('You must specify max fails for avail !!!');
          exit;
        }

        $add_max_fails_msg = URI_get_int("add_max_fails_msg");
        if( is_null($add_max_fails_msg) )
        {	// chybi max fails
          echo('You must specify max fails for msg!!!');
          exit;
        }
        $add_delay_msg = URI_get_int("add_delay_msg");
        if( is_null($add_delay_msg) )
        {	// chybi delay_msg
          echo('You must specify delay for msg!!!');
          exit;
        }
        // prevod na MB
        if( !is_null($traffic_limit) ) $traffic_limit *= 1000000;
        if( !is_null($traffic_limit_alt) ) $traffic_limit_alt *= 1000000;        
        if( !is_null($traffic_limit_alt2) ) $traffic_limit_alt2 *= 1000000;

        // prevod na sekundy        
        $add_group_window = $add_group_window * 60;

        if( is_superadmin() )
        { // vezmeme id z formulare
          $company_id = URI_get_int("company_id");
        }
        else
        {  // vezmeme id ze session
          $company_id = get_company_id();
        }

        $sql = 'INSERT INTO groups ( description, company_id, level_limit, qual_limit_lo, traffic_limit, traffic_limit_alt, traffic_limit_alt2, temp_limit_lo, temp_limit_hi, volt_limit_lo, volt_limit_hi, report_period, max_fails, max_fails_msg, delay_msg )
          VALUES ("'.$add_name.'",
            "'.$company_id.'",
            '.Str4Sql($level_limit).',
            '.Str4Sql($qual_limit_lo).',
            '.Str4Sql($traffic_limit).',
            '.Str4Sql($traffic_limit_alt).',
            '.Str4Sql($traffic_limit_alt2).',
            '.Str4Sql($temp_limit_lo).',
            '.Str4Sql($temp_limit_hi).',
            '.Str4Sql($volt_limit_lo).',
            '.Str4Sql($volt_limit_hi).',
            "'.$add_group_window.'",
            "'.$add_max_fails.'",
            "'.$add_max_fails_msg.'",
            "'.$add_delay_msg.'" )';

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        echo('Group was added succesfully.');
        log_event($company_id,'Group '.$add_name.' was created');

        break;
      }

      case "edit":  // upravit skupinu
      {

        $group_id = URI_get_int("group_id");
        if( is_null($group_id) )
        { // spatne group_id
          echo('Missing or incorrect group id !!!');
          exit;          
        }

        $add_name = URI_get_string("add_name");
        if( is_null( $add_name ) )
        {	// chybi name
          echo('You must specify group name !!!');
          exit;
        }

        $level_limit        = URI_get_int("add_level_limit");
        $qual_limit_lo      = URI_get_int("add_qual_limit_lo");
        $traffic_limit      = URI_get_int("add_traffic_limit");
        $traffic_limit_alt  = URI_get_int("add_traffic_limit_alt");        
        $traffic_limit_alt2 = URI_get_int("add_traffic_limit_alt2");
        $temp_limit_lo      = URI_get_int("add_temp_limit_lo");
        $temp_limit_hi      = URI_get_int("add_temp_limit_hi");
        $volt_limit_lo      = URI_get_int("add_volt_limit_lo");
        $volt_limit_hi      = URI_get_int("add_volt_limit_hi");

        $add_group_window = URI_get_int("add_group_window");
        if( is_null($add_group_window) )
        {	// chybi group window
          echo('You must specify group window !!!');
          exit;
        }

        $add_max_fails = URI_get_int("add_max_fails");
        if( is_null($add_max_fails) )
        {	// chybi max fails
          echo('You must specify max fails for avail !!!');
          exit;
        }

        $add_max_fails_msg = URI_get_int("add_max_fails_msg");
        if( is_null($add_max_fails_msg) )
        {	// chybi max fails
          echo('You must specify max fails for msg!!!');
          exit;
        }
        
        $add_delay_msg = URI_get_int("add_delay_msg");
        if( is_null($add_delay_msg) )
        {	// chybi delay msg
          echo('You must specify delay for msg!!!');
          exit;
        }

        // prevod na MB
        if( !is_null($traffic_limit) ) $traffic_limit *= 1000000;
        if( !is_null($traffic_limit_alt) ) $traffic_limit_alt *= 1000000;        
        if( !is_null($traffic_limit_alt2) ) $traffic_limit_alt2 *= 1000000;        

        // prevod na sekundy
        $add_group_window = $add_group_window * 60;

        $sql = 'SELECT company_id
                FROM groups
                WHERE group_id = "'.$group_id.'"';
				$result = db_query($link, $sql);
        list($company_id) = mysqli_fetch_row( $result );

        $sql = 'UPDATE groups
                SET
                description = "'.$add_name.'",
                level_limit = '.Str4Sql($level_limit).',
                qual_limit_lo = '.Str4Sql($qual_limit_lo).',
                traffic_limit = '.Str4Sql($traffic_limit).',
                traffic_limit_alt = '.Str4Sql($traffic_limit_alt).',
                traffic_limit_alt2 = '.Str4Sql($traffic_limit_alt2).',
                temp_limit_lo = '.Str4Sql($temp_limit_lo).',
                temp_limit_hi = '.Str4Sql($temp_limit_hi).',
                volt_limit_lo = '.Str4Sql($volt_limit_lo).',
                volt_limit_hi = '.Str4Sql($volt_limit_hi).',
                report_period = "'.$add_group_window.'",
                max_fails     = "'.$add_max_fails.'",
                max_fails_msg = "'.$add_max_fails_msg.'",
                delay_msg = "'.$add_delay_msg.'"
                WHERE group_id = "'.$group_id.'"';

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        echo('Group was changed succesfully.');
        log_event($company_id,'Group '.$add_name.' was changed');
        break;  
      }

      case "remove":  // odstranit skupinu
      {

        $group_id = URI_get_int("group_id");

        if( is_null($group_id) )
        { // spatne company_id
          echo('Missing or incorrect group id !!!');
          exit;          
        }

        // zkontrolujeme jestli skupina neobsahuje jeste nejake routry

        $sql = 'SELECT device_id
                FROM devices
                WHERE group_id = "'.$group_id.'"';

				// vykonani SQL prikazu
        $result = db_query($link, $sql);

        if( mysqli_num_rows( $result ) )
        {
          echo( 'This group contains some devices. Remove or move these devices first!!!' );
          exit;
        }

        $sql = 'SELECT description, company_id
                FROM groups
                WHERE group_id = "'.$group_id.'"';
				$result = db_query($link, $sql);
        list($group_name, $company_id) = mysqli_fetch_row( $result );

        // kontrola jestli nahodou nemazeme skupinu kam se pridavaji routry pomoci trapu
        $sql = 'SELECT default_group
                FROM companies
                WHERE company_id = "'.$company_id.'"';
				$result = db_query($link, $sql);
        list($default_group) = mysqli_fetch_row( $result );

        if( $default_group == $group_id )
        { // mazeme skupinu kam se pridavaji routry pomoci trapu, nastrcime jinou skupinu
          $sql = 'SELECT group_id
                  FROM groups
                  WHERE company_id = "'.$company_id.'" ORDER BY group_id LIMIT 1';           

  				$result = db_query($link, $sql);
          list($default_group) = mysqli_fetch_row( $result );

          if( !is_null( $default_group ) )
          { // nasli jsme nejakou jinou skupinu ze stejne firmy
            $sql = 'UPDATE companies
                    SET default_group = "'.$default_group.'"
                    WHERE company_id = "'.$company_id.'"';
    				$result = db_query($link, $sql);
          }
          else
          { // nenasli jsme zadnou volnou skupinu
            $sql = 'UPDATE companies
                    SET addtrap_en = 0
                    WHERE company_id = "'.$company_id.'"';
    				$result = db_query($link, $sql);          
          }
        }

        $sql = 'DELETE FROM groups
                WHERE group_id = "'.$group_id.'"';
                
				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        echo('Group was removed succesfully.');
        log_event($company_id,'Group '.$group_name.' was removed');
        break;  
      }

    default:{   // neznama akce
      echo('Group Change Error: Unknow operation');
      break;
    }      
        
  }

?>
	            </td>
            </tr>
<?php
	// pripojeni paticky
  include ("php/bottom.php");

?>
