<?php

/***************************************************************************/
/*                                                                         */
/*  HLAVICKA STRANKY      									                               */
/*                                                                         */
/***************************************************************************/

require_once "config.inc.php";

  if( is_superadmin() && isset( $_GET['company_id'] ) )
  {
    set_company_id( $_GET['company_id'] );
  }

	// seznam povolenych stranek
  $refreshlist = array( "device_list","device_status");



	if(isset($_GET['page']))
	{
		$page = $_GET['page'];	
	}
	else
	{
		$page = "device_list";	
	}

  switch( !isset($cfg['color_scheme']) ? "default" : $cfg['color_scheme'])
  {
    case "green":
      $scheme_file="style_green.css";
      $scheme_cal_file="calendar_green.css";
      break;
    case "blue":
      $scheme_file="style_blue.css";
      $scheme_cal_file="calendar_blue.css";
      break;
    case "default":
    default:
     // $scheme_file="style.css";
     // $scheme_cal_file="calendar.css";
      $scheme_file="style_blue.css";
      $scheme_cal_file="calendar_blue.css";
  }

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/plain; charset=utf-8" />
    <meta name="description" content="TODO - info" />
    <meta http-equiv="pragma" content="no-cache">
    <meta http-equiv="cache-control" content="no-cache">
<?php

  if( is_guest() )
  {
    if( ($cfg['refresh_period'] == 0) && ($cfg['autologout'] == 1))
    { // automaticky refresh vypnuty => refreshneme stranku aby se automaticky objevil prihlasovaci dialog jakmile vyprsi timeout( nyni 15 minut )
      echo( '    <meta http-equiv="refresh" content="960">' );  // 16 minut
    }
    else
    {
      unset( $_SESSION['timeout'] ); // zrusime tuto promennou, cimz vyradime automaticke odhlaseni - bude se pouze automaticky refreshovat  
    }
  
    if(in_array($page,$refreshlist))
    {	// zadana stranka povolena, povolit autorefresh
      if( $cfg['refresh_period'] != 0)
      {
			  echo( '    <meta http-equiv="refresh" content="'.$cfg['refresh_period'].'">' );    
      }
    }
  }
?>	
    <title>R-SeeNet v<?php echo(VERSION);?></title>
    <link rel='stylesheet' href='css/<?php echo $scheme_file;?>' type='text/css' />
    <link rel='stylesheet' href='css/<?php echo $scheme_cal_file;?>' type='text/css' />
    <link rel='stylesheet' href='css/wait_indicator.css' type='text/css' />
    <script src="js/misc.js" type="text/javascript"></script>
    <script src="js/wait_indicator.js" type="text/javascript"></script>
  </head>
  <body onload="ind_off()">
    <div class="wait_dialog" id="wait_table" style="visibility: visible">
    </div>
    <table align="center" width="800px" cellspacing="0" cellpadding="0">
