<?php

/***************************************************************************/
/*                                                                         */
/*  POMOCNE JS FUNKCE         	  					                               */
/*                                                                         */
/***************************************************************************/

function js_begin( $js )
{
  echo "            <script type=\"text/javascript\">\n";
  echo "            <!--\n";

  if( strstr( $js, "Error" ) )
  {
    echo "              function Error(msg, obj)\n";
    echo "              {\n";
    echo "                alert( msg ); obj.focus(); obj.select(); return false;\n";
    echo "              }\n";  
    echo "              function GetValue( obj )\n";
    echo "              {\n";
    echo "                return obj.value.replace(/\s/g, '');\n";
    echo "              }\n";
  }

  if( strstr( $js, "IsEmpty" ) )
  {
    echo "              function IsEmpty( obj )\n";
    echo "              {\n";
    echo "                return GetValue( obj ).length == 0;\n";
    echo "              }\n";
  }

  if( strstr( $js, "IsInRange" ) )
  {
    echo "              function IsInRange( obj, low, high, empty )\n";
    echo "              {\n";
    echo "                var str = GetValue( obj );\n";
    echo "                if( empty && str.length == 0 ) return true;\n";
    echo "                return ( parseInt(str) >= low ) && ( parseInt(str) <= high );\n";
    echo "              }\n";
  }

  if( strstr( $js, "GetScrollY" ) )
  {
    echo "              function GetScrollY() {\n";
    echo "                var scrOfY = 0;\n";
    echo "                if( typeof( window.pageYOffset ) == 'number' ) {\n";
    echo "                  scrOfY = window.pageYOffset;\n";
    echo "                } else if( document.body && ( document.body.scrollTop ) ) {\n";
    echo "                  scrOfY = document.body.scrollTop;\n";
    echo "                } else if( document.documentElement && ( document.documentElement.scrollTop ) ) {\n";
    echo "                  scrOfY = document.documentElement.scrollTop;\n";
    echo "                }\n";
    echo "                return scrOfY;\n";
    echo "              }\n";
  }

  if( strstr( $js, "GetPos" ) )
  {
    echo "              function GetPos(el) {\n";
    echo "                for (var dy=0;\n";
    echo "                  el != null;\n";
    echo "                  dy += el.offsetTop, el = el.offsetParent);\n";
    echo "                return dy;\n";
    echo "              }\n";
  }

  if( strstr( $js, "IsValidHostname" ) )
  {
    echo "              function IsValidHostname( obj )\n";
    echo "              {\n";
    echo "                var reg_ip = \"^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$\";\n";
    echo "                var reg_hostname = \"^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])$\";\n";
    echo "                var hostname = GetValue( obj );\n";
    echo "                if( hostname.match( reg_ip ) ){\n";
    echo "                  return 1;\n";
    echo "                }\n";
    echo "                if( hostname.match( reg_hostname ) ){\n";
    echo "                  return 1;\n";
    echo "                }\n";
    echo "                return 0;\n";
    echo "              }\n";
  }

  echo $js;

  echo "            -->\n";
  echo "            </script>\n";

}

function js_end( $js )
{
  echo "            <script type=\"text/javascript\">\n";
  echo "            <!--\n";
  echo $js;
  echo "            -->\n";
  echo "            </script>\n";
}
?>
