<?php

/***************************************************************************/
/*                                                                         */
/*  SCRIPT PRO ULOZENI NASTAVENI	   				                               */
/*                                                                         */
/***************************************************************************/


  if (isset($_SESSION['last']))
  {	// nacteni predchozi stranky
    header('Refresh: 3; URL = '.urldecode($_SESSION['last']));
  }
  else
  {	// nacteni uvodni stranky
    header('Refresh: 3; URL = index.php');  
  }

  include ("php/head.php");
  include ("php/menu.php");	
	require_once "php/misc.php";	

?>
            <tr>    
              <th colspan="3">Options Change</th>  
            </tr>
            <tr>
              <td colspan="3">
<?php

  // zjisteni typu formulare
  $options = URI_get_string("sub_opt");
  if( is_null( $options ) )
  {
    echo('Error: Unknown source form!!!');
    exit;
  }  

  switch($options)
  {
    case "general_opt":
    { // general settings


      $timezone = URI_get_string("timezone");
      if( is_null( $timezone ) )
      { // hodnota neni cislo => chyba
        echo( "Invalid timezone." );
        exit;
      }
      if( $cfg['timezone'] != $timezone )
      {
        user_cfg_write( get_user_id(), "timezone", $timezone);      
      }



      $ping_count = URI_get_int("ping_count");
      if( is_null( $ping_count ) )
      { // hodnota neni cislo => chyba
        echo( "Invalid ping count." );
        exit;
      }
      if( $cfg['ping_count'] != $ping_count )
      {
        user_cfg_write( get_user_id(), "ping_count", $ping_count);      
      }

      // pripojeni k DB
      $link = db_connect();
      
      $autologout = is_null( URI_get_int("autologout") ) ? 0 : 1;

      $sql = 'UPDATE companies
              SET autologout = "'.$autologout.'"
              WHERE company_id = (SELECT company_id FROM users WHERE user_id = "'.get_user_id().'")';

      // vykonani SQL prikazu
      $result = db_query($link, $sql);

      if( !is_null(URI_get_int("nologin")) )
      {
        if( !isset($cfg["nologin"]) )
        {
          $sql = 'INSERT INTO users
                  SET username = "default",
                  password = PASSWORD("conel"),
                  rights = 2,
                  company_id = "'.get_company_id().'"';

          // vykonani SQL prikazu
          $result = db_query($link, $sql);          

          $sql = 'SELECT LAST_INSERT_ID()';

          // vykonani SQL prikazu
          $result = db_query($link, $sql);          
          list( $user_id ) = mysqli_fetch_row( $result );

          $sql = 'SELECT group_id
                  FROM groups';

          // vykonani SQL prikazu
          $result = db_query($link, $sql);          

          while( list( $group_id ) = mysqli_fetch_row( $result ) )
          {

              $sql = 'INSERT INTO user_group SET
                user_id = "'.$user_id.'",       
                group_id = "'.$group_id.'"';

      				// vykonani SQL prikazu
  		    		$result1 = db_query($link, $sql);
          }
        }
      } 
      else
      {
        $sql = 'SELECT user_id FROM users
                WHERE username = "default"';

        // vykonani SQL prikazu
        $result = db_query($link, $sql);
        list( $user_id ) = mysqli_fetch_row( $result );


        $sql = 'DELETE FROM users
                WHERE username = "default"';

        // vykonani SQL prikazu
        $result = db_query($link, $sql);                

        $sql = 'DELETE FROM user_group
                WHERE user_id = "'.$user_id.'"';

        // vykonani SQL prikazu
        $result = db_query($link, $sql);        

      }


      $refresh_period = URI_get_int("refresh_period");
      if( is_null( $refresh_period ) )
      { // hodnota neni cislo => chyba
        echo( "Invalid refresh period." );
        exit;
      }
      if( $cfg['refresh_period'] != $refresh_period )
      {
        user_cfg_write( get_user_id(), "refresh_period", $refresh_period);      
      }

      echo('General settings saved.');
      log_event(get_company_id(),'General settings were changed.');
      break;
    }

    case "own_logo_opt":
    { // own logo
      if( is_admin() )
      switch( URI_get_string("logo_oper") )
      {
        case "Add":
				    if($_FILES["file"]['error'] > 0)
				    {	// chyba pri prenosu
					    echo('Error: '.$_FILES["file"]['error']);
					    exit;
				    }
				
    				if(!is_file($_FILES['import_file']['tmp_name']))
    				{	// neni zadan soubor
    					echo('File not specified.');
    					exit;
    				}

    				if(!(strstr($_FILES['import_file']['name'], '.png') || strstr($_FILES['import_file']['name'], '.PNG')))
    				{	// neni png soubor
    					echo('Bad file type!!! PNG image file is expected.');
    					exit;
    				}					
            $local_file = $_FILES['import_file']['tmp_name'];

            // pripojeni k DB
            $link = db_connect();

            $f = fopen($local_file, 'rb'); 

            $data = fread($f, filesize( $local_file ));

            $sql = 'UPDATE companies SET logo = "'.mysql_escape_string( $data ).'" WHERE company_id = '.get_company_id();

            // vykonani SQL prikazu
            $result = db_query($link, $sql);

            if (!$result) {
              echo "Failed to install logo...\n";
            }
        
            echo "Logo installed succesfully";
            log_event(get_company_id(),'Logo '.$_FILES['import_file']['name'].' was installed');            

          break;

        case "Delete":
          // pripojeni k DB
          $link = db_connect();	

          // kontrola pritomnosti souboru
          $sql = 'UPDATE companies SET logo = NULL WHERE company_id = '.get_company_id();

          // vykonani SQL prikazu
          $result = db_query($link, $sql);

          log_event(get_company_id(),'Logo was removed');            
          echo "Logo succesfully removed";
          break;

        default:
          echo "Error: Unknown operation!!!";
          break;
      }
      break;
    }
    
    case "appearance_opt":
    { // appearance settings

      $col_list = URI_get_string("col_list");
      if( !is_null($col_list) )
      if( $cfg['device_list_cols'] != $col_list )
      { // refresh_period se zmenil => ulozit
        user_cfg_write( get_user_id(), "device_list_cols", $col_list);
      }

      $color_scheme = URI_get_string("color_scheme");
      if( !is_null($color_scheme) )
      if( $cfg['color_scheme'] != $color_scheme )
      { // refresh_period se zmenil => ulozit
        user_cfg_write( get_user_id(), "color_scheme", $color_scheme);
      }

      $link_target = URI_get_string("user_link_target");
      if( $cfg['user_link_target'] != $link_target )
      { // user_link_target se zmenil => ulozit
        user_cfg_write( get_user_id(), "user_link_target", $link_target);
      }

      $link_text = URI_get_string("user_link_text");
      if( $cfg['user_link_text'] != $link_text )
      { // user_link_target se zmenil => ulozit
        user_cfg_write( get_user_id(), "user_link_text", $link_text);
      }

      echo('Appearance settings saved.');
      log_event(get_company_id(),'Appearance settings were changed');                  

      break;      
    }
  
    case "snmp_opt":
    { // snmp settings

      $default_community = URI_get_string("default_community");
      if( !is_null($default_community) )
      if( $cfg['default_community'] != $default_community )
      { // refresh_period se zmenil => ulozit
        user_cfg_write( get_user_id(), "default_community", $default_community);
      }

    	// pripojeni k DB
      $link = db_connect();      

      $sql = 'SELECT *
              FROM companies';

    	// vykonani SQL prikazu
      $result = db_query($link, $sql);

      if( mysqli_num_rows($result) == 1 )
      { // mame pouze jednu firmu, takze nas zajimaji i nasledujici parametry

      $default_group = URI_get_int("default_group");
      $addtrap_en = URI_get_bool("addtrap_en");

      $sql = 'UPDATE companies 
          SET
          default_group = "'.$default_group.'",
          addtrap_en = "'.$addtrap_en.'"
          WHERE company_id = "'.get_company_id().'"';

    	// vykonani SQL prikazu
      $result = db_query($link, $sql);

      }

      echo('Snmp settings saved.');
      log_event(get_company_id(),'SNMP settings were changed');      

      break;      
    }  

    case "email_sms_opt":
    { // sms gateway settings

      $sms_hostname   = URI_get_string("sms_hostname");
      $sms_port       = URI_get_int("sms_port");
      $sms_limit      = URI_get_int("sms_limit");
      $smtp_hostname  = URI_get_string("smtp_hostname");
      $smtp_port      = URI_get_int("smtp_port");
      $smtp_from      = URI_get_string("smtp_from");
      $smtp_sub       = URI_get_string("smtp_sub");
      $smtp_user      = URI_get_string("smtp_user");      
      $smtp_psw       = URI_get_string("smtp_psw");      
      $email_limit    = URI_get_int("email_limit");
      $time_send      = URI_get_string("time_send");

    	// pripojeni k DB
      $link = db_connect();      

      $sql = 'UPDATE companies 
          SET
          sms_hostname = '.Str4Sql($sms_hostname).',
          sms_port = '.Str4Sql($sms_port).',
          sms_limit = "'.$sms_limit.'",
          smtp_hostname = '.Str4Sql($smtp_hostname).',
          smtp_port = '.Str4Sql($smtp_port).',
          smtp_from = '.Str4Sql($smtp_from).',
          smtp_sub = '.Str4Sql($smtp_sub).',
          smtp_user = '.Str4Sql($smtp_user).',
          time_send = '.Str4Sql($time_send).',
          email_limit = "'.$email_limit.'"';

          if( !is_null($smtp_psw) )
          { // je nastaveno heslo, budeme jej menit
            $sql = $sql.',smtp_psw = "'.$smtp_psw.'"';
          }

          $sql = $sql.' WHERE company_id = "'.get_company_id().'"';

    	// vykonani SQL prikazu
      $result = db_query($link, $sql);

      echo('Email & Sms settings saved.');
      log_event(get_company_id(),'Email & SMS settings were changed');

      break;      
    }

    case "warnings_opt":
    { // warning settings

      $msg_status_off = URI_get_string("msg_status_off");
      $msg_status_on  = URI_get_string("msg_status_on");
      $msg_traffic    = URI_get_string("msg_traffic");
      $msg_level      = URI_get_string("msg_level");
      $msg_qual_lo    = URI_get_string("msg_qual_lo");
      $msg_temp_lo    = URI_get_string("msg_temp_lo");
      $msg_temp_hi    = URI_get_string("msg_temp_hi");
      $msg_volt_lo    = URI_get_string("msg_volt_lo");
      $msg_volt_hi    = URI_get_string("msg_volt_hi");
      $msg_trap_poll  = URI_get_string("msg_trap_poll");

    	// pripojeni k DB
      $link = db_connect();      

      $sql = 'UPDATE companies 
          SET
          warning_enabled = "'.URI_get_bool("warning_enabled").'",
          ident_descr = "'.URI_get_bool("ident_descr").'", 
          ident_location = "'.URI_get_bool("ident_location").'",  
          ident_ip = "'.URI_get_bool("ident_ip").'",  
          ident_mac = "'.URI_get_bool("ident_mac").'",  
          msg_status_off = '.Str4Sql($msg_status_off).',
          msg_status_on = '.Str4Sql($msg_status_on).',
          msg_traffic = '.Str4Sql($msg_traffic).',
          msg_level = '.Str4Sql($msg_level).',
          msg_qual_lo = '.Str4Sql($msg_qual_lo).',
          msg_temp_lo = '.Str4Sql($msg_temp_lo).',
          msg_temp_hi = '.Str4Sql($msg_temp_hi).',
          msg_volt_lo = '.Str4Sql($msg_volt_lo).',
          msg_volt_hi = '.Str4Sql($msg_volt_hi).',
          msg_trap_poll = '.Str4Sql($msg_trap_poll).'
          WHERE company_id = "'.get_company_id().'"';

    	// vykonani SQL prikazu
      $result = db_query($link, $sql);

      echo('Warnings settings saved.');
      log_event(get_company_id(),'Warnings settings were changed');      

      break;      
    }

    case "report_opt":
    { // report settings

      $daily_report_from = URI_get_int("daily_report_from");
      if( is_null( $daily_report_from ) )
      { // hodnota neni cislo => chyba
        echo( "Invalid from hour." );
        exit;
      }
      if( $cfg['daily_report_from'] != $daily_report_from )
      {
        user_cfg_write( get_user_id(), "daily_report_from", $daily_report_from);      
      }

      $daily_report_to = URI_get_int("daily_report_to");
      if( is_null( $daily_report_to ) )
      { // hodnota neni cislo => chyba
        echo( "Invalid to hour." );
        exit;
      }
      if( $cfg['daily_report_to'] != $daily_report_to )
      {
        user_cfg_write( get_user_id(), "daily_report_to", $daily_report_to);      
      }

      if( $cfg['report_list_cols'] != $_GET['col_list'] )
      { // refresh_period se zmenil => ulozit
        user_cfg_write( get_user_id(), "report_list_cols", $_GET['col_list']);
      }

      echo('Report settings saved.');
      log_event(get_company_id(),'Report settings were changed');

      break;      
    }    
  }

  $_SESSION['params_ok'] = 0;
  
?>		
              </td>
            </tr>	
<?php
	// pripojeni paticky
  include ("php/bottom.php");

?>
