<?php

/***************************************************************************/
/*                                                                         */
/*  SCRIPT PRO PROVEDENI PINGU	  					                               */
/*                                                                         */
/***************************************************************************/

  include 'php/netping.php';


  if(isset($_GET['hostname']) && ($_GET['hostname'] != ''))
  {  // hostname zadano
     $hostname = $_GET['hostname'];
  }	


if(!filter_var($hostname, FILTER_VALIDATE_IP))
{
    // neplatne hostname
          echo "invalid arguments";
          exit;
} 

// hostname je ok muzeme jit dal

  switch($cfg['color_scheme'])
  {
    case "green":
      $scheme_file="style_green.css";
      break;
    case "blue":
      $scheme_file="style_blue.css";
      break;
    case "default":
    default:
      $scheme_file="style.css";
  }

	
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <meta name="description" content="TODO - info">
    <meta http-equiv="pragma" content="no-cache">
    <meta http-equiv="cache-control" content="no-cache">    
    <title>Ping <?php echo($hostname)?></title>
    <link rel='stylesheet' href='css/<?php echo $scheme_file; ?>' type='text/css'>
    <link rel='stylesheet' href='css/wait_indicator.css' type='text/css'>
    <script src="js/wait_indicator.js" type="text/javascript"></script>    
  </head>
  <body onload="ind_off()" class="new_window">
  <!-- dialog -->
    <div class="wait_dialog" id="wait_table" style="visibility: visible">
    </div>
  
    <table width="530px">
      <tr>
        <th>Ping</th>
      </tr>
      <tr>
        <td>
          <table width="100%">
<?php
  flush();

  if(getenv("OS")=="Windows_NT")
  { // jedeme na windows

    $ping=new Net_Ping();

    $echo_sum = 0;
    $echo_count = 0;
    $echo_min = 1000000;
    $echo_max = 0;

    for($i = 0;$i < $cfg['ping_count'];$i++)
    {
      echo "            <tr>\n";
      echo "              <td nowrap width=\"1%\">Reply from ".$hostname.":</td>\n";
      $ping->Ping($hostname);
      if ($ping->time)
      {
        echo "              <td>time ".($ping->time * 1000)." ms</td>\n";
        $echo_sum += $ping->time * 1000;
        $echo_count++;
        if($ping->time > $echo_max)
        {
          $echo_max = $ping->time;
        }    
        if($ping->time < $echo_min)
        {
          $echo_min = $ping->time;
        }      
      }
      else
      {
        $echos[$i] = NULL;
        echo "              <td>".$ping->errstr."</td>\n";          
      }     
      echo "            </tr>\n"; 
      flush();
      if( $i < ( $cfg['ping_count'] - 1 ) )
      { // jeste bude dalsi cykl, sekundu pockame
        sleep( 1 );   
      }
    }

    echo "            <tr>\n";
    echo "            </tr>\n";    

    echo "            <tr>\n";
    echo "              <td colspan=\"2\">Packets: Sent = ".$cfg['ping_count'].", Received = ".$echo_count.", Lost = ".($cfg['ping_count'] - $echo_count)." (".round(($cfg['ping_count'] - $echo_count)/$cfg['ping_count'] * 100)."% lost)</td>\n";  
    echo "            </tr>\n";    

    if($echo_count)
    {
      echo "            <tr>\n";
      echo "              <td colspan=\"2\">Minimum = ".($echo_min * 1000)." ms, Maximum = ".($echo_max * 1000)." ms, Average = ".round($echo_sum/$echo_count)." ms</td>\n";  
      echo "            </tr>\n";  
    }
  }
  else
  { // jedeme na linuxu, kvuli bezpecnostnim pravidlum jsme odkazani na program ping
    echo "            <tr>\n";
    echo "              <td>\n";
    echo "                <pre>\n";
    $content = '';
    $fd = popen("ping -c ".$cfg['ping_count']." -s 64 -t 64 ".$hostname,"r");
    if(!$fd)
    {
      $content = 'Ping not available.';
    }
    else
    {
      while(!feof($fd)) {
        $content = $content.fread($fd, 1024);
      }
      pclose($fd);
    }
    echo($content);
    echo "                </pre>\n";
    echo "              </td>\n";    
    echo "            </tr>\n";
  }
?>
          </table>      
        </td>
      </tr>
    </table>
  </body>
</html>
