<?php

/***************************************************************************/
/*                                                                         */
/*  STRANKA REPORTU													                               */
/*                                                                         */
/***************************************************************************/

  
  require_once "config.inc.php";
  require_once "php/mysql.php"; 
	require_once "php/misc.php";  

  include "php/report_columns.php";

  $header = Array();

  foreach($report_list_selected as $id => $par_name)
  {
    $header[$id] = "<th>".$report_list_cols[$par_name]."</th>\n";
  }

	// pripojeni k DB
  $link = db_connect(); 

  $data_src = URI_get_string("data_src");
  $sub_opt = URI_get_string("sub_opt");

  $group_id = URI_get_int("group_id");

  $latency_limit = URI_get_int("latency_limit");
  $ploss_limit = URI_get_int("ploss_limit");
  $avail_limit = URI_get_int("avail_limit");
  $signal_limit = URI_get_int("signal_strength_limit");

  $from = URI_get_int("from");
  $to = URI_get_int("to");

  echo "                      <table width=\"100%\">\n";
  echo "                        <tr align=\"center\">\n";
  echo "                          <td align=\"center\"><b>From: </b>".date("d-m-Y H:i",$from)." <b>To: </b>".date("d-m-Y H:i",$to)."</td>\n";
  echo "                        </tr>\n";

  $temp_path = "temp/".substr(session_id(),0,8);
  
  if(!is_dir($temp_path))
  {
    umask(0000); // nulovani masky prav
    mkdir($temp_path,0777);
  }  

  if( $sub_opt == "all" || $sub_opt == "latency" )
  {
    include "php/report_latency.php";
  }

  if( $sub_opt == "all" || $sub_opt == "ploss" )
  {
    include "php/report_ploss.php";
  }  

  if( $sub_opt == "all" || $sub_opt == "avail" )
  {
    include "php/report_avail.php";
  }

  if( $sub_opt == "all" || $sub_opt == "signal" )
  {
    include "php/report_signal.php";
  }

  echo "                      </table>\n";
	
?>


