<?php

  echo "                        <tr align=\"left\">\n";
  echo "                          <td nowrap class=\"header\">Daily Report</td>\n";
  echo "                        </tr>\n";
  echo "                        <tr align=\"center\">\n";
  echo "                          <td align=\"center\">\n";
  echo "                            <table>\n";

  /********************************** Online Routers ***********************************/

  echo "                              <tr>\n";
  echo "                                <td>Online network access routers:</td>\n";

  if( $data_src != "host" )
  {
    switch( $data_src )
    {
      case "all":

        $sql = 'SELECT SUM(device_working)
                FROM summary            
                WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")
                AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
                GROUP BY time';

        $result = db_query($link, $sql);
      
        $device_working = array();

        $i = mysqli_num_rows( $result );

        for($j = 0;$j < $i;$j++)
        {
          list($device_working[]) = mysqli_fetch_row($result);      
        }

        $min_count = count($device_working)>0 ? min($device_working) : 0;
        $max_count = count($device_working)>0 ? max($device_working) : 0;

        break;

      case "group":
        $sql = 'SELECT MIN(device_working),MAX(device_working)
                FROM summary
                WHERE group_id = "'.$group_id.'"
                AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';
        $result = db_query($link, $sql);				
        list($min_count, $max_count) = mysqli_fetch_row($result);

        break;
    }


    if( $min_count != $max_count )
    {
      echo "                                <td>min: ".$min_count.", max: ".$max_count."</td>\n";
    }
    else
    {
      echo "                                <td>".$min_count."</td>\n";  
    }
  }

  echo "                              </tr>\n";

  /********************************** Availability ***********************************/

  echo "                              <tr>\n";
  echo "                                <td>Average availability over period</td>\n";

  switch( $data_src )
  {
    case "all":

      $sql = 'SELECT AVG(availability)
              FROM summary
              WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';

      break;

    case "group":
      $sql = 'SELECT AVG(availability)
              FROM summary
              WHERE group_id = "'.$group_id.'"
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';

      break;          
    
    default:

      $sql = 'SELECT AVG(availability)
              FROM stats
              WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';
  
  }

  $result = db_query($link, $sql);				
  list($avail) = mysqli_fetch_row($result);

  echo "                                <td>".round($avail,1)." %</td>\n";
  echo "                              </tr>\n";  

  /********************************** Latency ***********************************/

  echo "                              <tr>\n";
  echo "                                <td>Average Latency over period</td>\n";

  switch( $data_src )
  {
    case "all":

      $sql = 'SELECT AVG(average_latency)
              FROM summary
              WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';

      break;

    case "group":
      $sql = 'SELECT AVG(average_latency)
              FROM summary
              WHERE group_id = "'.$group_id.'"
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';

      break;          
    
    default:

      $sql = 'SELECT AVG(latency)
              FROM stats
              WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';
  
  }

  $result = db_query($link, $sql);				
  list($latency) = mysqli_fetch_row($result);

  echo "                                <td>".round($latency,1)." ms</td>\n";
  echo "                              </tr>\n";

  /********************************** Packet Loss ***********************************/

  echo "                              <tr>\n";
  echo "                                <td>Average packet loss over period</td>\n";

  switch( $data_src )
  {
    case "all":

      $sql = 'SELECT AVG(packetloss)
              FROM summary
              WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';

      break;

    case "group":
      $sql = 'SELECT AVG(packetloss)
              FROM summary
              WHERE group_id = "'.$group_id.'"
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';

      break;          
    
    default:

      $sql = 'SELECT AVG(packetloss)
              FROM day
              WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
              AND date BETWEEN "'.date("Y-m-d", $from).'" AND "'.date("Y-m-d", $to).'"';
  
  }

  $result = db_query($link, $sql);				
  list($ploss) = mysqli_fetch_row($result);

  echo "                                <td>".round($ploss,1)." %</td>\n";
  echo "                              </tr>\n";

  echo "                            </table>\n";  
  echo "                          </td>\n";
  echo "                        </tr>\n";      



  $filename = $temp_path."/ronline.png";
  include "php/report_graph_ronline.php";

  echo "                        <tr align=\"center\">\n";
  echo "                          <td><img src=\"".$filename."\" class=\"graph\"></td>\n";
  echo "                        </tr>\n";

  $filename = $temp_path."/avail.png";
  include "php/report_graph_avail.php";

  echo "                        <tr align=\"center\">\n";
  echo "                          <td><img src=\"".$filename."\" class=\"graph\"></td>\n";
  echo "                        </tr>\n";

  $filename = $temp_path."/latency.png";
  include "php/report_graph_latency.php";

  echo "                        <tr align=\"center\">\n";
  echo "                          <td><img src=\"".$filename."\" class=\"graph\"></td>\n";
  echo "                        </tr>\n";

  $filename = $temp_path."/ploss.png";
  include "php/report_graph_ploss.php";

  echo "                        <tr align=\"center\">\n";
  echo "                          <td><img src=\"".$filename."\" class=\"graph\"></td>\n";
  echo "                        </tr>\n";

?>
