<?php

  // graf Routers online    

  $x_data = array();
  $y_data = array();	

  
	$title = 'Routers Online';
	$YAxisName = '';
	$YAxisUnit = '';

  switch( $data_src )
  {
    case "all":

      $sql = 'SELECT DATE_FORMAT(time,"%Y-%m-%d %H:%i"), SUM(device_working)
              FROM summary            
              WHERE group_id IN (SELECT group_id FROM groups WHERE company_id = "'.get_company_id().'")
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
              GROUP BY time';

      break;

    case "group":
      $sql = 'SELECT DATE_FORMAT(time,"%Y-%m-%d %H:%i"), device_working
              FROM summary            
              WHERE group_id = "'.$group_id.'"
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"
              GROUP BY time';
        
      break;          
    default:
      $sql = 'CREATE TEMPORARY TABLE stats_fails
              (
                `time` datetime,
                `online` INT(1))
              ENGINE = MEMORY';
      $result = db_query($link, $sql);
      $sql = 'INSERT INTO stats_fails (time, online) 
              SELECT time, "1" FROM stats
              WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';
      $result = db_query($link, $sql);
      $sql = 'INSERT INTO stats_fails (time, online) 
              SELECT time, "0" FROM fails
              WHERE device_id = (SELECT device_id FROM devices WHERE hostname = "'.$host.'" OR hostname_alt = "'.$host.'" LIMIT 1)
              AND time BETWEEN "'.date("Y-m-d H:i", $from).'" AND "'.date("Y-m-d H:i", $to).'"';
      $result = db_query($link, $sql);
      $sql = 'SELECT time,online FROM stats_fails ORDER BY time';
  }

  $result = db_query($link, $sql);
   
  $i_max = mysqli_num_rows($result);
	
  for($i = 0;$i < $i_max;$i++)
  {
    list($x_data[$i], $y_data[$i]) = mysqli_fetch_row($result);
    $x_data[$i] = strtotime($x_data[$i]);
  }      
	
	$y_bottom = 0;
  $y_top = count($y_data)>0 ? ceil(max($y_data)/20) * 20 : 0;

  include "php/report_graph.php";

?>
