<?php

/***************************************************************************/
/*                                                                         */
/*  SSH APPLET                                             	  					   */
/*                                                                         */
/***************************************************************************/

  if(isset($_GET['hostname']) && ($_GET['hostname'] != ''))
  {  // hostname zadano
     $hostname = $_GET['hostname'];
  }	


  if(!filter_var($hostname, FILTER_VALIDATE_IP))
  {
    // neplatne hostname
          echo "invalid arguments";
          exit;
  } 

  // hostname je ok muzeme jit dal

  if(isset($_GET['color_scheme']))
  {
     $color_scheme = $_GET['color_scheme'];
  }	
  else
  {
     $color_scheme = "default";  
  }

  switch($color_scheme)
  {
    case "blue":
      $scheme_file="style_blue.css";
      break;
    case "default":
    default:
      $scheme_file="style.css";
  }

	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <meta name="description" content="TODO - info">
    <meta http-equiv="pragma" content="no-cache">
    <meta http-equiv="cache-control" content="no-cache">    
    <title>SSH Session <?php echo($hostname)?></title>
    <link rel='stylesheet' href='../css/<?php echo $scheme_file; ?>' type='text/css'>
    <link rel='stylesheet' href='../css/wait_indicator.css' type='text/css'>
    <script src="../js/wait_indicator.js" type="text/javascript"></script>
  </head>
  <body onload="ind_off();" class="new_window">
  <!-- dialog -->
    <div class="wait_dialog" id="wait_table" style="visibility: visible">
    </div>
  
    <table align="center">
      <tr>
        <th>SSH Session</th>
      </tr>
      <tr>
        <td>
          <applet codebase="../jar/"
            code="com.jcraft.jcterm.JCTermApplet.class"
            archive="jcterm-0.0.10.jar,jsch-0.1.46.jar"
            width="1024" height="768">
            <param name="jcterm.font_size"  value="12">
            <param name="jcterm.destinations"  value="root@<?php echo $hostname?>">
            <param name="jcterm.fg_bg" value="#FFFFFF:#000000">
          </applet>
        </td>
      </tr>
    </table>
  </body>
</html>
