<?php
/***************************************************************************/
/*                                                                         */
/*  FUNKCE PRO UPRAVU UZIVATELE							                               */
/*                                                                         */
/***************************************************************************/


  $oper = URI_get_string("oper");
  if( is_null( $oper ) )
  {
    echo('Missing operation !!!');
    exit;  
  }

  header('Refresh: 2; URL = index.php?page=user_list');  

  include ("php/head.php");
  include ("php/menu.php");
  require_once "config.inc.php";
  require_once "mysql.php";


?>
            <tr>
              <th colspan="3">User Change</th>  
            </tr>
            <tr>
	            <td colspan="3">
<?php

	// pripojeni k databazi
	$link = db_connect();

  // rozliseni typu operace
  switch($oper)
  {
    case "add":     // Pridat uzivatele
      {

        $add_username = URI_get_string("add_username");
        if( is_null($add_username) )
        {	// chybi username
          echo('You must specify user name !!!');
          exit;
        }

        if( $add_username == "default" )
        {	// chybi username
          echo('You cannot create user "default" !!!');
          exit;
        }

        $add_name = URI_get_string("add_name");
        $add_surname = URI_get_string("add_surname");
        $add_email = URI_get_string("add_email");
        $add_phone = URI_get_string("add_phone");
        $add_passwd = URI_get_string("add_passwd");
        if( is_null( $add_passwd ) )
        {
          echo('Missing password !!!');
          exit;        
        }

        $add_passwd2 = URI_get_string("add_passwd2");

        if( $add_passwd != $add_passwd2 )
        {
          echo('Passwords are not same !!!');
          exit;        
        }

        $add_rights = URI_get_int("add_rights");

        if( is_null($add_rights) )
        {	
          echo('Missing or incorrect rights !!!');
          exit;
        }

        if( !is_superadmin() && ( $add_rights == "0" ))
        {
          echo('You are not allowed to create superadmin account !!!');
          exit;          
        }

        $can_edit_device = is_null(URI_get_int("can_edit_device")) ? 0 : 1;

        if( is_superadmin() )
        { // vezmeme id z formulare
          if( $add_rights == "0")
          { // superadmin nepatri pod konkretni firmu
            $company_id = 0;
          }
          else
          {
            $company_id = URI_get_int("company_id");
          }
        }
        else
        {  // vezmeme id ze session
          $company_id = get_company_id();
        }

        $sql = 'INSERT INTO users ( username, password, company_id, name, surname, email, phone, rights, edit_device ) 
          VALUES ("'.$add_username.'",
            PASSWORD("'.$add_passwd.'"),
            "'.$company_id.'",
            '.Str4Sql($add_name).',            
            '.Str4Sql($add_surname).',
            '.Str4Sql($add_email).',
            '.Str4Sql($add_phone).',
            "'.$add_rights.'",
            "'.$can_edit_device.'")';

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        $sql = 'SELECT LAST_INSERT_ID()';
				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        list($user_id) = mysqli_fetch_row( $result );

        /***************************** pristup ke skupinam routru ***************************/

        $group_count = URI_get_int("group_count");
        if( is_null( $group_count ) || ($group_count <= 0) )
        {
          echo('Missing or incorrect group_count !!!');
          exit;          
        }        

        $groups = array();        
        for( $i = 0;$i < $group_count;$i++ )
        { // pres vsechny skupiny

          $group_id = URI_get_int("group_".$i);
          if( !is_null( $group_id ) )
          {
            $allowed = 1;

            if( $add_rights != 0 )
            { // neni to superadmin => je omezen pouze na svou company
              $sql = 'SELECT *
                      FROM groups
                      WHERE group_id = "'.$group_id.'"
                      AND company_id = "'.$company_id.'"';
              $result = db_query($link, $sql);
              if( mysqli_num_rows( $result ) == 0 )
              { // nenalezena prislusna group, takze ji nesuperadminovi nepovolime
                $allowed = 0;              
              }
            }

            if( ($add_rights == 2) && is_null( URI_get_int("sel_".$i) ))
            { // guest, ktery nema neco zaskrtnuto to nedostane, ostani ano
              $allowed = 0;
            }

            if( $allowed == 1 )
            {
              $sql = 'INSERT INTO user_group SET
                user_id = "'.$user_id.'",       
                group_id = "'.$group_id.'",       
                status_email = "'.URI_get_bool("status_email_".$i).'",
                status_sms = "'.URI_get_bool("status_sms_".$i).'",              
                traffic_email = "'.URI_get_bool("traffic_email_".$i).'",
                traffic_sms = "'.URI_get_bool("traffic_sms_".$i).'",              
                level_email = "'.URI_get_bool("level_email_".$i).'",
                level_sms = "'.URI_get_bool("level_sms_".$i).'",
                qual_email = "'.URI_get_bool("qual_email_".$i).'",
                qual_sms = "'.URI_get_bool("qual_sms_".$i).'",
                temp_email = "'.URI_get_bool("temp_email_".$i).'",
                temp_sms = "'.URI_get_bool("temp_sms_".$i).'",
                volt_email = "'.URI_get_bool("volt_email_".$i).'",
                volt_sms = "'.URI_get_bool("volt_sms_".$i).'",
                trap_poll_email = "'.URI_get_bool("trap_poll_email_".$i).'",
                trap_poll_sms = "'.URI_get_bool("trap_poll_sms_".$i).'",
                space_email = "'.URI_get_bool("space_email_".$i).'",
                space_sms = "'.URI_get_bool("space_sms_".$i).'"
                ON DUPLICATE KEY UPDATE
                status_email = "'.URI_get_bool("status_email_".$i).'",
                status_sms = "'.URI_get_bool("status_sms_".$i).'",
                traffic_email = "'.URI_get_bool("traffic_email_".$i).'",
                traffic_sms = "'.URI_get_bool("traffic_sms_".$i).'",
                level_email = "'.URI_get_bool("level_email_".$i).'",
                level_sms = "'.URI_get_bool("level_sms_".$i).'",
                qual_email = "'.URI_get_bool("qual_email_".$i).'",
                qual_sms = "'.URI_get_bool("qual_sms_".$i).'",
                temp_email = "'.URI_get_bool("temp_email_".$i).'",
                temp_sms = "'.URI_get_bool("temp_sms_".$i).'",
                volt_email = "'.URI_get_bool("volt_email_".$i).'",
                volt_sms = "'.URI_get_bool("volt_sms_".$i).'",
                trap_poll_email = "'.URI_get_bool("trap_poll_email_".$i).'",
                trap_poll_sms = "'.URI_get_bool("trap_poll_sms_".$i).'",
                space_email = "'.URI_get_bool("space_email_".$i).'",
                space_sms = "'.URI_get_bool("space_sms_".$i).'"';

      				// vykonani SQL prikazu
  		    		$result = db_query($link, $sql);
            }
          }
        }

        /***************************** defaultni hodnoty pro noveho uzivatele ***************************/
        // resim pomoci triggeru

        echo('User was added succesfully.');
        log_event(get_company_id(),'User '.$add_name.' was added');        
        break;
      }

      case "edit":  // upravit uzivatele
      {

        $user_id = URI_get_int("user_id");
        if( is_null($user_id) )
        { // spatne user_id
          echo('Missing or incorrect user id !!!');
          exit;          
        }

        $add_username = URI_get_string("add_username");
        if( is_null($add_username) )
        {	// chybi username
          echo('Missing username !!!');
          exit;
        }

        $add_name = URI_get_string("add_name");
        $add_surname = URI_get_string("add_surname");
        $add_email = URI_get_string("add_email");
        $add_phone = URI_get_string("add_phone");
        $add_old_passwd = URI_get_string("add_old_passwd");
        $add_passwd = URI_get_string("add_passwd");
        $add_passwd2 = URI_get_string("add_passwd2");

        if( !is_null($add_old_passwd) ||  !is_null($add_passwd) || !is_null($add_passwd2) )
        {  // budeme menit heslo

          if( is_null( $add_old_passwd ) )
          {
            echo('Missing old password !!!');
            exit;        
          }

          // kontrola stareho hesla
          $sql = 'SELECT * 
                  FROM users
                  WHERE user_id = "'.$user_id.'" AND password = PASSWORD("'.$add_old_passwd.'")';
          
          $result = db_query($link, $sql);

          if( !mysqli_num_rows( $result ) )
          {
            echo('Bad or old password !!!');
            exit;                  
          }

          if( is_null( $add_passwd ) )
          {
            echo('Missing password !!!');
            exit;        
          }

          if( $add_passwd != $add_passwd2 )
          {
            echo('Passwords are not same !!!');
            exit;        
          }
        }

        $add_rights = URI_get_int("add_rights");

        if( is_null($add_rights) )
        {	
          echo('Missing or incorrect rights !!!');
          exit;
        }

        $can_edit_device = is_null(URI_get_int("can_edit_device")) ? 0 : 1;

        if( !is_superadmin() && ( $add_rights == "0" ))
        {
          echo('You are not allowed to create superadmin account !!!');
          exit;          
        }


        $sql = 'UPDATE users
                SET
                username = "'.$add_username.'",';
        if( !is_null( $add_passwd ) )
        { // budeme menit heslo
          $sql =  $sql.'password = PASSWORD("'.$add_passwd.'"),';                
        }
        $sql =  $sql.'name = '.Str4Sql($add_name).',
                surname = '.Str4Sql($add_surname).',
                email = '.Str4Sql($add_email).',
                phone = '.Str4Sql($add_phone).',                
                rights = "'.$add_rights.'",
                edit_device = "'.$can_edit_device.'"
                WHERE user_id = "'.$user_id.'"';

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        // uprava tabulky user_group

        $group_count = URI_get_int("group_count");
        if( is_null( $group_count ) || ($group_count <= 0) )
        {
          echo('Missing or incorrect group_count !!!');
          exit;          
        }        

        $groups = array();        
        for( $i = 0;$i < $group_count;$i++ )
        { // pres vsechny skupiny

          $group_id = URI_get_int("group_".$i);
          if( !is_null( $group_id ) )
          {
            $groups[] = $group_id; 

            $sql = 'INSERT INTO user_group SET
              user_id = "'.$user_id.'",       
              group_id = "'.$group_id.'",       
              status_email = "'.URI_get_bool("status_email_".$i).'",
              status_sms = "'.URI_get_bool("status_sms_".$i).'",              
              traffic_email = "'.URI_get_bool("traffic_email_".$i).'",
              traffic_sms = "'.URI_get_bool("traffic_sms_".$i).'",              
              level_email = "'.URI_get_bool("level_email_".$i).'",
              level_sms = "'.URI_get_bool("level_sms_".$i).'",
              qual_email = "'.URI_get_bool("qual_email_".$i).'",
              qual_sms = "'.URI_get_bool("qual_sms_".$i).'",
              temp_email = "'.URI_get_bool("temp_email_".$i).'",
              temp_sms = "'.URI_get_bool("temp_sms_".$i).'",
              volt_email = "'.URI_get_bool("volt_email_".$i).'",
              volt_sms = "'.URI_get_bool("volt_sms_".$i).'",              
              trap_poll_email = "'.URI_get_bool("trap_poll_email_".$i).'",
              trap_poll_sms = "'.URI_get_bool("trap_poll_sms_".$i).'",
              space_email = "'.URI_get_bool("space_email_".$i).'",
              space_sms = "'.URI_get_bool("space_sms_".$i).'"
              ON DUPLICATE KEY UPDATE              
              status_email = "'.URI_get_bool("status_email_".$i).'",
              status_sms = "'.URI_get_bool("status_sms_".$i).'",              
              traffic_email = "'.URI_get_bool("traffic_email_".$i).'",
              traffic_sms = "'.URI_get_bool("traffic_sms_".$i).'",              
              level_email = "'.URI_get_bool("level_email_".$i).'",
              level_sms = "'.URI_get_bool("level_sms_".$i).'",
              qual_email = "'.URI_get_bool("qual_email_".$i).'",
              qual_sms = "'.URI_get_bool("qual_sms_".$i).'",
              temp_email = "'.URI_get_bool("temp_email_".$i).'",
              temp_sms = "'.URI_get_bool("temp_sms_".$i).'",
              volt_email = "'.URI_get_bool("volt_email_".$i).'",
              volt_sms = "'.URI_get_bool("volt_sms_".$i).'",                            
              trap_poll_email = "'.URI_get_bool("trap_poll_email_".$i).'",
              trap_poll_sms = "'.URI_get_bool("trap_poll_sms_".$i).'",
              space_email = "'.URI_get_bool("space_email_".$i).'",
              space_sms = "'.URI_get_bool("space_sms_".$i).'"';

    				// vykonani SQL prikazu
		    		$result = db_query($link, $sql);

          }

        }

        if( count( $groups ) )
        { // zmazeme vsechny nepovolene
          $sql = 'DELETE FROM user_group
                  WHERE user_id = "'.$user_id.'" AND group_id NOT IN('.implode($groups,',').')';
        }
        else
        { // zadna povolena skupina => mazeme vse
          $sql = 'DELETE FROM user_group
                  WHERE user_id = "'.$user_id.'"';        
        }

				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        echo('User was changed succesfully.');
        log_event(get_company_id(),'User '.$add_name.' was changed');        
        break;  
      }

      case "remove":  // odstranit uzivatele
      {

        $user_id = URI_get_int("user_id");

        if( is_null( $user_id ) )
        { // spatne user_id
          echo('Missing or incorrect user id !!!');
          exit;          
        }

        if( !is_superadmin() )
        { // zkotrolujeme vlastnika
          $sql = 'SELECT *
                  FROM users
                  WHERE user_id = "'.$user_id.'" AND company_id = "'.get_company_id().'"';

				  // vykonani SQL prikazu
          $result = db_query($link, $sql);

          if( !mysqli_num_rows( $result ) )
          {
            echo( 'You are not allowed remove this user account!!!' );
            exit;
          }

        }

        $sql = 'SELECT username
                FROM users
                WHERE user_id = "'.$user_id.'"';
				// vykonani SQL prikazu
				$result = db_query($link, $sql);
        list($user_name) = mysqli_fetch_row( $result );

        // smazani uzivatele
        $sql = 'DELETE FROM users
                WHERE user_id = "'.$user_id.'"';
                
				// vykonani SQL prikazu
				$result = db_query($link, $sql);

        // nektere veci se resi pomoci triggeru ... 

        echo('User was removed succesfully.');
        log_event(get_company_id(),'User '.$user_name.' was removed');        
        break;  
      }

    default:{   // neznama akce
      echo('User Change Error: Unknow operation');
      break;
    }      
        
  }

?>
	            </td>
            </tr>
<?php
	// pripojeni paticky
  include ("php/bottom.php");

?>
